/* GANG Software
 * BASE/eval/Parser.H
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by parse++


#ifndef eval_Parser_INCLUDED
#define eval_Parser_INCLUDED

#include "Node.H"
#include "Lexer.H"

#if !defined(DISABLE_EVAL_NAMESPACE)
namespace eval {
#endif

class Parser
  :
  public Lexer
{

public:
  Parser();
  virtual ~Parser();

private:

  public:
  void parsex();
  EvalNode *parser_node_p;
protected:
  void parse_nop( LvalStruct &a, LvalStruct const &x );
  void parse_unary_op( LvalStruct &a, tokens op,
                       LvalStruct const &x );
  void parse_binary_op( LvalStruct &a, tokens op,
                        LvalStruct const &x,
                        LvalStruct const &y);
  void parse_unary_fn( LvalStruct &a, LvalStruct &f,
                       LvalStruct const &x );
  void parse_binary_fn( LvalStruct &a, LvalStruct &f,
                        LvalStruct const &x,
                        LvalStruct const &y );
  void parse_identifier( LvalStruct &a, LvalStruct &x );
  void parse_number( LvalStruct &a, LvalStruct &x );
  void error( char const *message );

protected:

  int parse();

private:

  static int const FINAL;
  static int const FLAG;
  static int const NTBASE;
  static int const LAST;
  static int const EMPTY;
  static int const EOF_;
  static int const TERROR;
  static int const ERRCODE;
  static int const INITDEPTH;
  static size_t const MAXDEPTH;
  static UCHAR const translate[];
  static short const r1[];
  static short const r2[];
  static short const defact[];
  static short const defgoto[];
  static short const pact[];
  static short const pgoto[];
  static short const table[];
  static short const check[];
  int TRANSLATE( int x)
    { return x <= 272 ? translate[x] : 25; }

  // disabled
  Parser( Parser const & );
  // disabled
  Parser &operator=( Parser const & );


};

#if !defined(DISABLE_EVAL_NAMESPACE)
} // namespace eval
#endif

#endif // eval_Parser_INCLUDED

