/* GANG Software
 * GEOM/geomui/gtk/Build_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Build_.H"

namespace geomui {
namespace gtk {


Build_::
Build_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::Table( 3, 1, false );
  _main_widget_w->show();

  // reflect_plane_reset
  _reflect_plane_reset_w = new ::gtk::widget0::ButtonCb<Build_>(
    "reset", this, &Build_::reflect_plane_reset_cb );
  _reflect_plane_reset_w->show();
  _main_widget_w->add( _reflect_plane_reset_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _reflect_plane_reset_w,
    "Undo all reflections" );

  // frame6
  _frame6_w = new ::gtk::widget0::Frame( "reflect in a coordinate plane" );
  _frame6_w->show();
  _main_widget_w->add( _frame6_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // hbox2
  _hbox2_w = new ::gtk::widget0::HBox( false, 0 );
  _hbox2_w->show();
  _frame6_w->add( _hbox2_w );

  // reflect_coord_plane0
  _reflect_coord_plane0_w = new ::gtk::widget0::ButtonCb<Build_>(
    "X", this, &Build_::reflect_coord_plane0_cb );
  _reflect_coord_plane0_w->show();
  _hbox2_w->add( _reflect_coord_plane0_w, true, true, 0 );
  set_tooltip( _reflect_coord_plane0_w,
    "Build the surface by reflection in the yz-plane" );

  // reflect_coord_plane1
  _reflect_coord_plane1_w = new ::gtk::widget0::ButtonCb<Build_>(
    "Y", this, &Build_::reflect_coord_plane1_cb );
  _reflect_coord_plane1_w->show();
  _hbox2_w->add( _reflect_coord_plane1_w, true, true, 0 );
  set_tooltip( _reflect_coord_plane1_w,
    "Build the surface by reflection in the xz-plane" );

  // reflect_coord_plane2
  _reflect_coord_plane2_w = new ::gtk::widget0::ButtonCb<Build_>(
    "Z", this, &Build_::reflect_coord_plane2_cb );
  _reflect_coord_plane2_w->show();
  _hbox2_w->add( _reflect_coord_plane2_w, true, true, 0 );
  set_tooltip( _reflect_coord_plane2_w,
    "Build the surface by reflection in the xy-plane" );

  // frame1
  _frame1_w = new ::gtk::widget0::Frame( "reflect in an arbitrary plane" );
  _frame1_w->show();
  _main_widget_w->add( _frame1_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_FILL), 0, 0 );

  // vbox32
  _vbox32_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox32_w->show();
  _frame1_w->add( _vbox32_w );

  // reflect_plane_position
  numberwidget_config const reflect_plane_position_param[] = {
    { "a", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0.0 },
    { "b", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0.0 },
    { "c", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 1.0 },
    { "d", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0.0 } };

  _reflect_plane_position_w = new ::gtk::widget1::NumberWidget2Float(
    "reflection plane", reflect_plane_position_param, 4 );

  _reflect_plane_position_w->show();
  _vbox32_w->add( _reflect_plane_position_w, false, true, 0 );
  set_tooltip( _reflect_plane_position_w,
    "Set a in the reflection plane ax+by+cz+d=0" );

  // hbox3
  _hbox3_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox3_w->show();
  _vbox32_w->add( _hbox3_w, true, true, 0 );

  // reflect_plane_apply
  _reflect_plane_apply_w = new ::gtk::widget0::ButtonCb<Build_>(
    "apply", this, &Build_::reflect_plane_apply_cb );
  _reflect_plane_apply_w->show();
  _hbox3_w->add( _reflect_plane_apply_w, false, true, 0 );
  set_tooltip( _reflect_plane_apply_w,
    "Apply a reflection in an arbitrary coordinate plane" );


}

Build_::
~Build_()
{
  delete _reflect_plane_apply_w;
  delete _hbox3_w;
  delete _reflect_plane_position_w;
  delete _vbox32_w;
  delete _frame1_w;
  delete _reflect_coord_plane2_w;
  delete _reflect_coord_plane1_w;
  delete _reflect_coord_plane0_w;
  delete _hbox2_w;
  delete _frame6_w;
  delete _reflect_plane_reset_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace geomui

