/* GANG Software
 * GEOM/geomui/gtk/CustomColor_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "CustomColor_.H"

namespace geomui {
namespace gtk {


CustomColor_::
CustomColor_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::VBox( false, 0 );
  _main_widget_w->show();

  // color_choice
  _color_choice_w = new ::gtk::widget1::PopNotebookCb<CustomColor_>(
    this, &CustomColor_::color_choice_cb );
  _color_choice_w->set_tab_pos( GTK_POS_RIGHT );
  _color_choice_w->set_title( "iSight | Custom Color" );
  _color_choice_w->set_blocked( 0 );
  _color_choice_w->show();
  _main_widget_w->add( _color_choice_w, true, true, 0 );
  set_tooltip( _color_choice_w,
    "Color the surface" );

  // table1
  _table1_w = new ::gtk::widget0::Table( 2, 1, false );
  _table1_w->show();
  _color_choice_w->add_blocked( _table1_w );

  // color0
  base::Color4 const color0_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color0_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color0_param, this,
    &CustomColor_::color0_cb );

  _color0_w->show();
  _table1_w->add( _color0_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color0_w,
    "Color surface by a modification of the original color" );

  // color_reset0
  _color_reset0_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset0_cb );
  _color_reset0_w->show();
  _table1_w->add( _color_reset0_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset0_w,
    "Reset the color settings" );

  // tab0
  _tab0_w = new ::gtk::widget0::Label( "original" );
  _tab0_w->set_alignment(0, 0.5);
  _tab0_w->show();
  _color_choice_w->add_label( _tab0_w );

  // table3
  _table3_w = new ::gtk::widget0::Table( 2, 1, false );
  _table3_w->show();
  _color_choice_w->add_blocked( _table3_w );

  // color1
  base::Color4 const color1_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color1_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color1_param, this,
    &CustomColor_::color1_cb );

  _color1_w->show();
  _table3_w->add( _color1_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color1_w,
    "Color surface by normal direction" );

  // color_reset1
  _color_reset1_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset1_cb );
  _color_reset1_w->show();
  _table3_w->add( _color_reset1_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset1_w,
    "Reset the color settings" );

  // tab1
  _tab1_w = new ::gtk::widget0::Label( "normal" );
  _tab1_w->set_alignment(0, 0.5);
  _tab1_w->show();
  _color_choice_w->add_label( _tab1_w );

  // table61
  _table61_w = new ::gtk::widget0::Table( 2, 1, false );
  _table61_w->show();
  _color_choice_w->add_blocked( _table61_w );

  // color_reset2
  _color_reset2_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset2_cb );
  _color_reset2_w->show();
  _table61_w->add( _color_reset2_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset2_w,
    "Reset the color settings" );

  // table68
  _table68_w = new ::gtk::widget0::Table( 2, 1, false );
  _table68_w->show();
  _table61_w->add( _table68_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0 );

  // color2
  base::Color4 const color2_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color2_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color2_param, this,
    &CustomColor_::color2_cb );

  _color2_w->show();
  _table68_w->add( _color2_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color2_w,
    "Color surface by Gaussian curvature" );

  // frame1
  _frame1_w = new ::gtk::widget0::Frame( "scale" );
  _frame1_w->show();
  _table68_w->add( _frame1_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)(GTK_FILL), 0, 0 );

  // scale2
  numberwidget_config const scale2_param = {
    "scale", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.5 };

  _scale2_w = new ::gtk::widget1::NumberWidgetFloatCb<CustomColor_>(
    &scale2_param, this, &CustomColor_::color2_cb );

  _scale2_w->show();
  _frame1_w->add( _scale2_w );
  set_tooltip( _scale2_w,
    "Scale the Gaussian curvature color" );

  // tab2
  _tab2_w = new ::gtk::widget0::Label( "gaussian" );
  _tab2_w->set_alignment(0, 0.5);
  _tab2_w->show();
  _color_choice_w->add_label( _tab2_w );

  // table67
  _table67_w = new ::gtk::widget0::Table( 2, 1, false );
  _table67_w->show();
  _color_choice_w->add_blocked( _table67_w );

  // color_reset3
  _color_reset3_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset3_cb );
  _color_reset3_w->show();
  _table67_w->add( _color_reset3_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset3_w,
    "Reset the color settings" );

  // table69
  _table69_w = new ::gtk::widget0::Table( 2, 1, false );
  _table69_w->show();
  _table67_w->add( _table69_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0 );

  // color3
  base::Color4 const color3_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color3_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color3_param, this,
    &CustomColor_::color3_cb );

  _color3_w->show();
  _table69_w->add( _color3_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color3_w,
    "Color surface by mean curvature" );

  // frame4
  _frame4_w = new ::gtk::widget0::Frame( "scale" );
  _frame4_w->show();
  _table69_w->add( _frame4_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)(GTK_FILL), 0, 0 );

  // scale3
  numberwidget_config const scale3_param = {
    "scale", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.5 };

  _scale3_w = new ::gtk::widget1::NumberWidgetFloatCb<CustomColor_>(
    &scale3_param, this, &CustomColor_::color3_cb );

  _scale3_w->show();
  _frame4_w->add( _scale3_w );
  set_tooltip( _scale3_w,
    "Scale the mean curvature color" );

  // tab3
  _tab3_w = new ::gtk::widget0::Label( "mean" );
  _tab3_w->set_alignment(0, 0.5);
  _tab3_w->show();
  _color_choice_w->add_label( _tab3_w );

  // table66
  _table66_w = new ::gtk::widget0::Table( 2, 1, false );
  _table66_w->show();
  _color_choice_w->add_blocked( _table66_w );

  // color_reset4
  _color_reset4_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset4_cb );
  _color_reset4_w->show();
  _table66_w->add( _color_reset4_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset4_w,
    "Reset the color settings" );

  // table70
  _table70_w = new ::gtk::widget0::Table( 2, 1, false );
  _table70_w->show();
  _table66_w->add( _table70_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0 );

  // color4
  base::Color4 const color4_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color4_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color4_param, this,
    &CustomColor_::color4_cb );

  _color4_w->show();
  _table70_w->add( _color4_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color4_w,
    "Color surface by polygonal area" );

  // frame5
  _frame5_w = new ::gtk::widget0::Frame( "scale" );
  _frame5_w->show();
  _table70_w->add( _frame5_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)(GTK_FILL), 0, 0 );

  // scale4
  numberwidget_config const scale4_param = {
    "scale", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.5 };

  _scale4_w = new ::gtk::widget1::NumberWidgetFloatCb<CustomColor_>(
    &scale4_param, this, &CustomColor_::color4_cb );

  _scale4_w->show();
  _frame5_w->add( _scale4_w );
  set_tooltip( _scale4_w,
    "Scale the area curvature color" );

  // tab4
  _tab4_w = new ::gtk::widget0::Label( "area" );
  _tab4_w->set_alignment(0, 0.5);
  _tab4_w->show();
  _color_choice_w->add_label( _tab4_w );

  // table65
  _table65_w = new ::gtk::widget0::Table( 2, 1, false );
  _table65_w->show();
  _color_choice_w->add_blocked( _table65_w );

  // color5
  base::Color4 const color5_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color5_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color5_param, this,
    &CustomColor_::color5_cb );

  _color5_w->show();
  _table65_w->add( _color5_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color5_w,
    "Color surface by direction from the origin" );

  // color_reset5
  _color_reset5_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset5_cb );
  _color_reset5_w->show();
  _table65_w->add( _color_reset5_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset5_w,
    "Reset the color settings" );

  // tab5
  _tab5_w = new ::gtk::widget0::Label( "direction" );
  _tab5_w->set_alignment(0, 0.5);
  _tab5_w->show();
  _color_choice_w->add_label( _tab5_w );

  // table64
  _table64_w = new ::gtk::widget0::Table( 2, 1, false );
  _table64_w->show();
  _color_choice_w->add_blocked( _table64_w );

  // color_reset6
  _color_reset6_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset6_cb );
  _color_reset6_w->show();
  _table64_w->add( _color_reset6_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset6_w,
    "Reset the color settings" );

  // table71
  _table71_w = new ::gtk::widget0::Table( 2, 1, false );
  _table71_w->show();
  _table64_w->add( _table71_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0 );

  // color6
  base::Color4 const color6_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color6_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color6_param, this,
    &CustomColor_::color6_cb );

  _color6_w->show();
  _table71_w->add( _color6_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color6_w,
    "Color surface by distance from the origin" );

  // frame6
  _frame6_w = new ::gtk::widget0::Frame( "scale" );
  _frame6_w->show();
  _table71_w->add( _frame6_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)(GTK_FILL), 0, 0 );

  // scale6
  numberwidget_config const scale6_param = {
    "scale", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.5 };

  _scale6_w = new ::gtk::widget1::NumberWidgetFloatCb<CustomColor_>(
    &scale6_param, this, &CustomColor_::color6_cb );

  _scale6_w->show();
  _frame6_w->add( _scale6_w );
  set_tooltip( _scale6_w,
    "Scale the distance color" );

  // tab6
  _tab6_w = new ::gtk::widget0::Label( "distance" );
  _tab6_w->set_alignment(0, 0.5);
  _tab6_w->show();
  _color_choice_w->add_label( _tab6_w );

  // table63
  _table63_w = new ::gtk::widget0::Table( 2, 1, false );
  _table63_w->show();
  _color_choice_w->add_blocked( _table63_w );

  // color7
  base::Color4 const color7_param( 0.5f, 0.25f, 0.25f, 0.5f );
  _color7_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color", color7_param, this,
    &CustomColor_::color7_cb );

  _color7_w->show();
  _table63_w->add( _color7_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color7_w,
    "Color surface polygons with random colors" );

  // color_reset7
  _color_reset7_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset7_cb );
  _color_reset7_w->show();
  _table63_w->add( _color_reset7_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset7_w,
    "Reset the color settings" );

  // tab7
  _tab7_w = new ::gtk::widget0::Label( "random" );
  _tab7_w->set_alignment(0, 0.5);
  _tab7_w->show();
  _color_choice_w->add_label( _tab7_w );

  // table62
  _table62_w = new ::gtk::widget0::Table( 3, 1, false );
  _table62_w->show();
  _color_choice_w->add_blocked( _table62_w );

  // color8a
  base::Color4 const color8a_param( 0.25f, 0.25f, 0.25f, 0.5f );
  _color8a_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color 1", color8a_param, this,
    &CustomColor_::color8_cb );

  _color8a_w->show();
  _table62_w->add( _color8a_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color8a_w,
    "Color surface in a checkerboard pattern" );

  // color8b
  base::Color4 const color8b_param( 0.75f, 0.75f, 0.75f, 0.5f );
  _color8b_w = new ::gtk::widget1::ColorCb<CustomColor_>(
    "color 2", color8b_param, this,
    &CustomColor_::color8_cb );

  _color8b_w->show();
  _table62_w->add( _color8b_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color8b_w,
    "Color surface in a checkerboard pattern" );

  // color_reset8
  _color_reset8_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset8_cb );
  _color_reset8_w->show();
  _table62_w->add( _color_reset8_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset8_w,
    "Reset the color settings" );

  // tab8
  _tab8_w = new ::gtk::widget0::Label( "checked" );
  _tab8_w->set_alignment(0, 0.5);
  _tab8_w->show();
  _color_choice_w->add_label( _tab8_w );

  // table4
  _table4_w = new ::gtk::widget0::Table( 2, 1, false );
  _table4_w->show();
  _color_choice_w->add_blocked( _table4_w );

  // color_reset9
  _color_reset9_w = new ::gtk::widget0::ButtonCb<CustomColor_>(
    "reset", this, &CustomColor_::color_reset9_cb );
  _color_reset9_w->show();
  _table4_w->add( _color_reset9_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_reset9_w,
    "Reset the alpha fade settings" );

  // color9
  numberwidget_config const color9_param[] = {
    { "near", 0.0, FLT_MAX, 0.001, 0.01, 0.1, 3, 1.0 },
    { "far", 0.0, FLT_MAX, 0.001, 0.01, 0.1, 3, 2.0 } };

  _color9_w = new ::gtk::widget1::NumberWidget2FloatCb<CustomColor_>(
    "alpha fade", color9_param, 2, this, &CustomColor_::color9_cb );

  _color9_w->show();
  _table4_w->add( _color9_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color9_w,
    "Surface fade scale factor" );

  // tab9
  _tab9_w = new ::gtk::widget0::Label( "fade" );
  _tab9_w->set_alignment(0, 0.5);
  _tab9_w->show();
  _color_choice_w->add_label( _tab9_w );


}

CustomColor_::
~CustomColor_()
{
  delete _tab9_w;
  delete _color9_w;
  delete _color_reset9_w;
  delete _table4_w;
  delete _tab8_w;
  delete _color_reset8_w;
  delete _color8b_w;
  delete _color8a_w;
  delete _table62_w;
  delete _tab7_w;
  delete _color_reset7_w;
  delete _color7_w;
  delete _table63_w;
  delete _tab6_w;
  delete _scale6_w;
  delete _frame6_w;
  delete _color6_w;
  delete _table71_w;
  delete _color_reset6_w;
  delete _table64_w;
  delete _tab5_w;
  delete _color_reset5_w;
  delete _color5_w;
  delete _table65_w;
  delete _tab4_w;
  delete _scale4_w;
  delete _frame5_w;
  delete _color4_w;
  delete _table70_w;
  delete _color_reset4_w;
  delete _table66_w;
  delete _tab3_w;
  delete _scale3_w;
  delete _frame4_w;
  delete _color3_w;
  delete _table69_w;
  delete _color_reset3_w;
  delete _table67_w;
  delete _tab2_w;
  delete _scale2_w;
  delete _frame1_w;
  delete _color2_w;
  delete _table68_w;
  delete _color_reset2_w;
  delete _table61_w;
  delete _tab1_w;
  delete _color_reset1_w;
  delete _color1_w;
  delete _table3_w;
  delete _tab0_w;
  delete _color_reset0_w;
  delete _color0_w;
  delete _table1_w;
  delete _color_choice_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace geomui

