/* GANG Software
 * GEOM/geomui/gtk/MaterialSet_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "MaterialSet_.H"

namespace geomui {
namespace gtk {


MaterialSet_::
MaterialSet_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // vbox38
  _vbox38_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox38_w->show();

  // frame15
  _frame15_w = new ::gtk::widget0::Frame( "Element" );
  _frame15_w->show();
  _vbox38_w->add( _frame15_w, false, false, 0 );

  // id
  char const *id_label[] = {
    "faces", "edges", "vertices", "faces2", "lines", "points", "boundary", "silhouette", "box" };

  _id_w = new ::gtk::widget1::ButtonBarCb<MaterialSet_>(
    0U, id_label, 3, 3, this, &MaterialSet_::id_cb );

  _id_w->show();
  _frame15_w->add( _id_w );
  set_tooltip( _id_w,
    "Choose what element to color" );

  // table3
  _table3_w = new ::gtk::widget0::Table( 2, 2, true );
  _table3_w->show();
  _vbox38_w->add( _table3_w, false, false, 0 );

  // reset
  _reset_w = new ::gtk::widget0::ButtonCb<MaterialSet_>(
    "reset", this, &MaterialSet_::reset_cb );
  _reset_w->show();
  _table3_w->add( _reset_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _reset_w,
    "Reset the materials attributes for this panel" );

  // enable
  _enable_w = new ::gtk::widget0::ToggleButtonCb<MaterialSet_>(
    "enable", 0, this, &MaterialSet_::enable_cb );
  _enable_w->show();
  _table3_w->add( _enable_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _enable_w,
    "Toggle the materials attributes on/off" );

  // shademodel
  _shademodel_w = new ::gtk::widget0::ToggleButtonCb<MaterialSet_>(
    "smooth", 0, this, &MaterialSet_::shademodel_cb );
  _shademodel_w->show();
  _table3_w->add( _shademodel_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _shademodel_w,
    "Toggle between sharp edges and smooth" );

  // transparent
  _transparent_w = new ::gtk::widget0::ToggleButtonCb<MaterialSet_>(
    "transparent", false, this, &MaterialSet_::transparent_cb );
  _transparent_w->show();
  _table3_w->add( _transparent_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _transparent_w,
    "Toggle transparency" );

  // notebook1
  _notebook1_w = new ::gtk::widget1::PopNotebook;
  _notebook1_w->set_tab_pos( GTK_POS_TOP );
  _notebook1_w->set_title( "iSight | Materials" );
  _notebook1_w->set( 0 );
  _notebook1_w->show();
  _vbox38_w->add( _notebook1_w, false, false, 0 );
  set_tooltip( _notebook1_w,
    "" );

  // vbox41
  _vbox41_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox41_w->show();
  _notebook1_w->add( _vbox41_w );

  // hbox22
  _hbox22_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox22_w->show();
  _vbox41_w->add( _hbox22_w, true, true, 0 );

  // custom_color
  _custom_color_w = new ::gtk::widget0::ToggleButtonCb<MaterialSet_>(
    "custom color", 0, this, &MaterialSet_::custom_color_cb );
  _custom_color_w->show();
  _hbox22_w->add( _custom_color_w, false, true, 0 );
  set_tooltip( _custom_color_w,
    "Get color from custom color widget" );

  // lit
  _lit_w = new ::gtk::widget0::ToggleButtonCb<MaterialSet_>(
    "lit", true, this, &MaterialSet_::lit_cb );
  _lit_w->show();
  _hbox22_w->add( _lit_w, false, true, 0 );
  set_tooltip( _lit_w,
    "Toggle the lights for this materials attribute" );

  // color
  base::Color4 const color_param( 1.0f, 1.0f, 1.0f, 1.0f );
  _color_w = new ::gtk::widget1::ColorCb<MaterialSet_>(
    "color", color_param, this,
    &MaterialSet_::color_cb );

  _color_w->show();
  _vbox41_w->add( _color_w, true, true, 0 );
  set_tooltip( _color_w,
    "Set color of material" );

  // hidebox
  _hidebox_w = new ::gtk::widget0::VBox( false, 0 );
  _hidebox_w->show();
  _vbox41_w->add( _hidebox_w, true, true, 0 );

  // frame13
  _frame13_w = new ::gtk::widget0::Frame( "model" );
  _frame13_w->show();
  _hidebox_w->add( _frame13_w, true, true, 0 );

  // model
  char const *model_labels[] =
    { "ambient", "diffuse", "ambient and diffuse", "specular", "emissive" };

  _model_w = new ::gtk::widget1::MenuButtonCb<MaterialSet_>(
    2, model_labels, 5, this, &MaterialSet_::model_cb );
  _model_w->show();
  _frame13_w->add( _model_w );
  set_tooltip( _model_w,
    "Select how to color the surface" );

  // hbox27
  _hbox27_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox27_w->show();
  _hidebox_w->add( _hbox27_w, true, true, 0 );

  // ambient
  base::Color3 const ambient_param( 0.0f, 0.0f, 0.0f );
  _ambient_w = new ::gtk::widget1::ColorCb<MaterialSet_>(
    "ambient", ambient_param, this,
    &MaterialSet_::ambient_cb );

  _ambient_w->show();
  _hbox27_w->add( _ambient_w, true, true, 0 );
  set_tooltip( _ambient_w,
    "Set ambient color of material" );

  // diffuse
  base::Color4 const diffuse_param( 0.0f, 0.0f, 0.0f, 1.0f );
  _diffuse_w = new ::gtk::widget1::ColorCb<MaterialSet_>(
    "diffuse", diffuse_param, this,
    &MaterialSet_::diffuse_cb );

  _diffuse_w->show();
  _hbox27_w->add( _diffuse_w, true, true, 0 );
  set_tooltip( _diffuse_w,
    "Set diffuse color of material" );

  // hbox28
  _hbox28_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox28_w->show();
  _hidebox_w->add( _hbox28_w, true, true, 0 );

  // specular
  base::Color3 const specular_param( 0.0f, 0.0f, 0.0f );
  _specular_w = new ::gtk::widget1::ColorCb<MaterialSet_>(
    "specular", specular_param, this,
    &MaterialSet_::specular_cb );

  _specular_w->show();
  _hbox28_w->add( _specular_w, true, true, 0 );
  set_tooltip( _specular_w,
    "Set specular color of material" );

  // emissive
  base::Color3 const emissive_param( 0.0f, 0.0f, 0.0f );
  _emissive_w = new ::gtk::widget1::ColorCb<MaterialSet_>(
    "emissive", emissive_param, this,
    &MaterialSet_::emissive_cb );

  _emissive_w->show();
  _hbox28_w->add( _emissive_w, true, true, 0 );
  set_tooltip( _emissive_w,
    "Set emissive color of material" );

  // hbox29
  _hbox29_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox29_w->show();
  _hidebox_w->add( _hbox29_w, true, true, 0 );

  // frame16
  _frame16_w = new ::gtk::widget0::Frame( "shininess" );
  _frame16_w->show();
  _hbox29_w->add( _frame16_w, true, true, 0 );

  // shininess
  numberwidget_config const shininess_param = {
    "", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.0 };

  _shininess_w = new ::gtk::widget1::NumberWidgetFloatCb<MaterialSet_>(
    &shininess_param, this, &MaterialSet_::shininess_cb );

  _shininess_w->show();
  _frame16_w->add( _shininess_w );
  set_tooltip( _shininess_w,
    "Set shininess of material" );

  // label1
  _label1_w = new ::gtk::widget0::Label( "color" );
  _label1_w->set_alignment(0.5, 0.5);
  _label1_w->show();
  _notebook1_w->add_label( _label1_w );

  // vbox40
  _vbox40_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox40_w->show();
  _notebook1_w->add( _vbox40_w );

  // hbox25
  _hbox25_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox25_w->show();
  _vbox40_w->add( _hbox25_w, false, false, 0 );

  // element_size
  numberwidget_config const element_size_param = {
    "size", -FLT_MAX, FLT_MAX, 0.001, 0.01, 0.1, 3, 0.0 };

  _element_size_w = new ::gtk::widget1::NumberWidgetFloatCb<MaterialSet_>(
    &element_size_param, this, &MaterialSet_::element_size_cb );

  _element_size_w->show();
  _hbox25_w->add( _element_size_w, false, true, 0 );
  set_tooltip( _element_size_w,
    "Set the face/edge/vertex size" );

  // gap
  numberwidget_config const gap_param[] = {
    { "outside", -FLT_MAX, FLT_MAX, 0.001, 0.01, 0.1, 3, 0.0 },
    { "inside", -FLT_MAX, FLT_MAX, 0.001, 0.01, 0.1, 3, 0.0 } };

  _gap_w = new ::gtk::widget1::NumberWidget2FloatCb<MaterialSet_>(
    "gap", gap_param, 2, this, &MaterialSet_::gap_cb );

  _gap_w->show();
  _hbox25_w->add( _gap_w, false, true, 0 );
  set_tooltip( _gap_w,
    "Set the gap at edge of faces" );

  // hbox26
  _hbox26_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox26_w->show();
  _vbox40_w->add( _hbox26_w, false, false, 0 );

  // frame11
  _frame11_w = new ::gtk::widget0::Frame( "sides" );
  _frame11_w->show();
  _hbox26_w->add( _frame11_w, true, true, 0 );

  // vbox8
  _vbox8_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox8_w->show();
  _frame11_w->add( _vbox8_w );

  // side0
  char const *side0_labels[] =
    { "none", "point", "line", "fill" };

  _side0_w = new ::gtk::widget1::MenuButtonCb<MaterialSet_>(
    0, side0_labels, 4, this, &MaterialSet_::side_cb );
  _side0_w->show();
  _vbox8_w->add( _side0_w, false, false, 0 );
  set_tooltip( _side0_w,
    "Select whether to show polygons, edges of vertices of the surface (side A)" );

  // side1
  char const *side1_labels[] =
    { "none", "point", "line", "fill" };

  _side1_w = new ::gtk::widget1::MenuButtonCb<MaterialSet_>(
    0, side1_labels, 4, this, &MaterialSet_::side_cb );
  _side1_w->show();
  _vbox8_w->add( _side1_w, false, false, 0 );
  set_tooltip( _side1_w,
    "Select whether to show polygons, edges of vertices of the surface (side B)" );

  // nudge
  numberwidget_config const nudge_param[] = {
    { "factor", -FLT_MAX, FLT_MAX, 0.001, 0.01, 0.1, 3, 0.0 },
    { "unit", -FLT_MAX, FLT_MAX, 0.001, 0.01, 0.1, 3, 0.0 } };

  _nudge_w = new ::gtk::widget1::NumberWidget2FloatCb<MaterialSet_>(
    "nudge", nudge_param, 2, this, &MaterialSet_::nudge_cb );

  _nudge_w->show();
  _hbox26_w->add( _nudge_w, false, true, 0 );
  set_tooltip( _nudge_w,
    "Set the camera nudge factor" );

  // label2
  _label2_w = new ::gtk::widget0::Label( "attributes" );
  _label2_w->set_alignment(0.5, 0.5);
  _label2_w->show();
  _notebook1_w->add_label( _label2_w );


}

MaterialSet_::
~MaterialSet_()
{
  delete _label2_w;
  delete _nudge_w;
  delete _side1_w;
  delete _side0_w;
  delete _vbox8_w;
  delete _frame11_w;
  delete _hbox26_w;
  delete _gap_w;
  delete _element_size_w;
  delete _hbox25_w;
  delete _vbox40_w;
  delete _label1_w;
  delete _shininess_w;
  delete _frame16_w;
  delete _hbox29_w;
  delete _emissive_w;
  delete _specular_w;
  delete _hbox28_w;
  delete _diffuse_w;
  delete _ambient_w;
  delete _hbox27_w;
  delete _model_w;
  delete _frame13_w;
  delete _hidebox_w;
  delete _color_w;
  delete _lit_w;
  delete _custom_color_w;
  delete _hbox22_w;
  delete _vbox41_w;
  delete _notebook1_w;
  delete _transparent_w;
  delete _shademodel_w;
  delete _enable_w;
  delete _reset_w;
  delete _table3_w;
  delete _id_w;
  delete _frame15_w;
  delete _vbox38_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace geomui

