/* GANG Software
 * GEOM/milieu/gtk/Background_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Background_.H"

namespace milieu {
namespace gtk {


Background_::
Background_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::Table( 3, 1, false );
  _main_widget_w->show();

  // color
  float color_param[] = { 0.0f, 0.0f, 0.0f };
  _color_w = new ::gtk::widget0::ColorSelectionCb<Background_>(
    color_param, this, &Background_::color_cb );

  _color_w->show();
  _main_widget_w->add( _color_w, 0, 1, 1, 2,
    (GtkAttachOptions)0,
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _color_w,
    "Select background color" );

  // reset
  _reset_w = new ::gtk::widget0::ButtonCb<Background_>(
    "reset", this, &Background_::reset_cb );
  _reset_w->show();
  _main_widget_w->add( _reset_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _reset_w,
    "Reset the background color of the viewer window" );

  // hbox1
  _hbox1_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox1_w->show();
  _main_widget_w->add( _hbox1_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // bgcolor0
  _bgcolor0_w = new ::gtk::widget0::ButtonCb<Background_>(
    "black", this, &Background_::bgcolor0_cb );
  _bgcolor0_w->show();
  _hbox1_w->add( _bgcolor0_w, true, true, 0 );
  set_tooltip( _bgcolor0_w,
    "Set the background color of the viewer window to black" );

  // bgcolor1
  _bgcolor1_w = new ::gtk::widget0::ButtonCb<Background_>(
    "gray35", this, &Background_::bgcolor1_cb );
  _bgcolor1_w->show();
  _hbox1_w->add( _bgcolor1_w, true, true, 0 );
  set_tooltip( _bgcolor1_w,
    "Set the background color of the viewer window to dark gray" );

  // bgcolor2
  _bgcolor2_w = new ::gtk::widget0::ButtonCb<Background_>(
    "gray70", this, &Background_::bgcolor2_cb );
  _bgcolor2_w->show();
  _hbox1_w->add( _bgcolor2_w, true, true, 0 );
  set_tooltip( _bgcolor2_w,
    "Set the background color of the viewer window to light gray" );

  // bgcolor3
  _bgcolor3_w = new ::gtk::widget0::ButtonCb<Background_>(
    "white", this, &Background_::bgcolor3_cb );
  _bgcolor3_w->show();
  _hbox1_w->add( _bgcolor3_w, true, true, 0 );
  set_tooltip( _bgcolor3_w,
    "Set the background color of the viewer window to white" );

  // image
  _image_w = new ::gtk::widget0::ButtonCb<Background_>(
    "image", this, &Background_::image_cb );
  _image_w->show();
  _hbox1_w->add( _image_w, true, true, 0 );
  set_tooltip( _image_w,
    "Choose a background image file" );


}

Background_::
~Background_()
{
  delete _image_w;
  delete _bgcolor3_w;
  delete _bgcolor2_w;
  delete _bgcolor1_w;
  delete _bgcolor0_w;
  delete _hbox1_w;
  delete _reset_w;
  delete _color_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace milieu

