/* GANG Software
 * GEOM/milieu/gtk/Blend_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Blend_.H"

namespace milieu {
namespace gtk {


Blend_::
Blend_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget1::PopNotebook;
  _main_widget_w->set_tab_pos( GTK_POS_TOP );
  _main_widget_w->set_title( "iSight | Blend" );
  _main_widget_w->set( 0 );
  _main_widget_w->show();
  set_tooltip( _main_widget_w,
    "Blend" );

  // vbox37
  _vbox37_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox37_w->show();
  _main_widget_w->add( _vbox37_w );

  // hbox18
  _hbox18_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox18_w->show();
  _vbox37_w->add( _hbox18_w, false, false, 0 );

  // depth_enable
  _depth_enable_w = new ::gtk::widget0::ToggleButtonCb<Blend_>(
    "enable", true, this, &Blend_::depth_enable_cb );
  _depth_enable_w->show();
  _hbox18_w->add( _depth_enable_w, true, true, 0 );
  set_tooltip( _depth_enable_w,
    "Enable depth buffering" );

  // depth_reset
  _depth_reset_w = new ::gtk::widget0::ButtonCb<Blend_>(
    "reset", this, &Blend_::depth_reset_cb );
  _depth_reset_w->show();
  _hbox18_w->add( _depth_reset_w, true, true, 0 );
  set_tooltip( _depth_reset_w,
    "Reset depth buffering" );

  // table97
  _table97_w = new ::gtk::widget0::Table( 2, 2, false );
  _table97_w->show();
  _vbox37_w->add( _table97_w, true, true, 0 );

  // depth_function
  char const *depth_function_labels[] =
    { "never", "always", "<", "<=", "=", ">=", ">", "!=" };

  _depth_function_w = new ::gtk::widget1::MenuButtonCb<Blend_>(
    2, depth_function_labels, 8, this, &Blend_::depth_function_cb );
  _depth_function_w->show();
  _table97_w->add( _depth_function_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _depth_function_w,
    "Select a depth function" );

  // depth_mask
  char const *depth_mask_labels[] =
    { "read-only", "read/write" };

  _depth_mask_w = new ::gtk::widget1::MenuButtonCb<Blend_>(
    1, depth_mask_labels, 2, this, &Blend_::depth_mask_cb );
  _depth_mask_w->show();
  _table97_w->add( _depth_mask_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _depth_mask_w,
    "Set the depth mask" );

  // label940
  _label940_w = new ::gtk::widget0::Label( "depth test fn" );
  _label940_w->set_alignment(0, 0.5);
  _label940_w->show();
  _table97_w->add( _label940_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label978
  _label978_w = new ::gtk::widget0::Label( "depth mask" );
  _label978_w->set_alignment(0, 0.5);
  _label978_w->show();
  _table97_w->add( _label978_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label979
  _label979_w = new ::gtk::widget0::Label( "Depth" );
  _label979_w->set_alignment(0, 0.5);
  _label979_w->show();
  _main_widget_w->add_label( _label979_w );

  // vbox38
  _vbox38_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox38_w->show();
  _main_widget_w->add( _vbox38_w );

  // hbox19
  _hbox19_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox19_w->show();
  _vbox38_w->add( _hbox19_w, false, false, 0 );

  // blend_enable
  _blend_enable_w = new ::gtk::widget0::ToggleButtonCb<Blend_>(
    "enable", false, this, &Blend_::blend_enable_cb );
  _blend_enable_w->show();
  _hbox19_w->add( _blend_enable_w, true, true, 0 );
  set_tooltip( _blend_enable_w,
    "Enable blending" );

  // blend_reset
  _blend_reset_w = new ::gtk::widget0::ButtonCb<Blend_>(
    "reset", this, &Blend_::blend_reset_cb );
  _blend_reset_w->show();
  _hbox19_w->add( _blend_reset_w, true, true, 0 );
  set_tooltip( _blend_reset_w,
    "Reset blending" );

  // table48
  _table48_w = new ::gtk::widget0::Table( 4, 2, false );
  _table48_w->show();
  _vbox38_w->add( _table48_w, true, true, 0 );

  // blend_dest_function
  char const *blend_dest_function_labels[] =
    { "zero", "one", "dst color", "one minus dst color", "src alpha saturate", "src alpha", "one minus src alpha", "dst alpha ", "one minus dst alpha", "constant color ext", "one minus constant color ext", "constant alpha ext", "one minus constant alpha ext" };

  _blend_dest_function_w = new ::gtk::widget1::MenuButtonCb<Blend_>(
    6, blend_dest_function_labels, 13, this, &Blend_::blend_dest_function_cb );
  _blend_dest_function_w->show();
  _table48_w->add( _blend_dest_function_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _blend_dest_function_w,
    "Set the blend destination function" );

  // label938
  _label938_w = new ::gtk::widget0::Label( "source blend fn" );
  _label938_w->set_alignment(0, 0.5);
  _label938_w->show();
  _table48_w->add( _label938_w, 0, 1, 0, 1,
    (GtkAttachOptions)0,
    (GtkAttachOptions)0, 0, 0 );

  // blend_src_function
  char const *blend_src_function_labels[] =
    { "zero", "one", "src color", "one minus src color", "src alpha", "one minus src alpha", "dst alpha", "one minus dst alpha", "constant color ext", "one minus constant color ext", "constant alpha ext", "one minus constant alpha ext" };

  _blend_src_function_w = new ::gtk::widget1::MenuButtonCb<Blend_>(
    4, blend_src_function_labels, 12, this, &Blend_::blend_src_function_cb );
  _blend_src_function_w->show();
  _table48_w->add( _blend_src_function_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _blend_src_function_w,
    "Set the blend source function" );

  // antialias_point
  _antialias_point_w = new ::gtk::widget0::ToggleButtonCb<Blend_>(
    "enable", false, this, &Blend_::antialias_point_cb );
  _antialias_point_w->show();
  _table48_w->add( _antialias_point_w, 1, 2, 2, 3,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _antialias_point_w,
    "Toggle antialiasing of points" );

  // antialias_line
  _antialias_line_w = new ::gtk::widget0::ToggleButtonCb<Blend_>(
    "enable", false, this, &Blend_::antialias_line_cb );
  _antialias_line_w->show();
  _table48_w->add( _antialias_line_w, 1, 2, 3, 4,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _antialias_line_w,
    "Toggle antialiasing of lines" );

  // label3
  _label3_w = new ::gtk::widget0::Label( "antialias lines" );
  _label3_w->set_alignment(0, 0.5);
  _label3_w->show();
  _table48_w->add( _label3_w, 0, 1, 3, 4,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label2
  _label2_w = new ::gtk::widget0::Label( "antialias points" );
  _label2_w->set_alignment(0, 0.5);
  _label2_w->show();
  _table48_w->add( _label2_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label939
  _label939_w = new ::gtk::widget0::Label( "dest blend fn" );
  _label939_w->set_alignment(0, 0.5);
  _label939_w->show();
  _table48_w->add( _label939_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label100
  _label100_w = new ::gtk::widget0::Label( "Blend" );
  _label100_w->set_alignment(0, 0.5);
  _label100_w->show();
  _main_widget_w->add_label( _label100_w );

  // table85
  _table85_w = new ::gtk::widget0::Table( 3, 1, false );
  _table85_w->show();
  _main_widget_w->add( _table85_w );

  // table86
  _table86_w = new ::gtk::widget0::Table( 2, 2, false );
  _table86_w->show();
  _table85_w->add( _table86_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // fog_mode_label
  _fog_mode_label_w = new ::gtk::widget0::Label( "fog" );
  _fog_mode_label_w->set_alignment(0, 0.5);
  _fog_mode_label_w->show();
  _table86_w->add( _fog_mode_label_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // fog_enable
  _fog_enable_w = new ::gtk::widget0::ToggleButtonCb<Blend_>(
    "enable", false, this, &Blend_::fog_enable_cb );
  _fog_enable_w->show();
  _table86_w->add( _fog_enable_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _fog_enable_w,
    "Enable fog" );

  // fog_reset
  _fog_reset_w = new ::gtk::widget0::ButtonCb<Blend_>(
    "reset", this, &Blend_::fog_reset_cb );
  _fog_reset_w->show();
  _table86_w->add( _fog_reset_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _fog_reset_w,
    "Reset fog" );

  // fog_mode
  char const *fog_mode_labels[] =
    { "linear", "exp", "exp2" };

  _fog_mode_w = new ::gtk::widget1::MenuButtonCb<Blend_>(
    0, fog_mode_labels, 3, this, &Blend_::fog_mode_cb );
  _fog_mode_w->show();
  _table86_w->add( _fog_mode_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _fog_mode_w,
    "Set the fog decay mode" );

  // fog_parameter
  numberwidget_config const fog_parameter_param[] = {
    { "density",    0.0f, 1.0e6f, 0.001f, 0.01f, 0.1f, 3, 0.1f },
    { "start",   -1.0e6f, 1.0e6f, 0.001f, 0.01f, 0.1f, 3, 6.0f },
    { "end",     -1.0e6f, 1.0e6f, 0.001f, 0.01f, 0.1f, 3, 12.0f } };

  _fog_parameter_w = new ::gtk::widget1::NumberWidget2FloatCb<Blend_>(
    "fog parameters", fog_parameter_param, 3, this, &Blend_::fog_parameter_cb );

  _fog_parameter_w->show();
  _table85_w->add( _fog_parameter_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _fog_parameter_w,
    "Set fog density" );

  // fog_color
  base::Color3 const fog_color_param( 1.0f, 1.0f, 1.0f );
  _fog_color_w = new ::gtk::widget1::ColorCb<Blend_>(
    "fog color", fog_color_param, this,
    &Blend_::fog_color_cb );

  _fog_color_w->show();
  _table85_w->add( _fog_color_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _fog_color_w,
    "Set the fog color" );

  // label953
  _label953_w = new ::gtk::widget0::Label( "Fog" );
  _label953_w->set_alignment(0, 0.5);
  _label953_w->show();
  _main_widget_w->add_label( _label953_w );


}

Blend_::
~Blend_()
{
  delete _label953_w;
  delete _fog_color_w;
  delete _fog_parameter_w;
  delete _fog_mode_w;
  delete _fog_reset_w;
  delete _fog_enable_w;
  delete _fog_mode_label_w;
  delete _table86_w;
  delete _table85_w;
  delete _label100_w;
  delete _label939_w;
  delete _label2_w;
  delete _label3_w;
  delete _antialias_line_w;
  delete _antialias_point_w;
  delete _blend_src_function_w;
  delete _label938_w;
  delete _blend_dest_function_w;
  delete _table48_w;
  delete _blend_reset_w;
  delete _blend_enable_w;
  delete _hbox19_w;
  delete _vbox38_w;
  delete _label979_w;
  delete _label978_w;
  delete _label940_w;
  delete _depth_mask_w;
  delete _depth_function_w;
  delete _table97_w;
  delete _depth_reset_w;
  delete _depth_enable_w;
  delete _hbox18_w;
  delete _vbox37_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace milieu

