/* GANG Software
 * GEOM/milieu/gtk/Camera_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Camera_.H"

namespace milieu {
namespace gtk {


Camera_::
Camera_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::VBox( false, 0 );
  _main_widget_w->show();

  // camera_choice
  _camera_choice_w = new ::gtk::widget1::PopNotebookCb<Camera_>(
    this, &Camera_::camera_choice_cb );
  _camera_choice_w->set_tab_pos( GTK_POS_TOP );
  _camera_choice_w->set_title( "iSight | Camera" );
  _camera_choice_w->set_blocked( 0 );
  _camera_choice_w->show();
  _main_widget_w->add( _camera_choice_w, true, true, 0 );
  set_tooltip( _camera_choice_w,
    "Select perspective or orthographic camera" );

  // table41
  _table41_w = new ::gtk::widget0::Table( 2, 1, false );
  _table41_w->show();
  _camera_choice_w->add_blocked( _table41_w );

  // camera_perspective
  numberwidget_config const camera_perspective_param[] = {
    { "field of view",  -1.0, 1.0, 0.001, 0.01, 0.1, 3, 0.25 },
    { "near clip", 0.0, 1.0e6f, 0.0001, 0.001, 0.01, 6, 1.0e-2 },
    { "far clip", 0.0, 1.0e6f, 0.001, 0.01, 0.1, 3, 1.0e+2 } };

  _camera_perspective_w = new ::gtk::widget1::NumberWidget2FloatCb<Camera_>(
    "perspective camera", camera_perspective_param, 3, this, &Camera_::camera_perspective_cb );

  _camera_perspective_w->show();
  _table41_w->add( _camera_perspective_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _camera_perspective_w,
    "Set field-of-view of the perspective camera" );

  // camera_perspective_reset
  _camera_perspective_reset_w = new ::gtk::widget0::ButtonCb<Camera_>(
    "reset", this, &Camera_::camera_perspective_reset_cb );
  _camera_perspective_reset_w->show();
  _table41_w->add( _camera_perspective_reset_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _camera_perspective_reset_w,
    "Reset the perspective camera" );

  // notebooktab_camera_perspective
  _notebooktab_camera_perspective_w = new ::gtk::widget0::Label( "Perspective" );
  _notebooktab_camera_perspective_w->set_alignment(0, 0.5);
  _notebooktab_camera_perspective_w->show();
  _camera_choice_w->add_label( _notebooktab_camera_perspective_w );

  // table43
  _table43_w = new ::gtk::widget0::Table( 2, 1, false );
  _table43_w->show();
  _camera_choice_w->add_blocked( _table43_w );

  // camera_orthographic
  numberwidget_config const camera_orthographic_param[] = {
    { "zoom",  -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 3.0 },
    { "near clip", -1.0e6f, 1.0e6f, 0.0001, 0.001, 0.01, 3, -5.0e+2 },
    { "far clip", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 5.0e+2 } };

  _camera_orthographic_w = new ::gtk::widget1::NumberWidget2FloatCb<Camera_>(
    "orthographic camera", camera_orthographic_param, 3, this, &Camera_::camera_orthographic_cb );

  _camera_orthographic_w->show();
  _table43_w->add( _camera_orthographic_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _camera_orthographic_w,
    "Set hight of the orthographic camera" );

  // camera_orthographic_reset
  _camera_orthographic_reset_w = new ::gtk::widget0::ButtonCb<Camera_>(
    "reset", this, &Camera_::camera_orthographic_reset_cb );
  _camera_orthographic_reset_w->show();
  _table43_w->add( _camera_orthographic_reset_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _camera_orthographic_reset_w,
    "Reset the orthographic camera" );

  // notebooktab_camera_orthographic
  _notebooktab_camera_orthographic_w = new ::gtk::widget0::Label( "Orthographic" );
  _notebooktab_camera_orthographic_w->set_alignment(0, 0.5);
  _notebooktab_camera_orthographic_w->show();
  _camera_choice_w->add_label( _notebooktab_camera_orthographic_w );


}

Camera_::
~Camera_()
{
  delete _notebooktab_camera_orthographic_w;
  delete _camera_orthographic_reset_w;
  delete _camera_orthographic_w;
  delete _table43_w;
  delete _notebooktab_camera_perspective_w;
  delete _camera_perspective_reset_w;
  delete _camera_perspective_w;
  delete _table41_w;
  delete _camera_choice_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace milieu

