/* GANG Software
 * GEOM/milieu/gtk/GlobalLight_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "GlobalLight_.H"

namespace milieu {
namespace gtk {


GlobalLight_::
GlobalLight_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::Frame( "global light" );
  _main_widget_w->show();

  // table45
  _table45_w = new ::gtk::widget0::Table( 4, 1, false );
  _table45_w->show();
  _main_widget_w->add( _table45_w );

  // table72
  _table72_w = new ::gtk::widget0::Table( 1, 2, true );
  _table72_w->show();
  _table45_w->add( _table72_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // reset
  _reset_w = new ::gtk::widget0::ButtonCb<GlobalLight_>(
    "reset", this, &GlobalLight_::reset_cb );
  _reset_w->show();
  _table72_w->add( _reset_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _reset_w,
    "Reset the global ambient light" );

  // enable
  _enable_w = new ::gtk::widget0::ToggleButtonCb<GlobalLight_>(
    "enable", true, this, &GlobalLight_::enable_cb );
  _enable_w->show();
  _table72_w->add( _enable_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _enable_w,
    "Enable/disable lights" );

  // ambient
  base::Color3 const ambient_param( 0.5f, 0.5f, 0.5f );
  _ambient_w = new ::gtk::widget1::ColorCb<GlobalLight_>(
    "ambient", ambient_param, this,
    &GlobalLight_::ambient_cb );

  _ambient_w->show();
  _table45_w->add( _ambient_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _ambient_w,
    "Set global ambient light" );

  // frame3
  _frame3_w = new ::gtk::widget0::Frame( "face lighting" );
  _frame3_w->show();
  _table45_w->add( _frame3_w, 0, 1, 3, 4,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // sidedness
  char const *sidedness_labels[] =
    { "one-sided lighting", "two-sided lighting" };

  _sidedness_w = new ::gtk::widget1::MenuButtonCb<GlobalLight_>(
    1, sidedness_labels, 2, this, &GlobalLight_::sidedness_cb );
  _sidedness_w->show();
  _frame3_w->add( _sidedness_w );
  set_tooltip( _sidedness_w,
    "Choose to light one or both sides of surface polygons" );

  // frame2
  _frame2_w = new ::gtk::widget0::Frame( "viewpoint" );
  _frame2_w->show();
  _table45_w->add( _frame2_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // viewpoint
  char const *viewpoint_labels[] =
    { "infinite viewpoint", "local viewpoint" };

  _viewpoint_w = new ::gtk::widget1::MenuButtonCb<GlobalLight_>(
    1, viewpoint_labels, 2, this, &GlobalLight_::viewpoint_cb );
  _viewpoint_w->show();
  _frame2_w->add( _viewpoint_w );
  set_tooltip( _viewpoint_w,
    "Select lighting viewpoint (local is more realistic)" );


}

GlobalLight_::
~GlobalLight_()
{
  delete _viewpoint_w;
  delete _frame2_w;
  delete _sidedness_w;
  delete _frame3_w;
  delete _ambient_w;
  delete _enable_w;
  delete _reset_w;
  delete _table72_w;
  delete _table45_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace milieu

