/* GANG Software
 * GEOM/milieu/gtk/Light_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Light_.H"

namespace milieu {
namespace gtk {


Light_::
Light_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::Frame( "lights" );
  _main_widget_w->show();

  // table1
  _table1_w = new ::gtk::widget0::Table( 3, 1, false );
  _table1_w->show();
  _main_widget_w->add( _table1_w );

  // id
  char const *id_label[] = {
    "1", "2", "3", "4" , "5", "6", "7", "8" };

  _id_w = new ::gtk::widget1::ButtonBarCb<Light_>(
    0U, id_label, 1, 8, this, &Light_::id_cb );

  _id_w->show();
  _table1_w->add( _id_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _id_w,
    "Select a light" );

  // vbox13
  _vbox13_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox13_w->show();
  _table1_w->add( _vbox13_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0 );

  // hbox5
  _hbox5_w = new ::gtk::widget0::HBox( false, 0 );
  _hbox5_w->show();
  _vbox13_w->add( _hbox5_w, false, true, 0 );

  // hidebutton
  _hidebutton_w = new ::gtk::widget0::ButtonCb<Light_>(
    "more...", this, &Light_::hidebutton_cb );
  _hidebutton_w->show();
  _hbox5_w->add( _hidebutton_w, false, false, 0 );
  set_tooltip( _hidebutton_w,
    "Hide" );

  // hidebox
  _hidebox_w = new ::gtk::widget0::HBox( false, 0 );
  _hidebox_w->show();
  _vbox13_w->add( _hidebox_w, false, true, 0 );

  // vbox11
  _vbox11_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox11_w->show();
  _hidebox_w->add( _vbox11_w, true, true, 0 );

  // attenuation
  numberwidget_config const attenuation_param[] = {
    { "0", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 },
    { "1", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 },
    { "2", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 } };

  _attenuation_w = new ::gtk::widget1::NumberWidget2FloatCb<Light_>(
    "attenuation", attenuation_param, 3, this, &Light_::attenuation_cb );

  _attenuation_w->show();
  _vbox11_w->add( _attenuation_w, false, false, 0 );
  set_tooltip( _attenuation_w,
    "Set light attenuation (constant term)" );

  // vbox12
  _vbox12_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox12_w->show();
  _hidebox_w->add( _vbox12_w, true, true, 0 );

  // spot
  numberwidget_config const spot_param[] = {
    { "X",   -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 },
    { "Y",   -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 },
    { "Z",   -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0 },
    { "exp", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0 },
    { "cut", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0 } };

  _spot_w = new ::gtk::widget1::NumberWidget2FloatCb<Light_>(
    "spot", spot_param, 5, this, &Light_::spot_cb );

  _spot_w->show();
  _vbox12_w->add( _spot_w, false, false, 0 );
  set_tooltip( _spot_w,
    "Set spotlight direction (x)" );

  // vbox15
  _vbox15_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox15_w->show();
  _table1_w->add( _vbox15_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // reset
  _reset_w = new ::gtk::widget0::ButtonCb<Light_>(
    "reset", this, &Light_::reset_cb );
  _reset_w->show();
  _vbox15_w->add( _reset_w, false, false, 0 );
  set_tooltip( _reset_w,
    "Reset this light" );

  // hbox6
  _hbox6_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox6_w->show();
  _vbox15_w->add( _hbox6_w, false, false, 0 );

  // enable
  _enable_w = new ::gtk::widget0::ToggleButtonCb<Light_>(
    "enable", true, this, &Light_::enable_cb );
  _enable_w->show();
  _hbox6_w->add( _enable_w, true, true, 0 );
  set_tooltip( _enable_w,
    "Enable this light" );

  // moving
  _moving_w = new ::gtk::widget0::ToggleButtonCb<Light_>(
    "move", 0, this, &Light_::moving_cb );
  _moving_w->show();
  _hbox6_w->add( _moving_w, true, true, 0 );
  set_tooltip( _moving_w,
    "Move the light with the mouse" );

  // hbox7
  _hbox7_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox7_w->show();
  _vbox15_w->add( _hbox7_w, false, false, 0 );

  // attached
  _attached_w = new ::gtk::widget0::ToggleButtonCb<Light_>(
    "attach", false, this, &Light_::attached_cb );
  _attached_w->show();
  _hbox7_w->add( _attached_w, true, true, 0 );
  set_tooltip( _attached_w,
    "Toggle whether this light moves with the geometry object" );

  // show
  _show_w = new ::gtk::widget0::ToggleButtonCb<Light_>(
    "show", 0, this, &Light_::show_cb );
  _show_w->show();
  _hbox7_w->add( _show_w, true, true, 0 );
  set_tooltip( _show_w,
    "Show the light" );

  // hbox8
  _hbox8_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox8_w->show();
  _vbox15_w->add( _hbox8_w, false, false, 0 );

  // ambient
  base::Color3 const ambient_param( 0.0f, 0.0f, 0.0f );
  _ambient_w = new ::gtk::widget1::ColorCb<Light_>(
    "ambient", ambient_param, this,
    &Light_::ambient_cb );

  _ambient_w->show();
  _hbox8_w->add( _ambient_w, true, true, 0 );
  set_tooltip( _ambient_w,
    "Set ambient light" );

  // diffuse
  base::Color3 const diffuse_param( 0.0f, 0.0f, 0.0f );
  _diffuse_w = new ::gtk::widget1::ColorCb<Light_>(
    "diffuse", diffuse_param, this,
    &Light_::diffuse_cb );

  _diffuse_w->show();
  _hbox8_w->add( _diffuse_w, true, true, 0 );
  set_tooltip( _diffuse_w,
    "Set diffuse light" );

  // hbox9
  _hbox9_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox9_w->show();
  _vbox15_w->add( _hbox9_w, false, false, 0 );

  // specular
  base::Color3 const specular_param( 0.0f, 0.0f, 0.0f );
  _specular_w = new ::gtk::widget1::ColorCb<Light_>(
    "specular", specular_param, this,
    &Light_::specular_cb );

  _specular_w->show();
  _hbox9_w->add( _specular_w, true, true, 0 );
  set_tooltip( _specular_w,
    "Set specular light" );


}

Light_::
~Light_()
{
  delete _specular_w;
  delete _hbox9_w;
  delete _diffuse_w;
  delete _ambient_w;
  delete _hbox8_w;
  delete _show_w;
  delete _attached_w;
  delete _hbox7_w;
  delete _moving_w;
  delete _enable_w;
  delete _hbox6_w;
  delete _reset_w;
  delete _vbox15_w;
  delete _spot_w;
  delete _vbox12_w;
  delete _attenuation_w;
  delete _vbox11_w;
  delete _hidebox_w;
  delete _hidebutton_w;
  delete _hbox5_w;
  delete _vbox13_w;
  delete _id_w;
  delete _table1_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace milieu

