/* GANG Software
 * LAB/mrbubblelab/gtk/Controls_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Controls_.H"

namespace mrbubblelab {
namespace gtk {


Controls_::
Controls_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // vbox1
  _vbox1_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox1_w->show();

  // frame1
  _frame1_w = new ::gtk::widget0::Frame( "parameters" );
  _frame1_w->show();
  _vbox1_w->add( _frame1_w, true, true, 0 );

  // table1
  _table1_w = new ::gtk::widget0::Table( 2, 2, false );
  _table1_w->show();
  _frame1_w->add( _table1_w );

  // label1
  _label1_w = new ::gtk::widget0::Label( "coefficient" );
  _label1_w->set_alignment(0, 0.5);
  _label1_w->show();
  _table1_w->add( _label1_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label2
  _label2_w = new ::gtk::widget0::Label( "exponent" );
  _label2_w->set_alignment(0, 0.5);
  _label2_w->show();
  _table1_w->add( _label2_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // coefficient
  _coefficient_w = new ::gtk::widget0::Entry( 0U );
  _coefficient_w->set_editable( true );
  _coefficient_w->show();
  _table1_w->add( _coefficient_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // exponent
  _exponent_w = new ::gtk::widget0::Entry( 0U );
  _exponent_w->set_editable( true );
  _exponent_w->show();
  _table1_w->add( _exponent_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // frame2
  _frame2_w = new ::gtk::widget0::Frame( "initial conditions" );
  _frame2_w->show();
  _vbox1_w->add( _frame2_w, true, true, 0 );

  // table2
  _table2_w = new ::gtk::widget0::Table( 2, 2, false );
  _table2_w->show();
  _frame2_w->add( _table2_w );

  // label3
  _label3_w = new ::gtk::widget0::Label( "u(0)" );
  _label3_w->set_alignment(0, 0.5);
  _label3_w->show();
  _table2_w->add( _label3_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label4
  _label4_w = new ::gtk::widget0::Label( "u'(0)" );
  _label4_w->set_alignment(0, 0.5);
  _label4_w->show();
  _table2_w->add( _label4_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // u0
  _u0_w = new ::gtk::widget0::Entry( 0U );
  _u0_w->set_editable( true );
  _u0_w->show();
  _table2_w->add( _u0_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // uprime0
  _uprime0_w = new ::gtk::widget0::Entry( 0U );
  _uprime0_w->set_editable( true );
  _uprime0_w->show();
  _table2_w->add( _uprime0_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // frame3
  _frame3_w = new ::gtk::widget0::Frame( "normal shift" );
  _frame3_w->show();
  _vbox1_w->add( _frame3_w, true, true, 0 );

  // vbox2
  _vbox2_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox2_w->show();
  _frame3_w->add( _vbox2_w );

  // normalshift
  numberwidget_config const normalshift_param = {
    "normal shift", -FLT_MAX, FLT_MAX, 0.00001, 0.0001, 0.01, 5, 1.0 };

  _normalshift_w = new ::gtk::widget1::NumberWidgetFloatCb<Controls_>(
    &normalshift_param, this, &Controls_::normalshift_cb );

  _normalshift_w->show();
  _vbox2_w->add( _normalshift_w, false, true, 0 );
  set_tooltip( _normalshift_w,
    "Move through the normal-shifted family of surfaces" );

  // hbox1
  _hbox1_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox1_w->show();
  _vbox2_w->add( _hbox1_w, true, true, 0 );

  // normalshift_button0
  _normalshift_button0_w = new ::gtk::widget0::ButtonCb<Controls_>(
    "CMC", this, &Controls_::normalshift_button0_cb );
  _normalshift_button0_w->show();
  _hbox1_w->add( _normalshift_button0_w, true, true, 0 );
  set_tooltip( _normalshift_button0_w,
    "Set the normal shift to 1 (default)" );

  // normalshift_button1
  _normalshift_button1_w = new ::gtk::widget0::ButtonCb<Controls_>(
    "K", this, &Controls_::normalshift_button1_cb );
  _normalshift_button1_w->show();
  _hbox1_w->add( _normalshift_button1_w, true, true, 0 );
  set_tooltip( _normalshift_button1_w,
    "Set the normal shift to 0 to produce a K-surface (constant Gaussian curvature)" );

  // normalshift_button2
  _normalshift_button2_w = new ::gtk::widget0::ButtonCb<Controls_>(
    "CMC", this, &Controls_::normalshift_button2_cb );
  _normalshift_button2_w->show();
  _hbox1_w->add( _normalshift_button2_w, true, true, 0 );
  set_tooltip( _normalshift_button2_w,
    "Set the normal shift to -1 to produce the parallel CMC surface" );

  // frame4
  _frame4_w = new ::gtk::widget0::Frame( "integration counts" );
  _frame4_w->show();
  _vbox2_w->add( _frame4_w, true, true, 0 );

  // table3
  _table3_w = new ::gtk::widget0::Table( 2, 2, false );
  _table3_w->show();
  _frame4_w->add( _table3_w );

  // label5
  _label5_w = new ::gtk::widget0::Label( "initial" );
  _label5_w->set_alignment(0, 0.5);
  _label5_w->show();
  _table3_w->add( _label5_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label6
  _label6_w = new ::gtk::widget0::Label( "step" );
  _label6_w->set_alignment(0, 0.5);
  _label6_w->show();
  _table3_w->add( _label6_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // initial_integrator_count
  _initial_integrator_count_w = new ::gtk::widget0::Entry( 0U );
  _initial_integrator_count_w->set_editable( true );
  _initial_integrator_count_w->show();
  _table3_w->add( _initial_integrator_count_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // integrator_count
  _integrator_count_w = new ::gtk::widget0::Entry( 0U );
  _integrator_count_w->set_editable( true );
  _integrator_count_w->show();
  _table3_w->add( _integrator_count_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );


}

Controls_::
~Controls_()
{
  delete _integrator_count_w;
  delete _initial_integrator_count_w;
  delete _label6_w;
  delete _label5_w;
  delete _table3_w;
  delete _frame4_w;
  delete _normalshift_button2_w;
  delete _normalshift_button1_w;
  delete _normalshift_button0_w;
  delete _hbox1_w;
  delete _normalshift_w;
  delete _vbox2_w;
  delete _frame3_w;
  delete _uprime0_w;
  delete _u0_w;
  delete _label4_w;
  delete _label3_w;
  delete _table2_w;
  delete _frame2_w;
  delete _exponent_w;
  delete _coefficient_w;
  delete _label2_w;
  delete _label1_w;
  delete _table1_w;
  delete _frame1_w;
  delete _vbox1_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace mrbubblelab

