/* GANG Software
 * VIEWER/isightui/gtk/Mouse_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "Mouse_.H"

namespace isightui {
namespace gtk {


Mouse_::
Mouse_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::Frame( (char *)0 );
  _main_widget_w->show();

  // vbox32
  _vbox32_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox32_w->show();
  _main_widget_w->add( _vbox32_w );

  // vbox43
  _vbox43_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox43_w->show();
  _vbox32_w->add( _vbox43_w, false, true, 0 );

  // frame12
  _frame12_w = new ::gtk::widget0::Frame( "view mode" );
  _frame12_w->show();
  _vbox43_w->add( _frame12_w, true, true, 0 );

  // viewmode
  char const *viewmode_labels[] =
    { "examine", "fly" };

  _viewmode_w = new ::gtk::widget1::MenuButtonCb<Mouse_>(
    0, viewmode_labels, 2, this, &Mouse_::viewmode_cb );
  _viewmode_w->show();
  _frame12_w->add( _viewmode_w );
  set_tooltip( _viewmode_w,
    "Move the object (examine) or move the camera (fly)" );

  // hbox29
  _hbox29_w = new ::gtk::widget0::HBox( true, 0 );
  _hbox29_w->show();
  _vbox43_w->add( _hbox29_w, false, false, 0 );

  // reset0
  _reset0_w = new ::gtk::widget0::ButtonCb<Mouse_>(
    "reset", this, &Mouse_::reset0_cb );
  _reset0_w->show();
  _hbox29_w->add( _reset0_w, true, true, 0 );
  set_tooltip( _reset0_w,
    "Restore the mouse to default settings" );

  // reset1
  _reset1_w = new ::gtk::widget0::ButtonCb<Mouse_>(
    "accelerated", this, &Mouse_::reset1_cb );
  _reset1_w->show();
  _hbox29_w->add( _reset1_w, true, true, 0 );
  set_tooltip( _reset1_w,
    "Restore the mouse to default accelerated settings" );

  // frame110
  _frame110_w = new ::gtk::widget0::Frame( "inertia" );
  _frame110_w->show();
  _vbox43_w->add( _frame110_w, true, true, 0 );

  // table106
  _table106_w = new ::gtk::widget0::Table( 3, 2, true );
  _table106_w->show();
  _frame110_w->add( _table106_w );

  // inertia_enable
  _inertia_enable_w = new ::gtk::widget0::ToggleButtonCb<Mouse_>(
    "enable", true, this, &Mouse_::inertia_enable_cb );
  _inertia_enable_w->show();
  _table106_w->add( _inertia_enable_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _inertia_enable_w,
    "Enable inertia (surface continues to move after mouse button is released)" );

  // inertia_decay_enable
  _inertia_decay_enable_w = new ::gtk::widget0::ToggleButtonCb<Mouse_>(
    "enable", false, this, &Mouse_::inertia_decay_enable_cb );
  _inertia_decay_enable_w->show();
  _table106_w->add( _inertia_decay_enable_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _inertia_decay_enable_w,
    "Enable inertia decay (surface slows to a stop after mouse button is released" );

  // label987
  _label987_w = new ::gtk::widget0::Label( "inertia decay" );
  _label987_w->set_alignment(0, 0.5);
  _label987_w->show();
  _table106_w->add( _label987_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // label986
  _label986_w = new ::gtk::widget0::Label( "inertia" );
  _label986_w->set_alignment(0, 0.5);
  _label986_w->show();
  _table106_w->add( _label986_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );

  // inertia_decay_rate
  numberwidget_config const inertia_decay_rate_param = {
    "inertia decay rate", -1.0, 1.0, 0.001, 0.01, 0.1, 3, 0.975 };

  _inertia_decay_rate_w = new ::gtk::widget1::NumberWidgetFloatCb<Mouse_>(
    &inertia_decay_rate_param, this, &Mouse_::inertia_decay_rate_cb );

  _inertia_decay_rate_w->show();
  _table106_w->add( _inertia_decay_rate_w, 0, 2, 2, 3,
    (GtkAttachOptions)(GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _inertia_decay_rate_w,
    "Set the rate at which surface slows to a stop after mouse button is released" );

  // mouse_speed
  numberwidget_config const mouse_speed_param[] = {
    { "speed", -1.0e6f, 1.0e6f, 0.001, 0.01, 0.1, 3, 0.15 },
    { "acceleration", 0.0, 1.0e6f, 0.001, 0.01, 0.1, 3, 0.0 } };

  _mouse_speed_w = new ::gtk::widget1::NumberWidget2FloatCb<Mouse_>(
    "mouse speed", mouse_speed_param, 2, this, &Mouse_::mouse_speed_cb );

  _mouse_speed_w->show();
  _vbox43_w->add( _mouse_speed_w, false, true, 0 );
  set_tooltip( _mouse_speed_w,
    "Set mouse speed a (a*x^n)" );


}

Mouse_::
~Mouse_()
{
  delete _mouse_speed_w;
  delete _inertia_decay_rate_w;
  delete _label986_w;
  delete _label987_w;
  delete _inertia_decay_enable_w;
  delete _inertia_enable_w;
  delete _table106_w;
  delete _frame110_w;
  delete _reset1_w;
  delete _reset0_w;
  delete _hbox29_w;
  delete _viewmode_w;
  delete _frame12_w;
  delete _vbox43_w;
  delete _vbox32_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace isightui

