/* GANG Software
 * VIEWER/isightui/gtk/WindowSize_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "WindowSize_.H"

namespace isightui {
namespace gtk {


WindowSize_::
WindowSize_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget0::VBox( false, 0 );
  _main_widget_w->show();

  // window_size
  numberwidget_config const window_size_param[] = {
    { "width", 0.0, FLT_MAX, 0.02, 0.14, 1.0, 0, 500 },
    { "height", 0.0, FLT_MAX, 0.02, 0.14, 1.0, 0, 500 } };

  _window_size_w = new ::gtk::widget1::NumberWidget2IntCb<WindowSize_>(
    "window size", window_size_param, 2, this, &WindowSize_::window_size_cb );

  _window_size_w->show();
  _main_widget_w->add( _window_size_w, false, true, 0 );
  set_tooltip( _window_size_w,
    "Set the viewer window width (pixels)" );

  // table3
  _table3_w = new ::gtk::widget0::Table( 3, 2, false );
  _table3_w->show();
  _main_widget_w->add( _table3_w, false, false, 0 );

  // windowsize0
  _windowsize0_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "500x500", this, &WindowSize_::windowsize0_cb );
  _windowsize0_w->show();
  _table3_w->add( _windowsize0_w, 0, 1, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize0_w,
    "Set the viewer window to 500x500 pixels" );

  // windowsize1
  _windowsize1_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "640x480", this, &WindowSize_::windowsize1_cb );
  _windowsize1_w->show();
  _table3_w->add( _windowsize1_w, 1, 2, 0, 1,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize1_w,
    "Set the viewer window to 640x480 pixels" );

  // windowsize3
  _windowsize3_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "1024x768", this, &WindowSize_::windowsize3_cb );
  _windowsize3_w->show();
  _table3_w->add( _windowsize3_w, 1, 2, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize3_w,
    "Set the viewer window to 1024x786 pixels" );

  // windowsize2
  _windowsize2_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "800x800", this, &WindowSize_::windowsize2_cb );
  _windowsize2_w->show();
  _table3_w->add( _windowsize2_w, 0, 1, 1, 2,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize2_w,
    "Set the viewer window to 800x800 pixels" );

  // windowsize4
  _windowsize4_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "1200x1200", this, &WindowSize_::windowsize4_cb );
  _windowsize4_w->show();
  _table3_w->add( _windowsize4_w, 0, 1, 2, 3,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize4_w,
    "Set the viewer window to 1280x1024 pixels" );

  // windowsize5
  _windowsize5_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "1280x960", this, &WindowSize_::windowsize5_cb );
  _windowsize5_w->show();
  _table3_w->add( _windowsize5_w, 1, 2, 2, 3,
    (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
    (GtkAttachOptions)0, 0, 0 );
  set_tooltip( _windowsize5_w,
    "Set the viewer window to 1280x960 pixels" );

  // fullscreen
  _fullscreen_w = new ::gtk::widget0::ButtonCb<WindowSize_>(
    "full screen", this, &WindowSize_::fullscreen_cb );
  _fullscreen_w->show();
  _main_widget_w->add( _fullscreen_w, false, false, 0 );
  set_tooltip( _fullscreen_w,
    "Set the viewer window to full screen" );


}

WindowSize_::
~WindowSize_()
{
  delete _fullscreen_w;
  delete _windowsize5_w;
  delete _windowsize4_w;
  delete _windowsize2_w;
  delete _windowsize3_w;
  delete _windowsize1_w;
  delete _windowsize0_w;
  delete _table3_w;
  delete _window_size_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace isightui

