/* GANG Software
 * VIEWER/isightui/gtk/WriteConfig_.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by glade++

#include "WriteConfig_.H"

namespace isightui {
namespace gtk {


WriteConfig_::
WriteConfig_()
{
  _tooltips = new ::gtk::widget0::Tooltips;


  // main_widget
  _main_widget_w = new ::gtk::widget1::PopNotebook;
  _main_widget_w->set_tab_pos( GTK_POS_TOP );
  _main_widget_w->set_title( "iSight Write Config" );
  _main_widget_w->set( 1 );
  _main_widget_w->show();
  set_tooltip( _main_widget_w,
    "" );

  // vbox3
  _vbox3_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox3_w->show();
  _main_widget_w->add( _vbox3_w );

  // reset_geometry
  _reset_geometry_w = new ::gtk::widget0::ButtonCb<WriteConfig_>(
    "reset", this, &WriteConfig_::reset_geometry_cb );
  _reset_geometry_w->show();
  _vbox3_w->add( _reset_geometry_w, false, false, 0 );
  set_tooltip( _reset_geometry_w,
    "Reset" );

  // frame4
  _frame4_w = new ::gtk::widget0::Frame( "write colors" );
  _frame4_w->show();
  _vbox3_w->add( _frame4_w, true, true, 0 );

  // write_colors
  char const *write_colors_labels[] =
    { "no", "yes", "automatic" };

  _write_colors_w = new ::gtk::widget1::MenuButton(
    2, write_colors_labels, 3 );
  _write_colors_w->show();
  _frame4_w->add( _write_colors_w );
  set_tooltip( _write_colors_w,
    "Write colors" );

  // frame5
  _frame5_w = new ::gtk::widget0::Frame( "write normals" );
  _frame5_w->show();
  _vbox3_w->add( _frame5_w, true, true, 0 );

  // write_normals
  char const *write_normals_labels[] =
    { "no", "yes", "automatic" };

  _write_normals_w = new ::gtk::widget1::MenuButton(
    2, write_normals_labels, 3 );
  _write_normals_w->show();
  _frame5_w->add( _write_normals_w );
  set_tooltip( _write_normals_w,
    "Write normal vectors" );

  // transparent
  _transparent_w = new ::gtk::widget0::ToggleButton(
    "transparent", 0 );
  _transparent_w->show();
  _vbox3_w->add( _transparent_w, false, false, 0 );
  set_tooltip( _transparent_w,
    "Make the background transparent on image files" );

  // label3
  _label3_w = new ::gtk::widget0::Label( "Geometry" );
  _label3_w->set_alignment(0.5, 0.5);
  _label3_w->show();
  _main_widget_w->add_label( _label3_w );

  // vbox1
  _vbox1_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox1_w->show();
  _main_widget_w->add( _vbox1_w );

  // reset_image
  _reset_image_w = new ::gtk::widget0::ButtonCb<WriteConfig_>(
    "reset", this, &WriteConfig_::reset_image_cb );
  _reset_image_w->show();
  _vbox1_w->add( _reset_image_w, false, false, 0 );
  set_tooltip( _reset_image_w,
    "Reset" );

  // frame3
  _frame3_w = new ::gtk::widget0::Frame( "size" );
  _frame3_w->show();
  _vbox1_w->add( _frame3_w, false, true, 0 );

  // vbox2
  _vbox2_w = new ::gtk::widget0::VBox( false, 0 );
  _vbox2_w->show();
  _frame3_w->add( _vbox2_w );

  // size_use_window
  _size_use_window_w = new ::gtk::widget0::ToggleButtonCb<WriteConfig_>(
    "use window size", 1, this, &WriteConfig_::size_use_window_cb );
  _size_use_window_w->show();
  _vbox2_w->add( _size_use_window_w, false, false, 0 );
  set_tooltip( _size_use_window_w,
    "make the image the same size as the window" );

  // size
  numberwidget_config const size_param[] = {
    { "width", 0.0, FLT_MAX, 0.02, 0.14, 1.0, 0, 500 },
    { "height", 0.0, FLT_MAX, 0.02, 0.14, 1.0, 0, 500 } };

  _size_w = new ::gtk::widget1::NumberWidget2Int(
    "size", size_param, 2 );

  _size_w->show();
  _vbox2_w->add( _size_w, false, true, 0 );
  set_tooltip( _size_w,
    "Image width" );

  // frame1
  _frame1_w = new ::gtk::widget0::Frame( "JPEG/PNG image compression" );
  _frame1_w->show();
  _vbox1_w->add( _frame1_w, false, true, 0 );

  // compression
  numberwidget_config const compression_param = {
    "compression", 0.0, 1.0, 0.001, 0.01, 0.1, 3, 0.75 };

  _compression_w = new ::gtk::widget1::NumberWidgetFloat(
    &compression_param );

  _compression_w->show();
  _frame1_w->add( _compression_w );
  set_tooltip( _compression_w,
    "JPEG/PNG compression" );

  // label2
  _label2_w = new ::gtk::widget0::Label( "Image" );
  _label2_w->set_alignment(0.5, 0.5);
  _label2_w->show();
  _main_widget_w->add_label( _label2_w );


}

WriteConfig_::
~WriteConfig_()
{
  delete _label2_w;
  delete _compression_w;
  delete _frame1_w;
  delete _size_w;
  delete _size_use_window_w;
  delete _vbox2_w;
  delete _frame3_w;
  delete _reset_image_w;
  delete _vbox1_w;
  delete _label3_w;
  delete _transparent_w;
  delete _write_normals_w;
  delete _frame5_w;
  delete _write_colors_w;
  delete _frame4_w;
  delete _reset_geometry_w;
  delete _vbox3_w;
  delete _main_widget_w;

  delete _tooltips;
}

} // namespace gtk
} // namespace isightui

