/* GANG Software
 * WIDGET/gtk/widget0/ToggleButton.H
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// generated by gtk2c++

#ifndef gtk_widget0_ToggleButton_INCLUDED
#define gtk_widget0_ToggleButton_INCLUDED

#include "widget/ui/Boolean.H"
#include "Button.H"

namespace gtk {
namespace widget0 {

class ToggleButton
  :
    virtual public widget::ui::Boolean,
    public Button
{
public:
  ToggleButton() :
      Button( gtk_toggle_button_new() ) {}
  ToggleButton( char const *label ) :
      Button( gtk_toggle_button_new_with_label( label ) ) {}
  ToggleButton( char const *label, bool state ) :
      Button( gtk_toggle_button_new_with_label( label ) )
    { set(state); }
  void set( bool state )
    { set_active( state ); }
  bool get() const
    { return get_active(); }
  void set_mode( bool draw_indicator )
    { gtk_toggle_button_set_mode( GTK_TOGGLE_BUTTON(w()), draw_indicator ); }
  void set_active( bool is_active )
    { gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(w()), is_active ); }
  bool get_active() const
    { return gtk_toggle_button_get_active(
      GTK_TOGGLE_BUTTON(w())); }
  void toggled()
    { gtk_toggle_button_toggled( GTK_TOGGLE_BUTTON(w())); }

protected:
  ToggleButton( GtkWidget *x ) : Button(x) {}
};

} // namespace widget0
} // namespace gtk

#endif // gtk_widget0_ToggleButton_INCLUDED
