/* GANG Software
 * BASE/vrml/Lexer.C
 * Copyright (C) 2002 Nicholas Schmitt <nick@gang.umass.edu>
 * Wed Sep 18 16:39:46 2002
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
// Generated by parse++

#include <stdlib.h>
#include "Lexer.H"

#if defined(__sgi) && !defined(__GNUG__)
#pragma set woff 1110
#endif

/*
  Acknowledgements:
  This code is modified from a VRML 2.0 parser by Gavin Bell and Daniel Woods
  Copyright (C) 1996 Silicon Graphics, Inc.
*/

#include <iostream>

namespace vrml {

char const *Lexer::format = "%lg";
char const *Lexer::format2 = "%lg%n";

// constructor
Lexer::
Lexer()
{
  _initialize();

  BEGIN(INITIAL);
  expectToken = 0;
  parsing_mf = 0;
  _lineno = 1;
  tmpString.erase();
}

// destructor
Lexer::~Lexer() {
  _deinitialize();
}

void Lexer::
input( CHAR *buf, size_t &result, size_t max_size )
{
  result = _stream->read( buf, max_size );
}

char *
Lexer::
skip_ws(char *s)
{
  while (*s == ' ' ||
         *s == '\f' ||
         *s == '\n' ||
         *s == '\r' ||
         *s == '\t' ||
         *s == '\v' ||
         *s == ',' ||
         *s == '#')
  {
    if (*s == '#')
    {
      while (*s && *s != '\n') ++s;
    }
    else
    {
      if (*s++ == '\n') ++_lineno;
    }
  }
  return s;
}

Lexer::Lexer( Lexer const & )
{
  abort();
}

Lexer &Lexer::operator=( const Lexer & )
{
  abort();
  return *this;
}

int const Lexer::BUFFER_NEW = 0;
int const Lexer::BUFFER_NORMAL = 1;
int const Lexer::BUFFER_EOF_PENDING = 2;
int const Lexer::END_OF_BUFFER_CHAR = 0;
int const Lexer::BUF_SIZE = 16384;
int const Lexer::EOB_ACT_CONTINUE_SCAN = 0;
int const Lexer::EOB_ACT_END_OF_FILE = 1;
int const Lexer::EOB_ACT_LAST_MATCH = 2;
int const Lexer::READ_BUF_SIZE = 8192;
int const Lexer::NUM_RULES = 50;
int const Lexer::END_OF_BUFFER = 51;
int const Lexer::MORE_ADJ = 0;
int const Lexer::INITIAL = 0;
int const Lexer::START_STACK_INCR = 25;
int const Lexer::EXIT_FAILURE_ = 1;
int const Lexer::CONSTANT1 = 1021;
int const Lexer::CONSTANT2 = 9853;

void Lexer::_initialize()
{
  current_buffer = (BufferState *)0;
  leng = 0;
  hold_char = 0;
  n_chars = 0;
  c_buf_p = (CHAR *)0;
  init = 1;
  start = 0;
  did_buffer_switch_on_eof = 0;
  last_accepting_state = 0;
  last_accepting_cpos = (CHAR *)0;
  start_stack_ptr = 0;
  start_stack_depth = 0;
  start_stack = (int *)0;
}

void Lexer::_deinitialize()
{
  if (current_buffer != (BufferState *)0)
  {
    delete_buffer(current_buffer);
  }
}

Lexer::BufferState::BufferState()
{
  ch_buf = (CHAR *)0;
  buf_pos = (CHAR *)0;
  buf_size = 0;
  n_chars = 0;
  is_our_buffer = 0;
  is_interactive = 0;
  at_bol = 0;
  fill_buffer = 0;
  buffer_status = 0;
}


const short int Lexer::accept[1021] =
{   0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   51,   49,   47,   48,   47,   14,
   47,    9,   14,   14,   14,   14,   14,   14,   14,   14,
   14,   49,   49,   49,   49,   49,   49,   49,   49,   23,
   49,   49,   49,   49,   21,   21,   49,   49,   49,   36,
   34,   36,   36,   49,   49,   33,   49,   49,   49,   49,
   49,   49,   49,   49,   49,   49,   17,   18,   49,   49,
   24,   49,   22,   22,   49,   49,   49,   37,   35,   37,
   37,   49,   49,   49,   49,   49,   49,   42,   41,   43,
   49,   44,   49,   46,   46,   47,   48,   47,   48,   48,
   47,   47,   47,   47,   14,   14,   14,    7,   14,   14,
    6,   14,   14,   14,   14,    0,   15,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   23,   23,   23,    0,
    0,    0,    0,    0,   21,   21,    0,    0,    0,    0,
    0,    0,    0,   36,   36,   36,   15,    0,   33,   33,
   33,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   16,    0,   24,   24,   24,    0,   22,
   22,    0,    0,    0,    0,    0,    0,    0,   37,   37,
   37,   16,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   42,   38,   39,   40,
   46,   46,   48,   48,   48,   47,    4,   14,   14,   14,
    5,   14,   14,   14,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   23,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   21,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   33,    0,    0,   25,    0,    0,    0,    0,
    0,   25,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   24,   22,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   26,    0,    0,    0,    0,    0,   26,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   46,   47,   14,   14,   14,   14,   14,   14,
    0,   20,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   25,
   25,    0,   25,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   26,   26,    0,   26,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   47,
   14,    2,    8,   14,   14,   12,   19,    0,    0,   31,
    0,    0,    0,    0,    0,   31,    0,    0,    0,    0,
   31,    0,    0,    0,   31,    0,    0,    0,    0,    0,
   31,    0,    0,    0,   45,   45,    0,    0,    0,    0,
   45,   45,    0,    0,   45,   45,    0,    0,   45,   45,
    0,    0,    0,    0,   45,   45,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   25,    0,   25,    0,
    0,   27,    0,    0,    0,    0,    0,   27,    0,    0,
    0,    0,   27,    0,    0,    0,   27,    0,    0,    0,
    0,    0,   27,    0,    0,    0,    0,   32,    0,    0,
    0,    0,    0,   32,    0,    0,    0,    0,   32,    0,
    0,    0,   32,    0,    0,    0,    0,    0,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   26,    0,
   26,    0,    0,   28,    0,    0,    0,    0,    0,   28,
    0,    0,    0,    0,   28,    0,    0,    0,   28,    0,
    0,    0,    0,    0,   28,    0,    0,   47,   14,   14,
   14,   14,   31,   31,    0,   31,    0,   31,   31,    0,
   31,   31,    0,   31,    0,   45,   45,   45,   45,   45,
   45,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   27,   27,    0,   27,    0,
   27,   27,    0,   27,   27,    0,   27,    0,   32,   32,
    0,   32,    0,   32,   32,    0,   32,   32,    0,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   28,   28,    0,   28,    0,
   28,   28,    0,   28,   28,    0,   28,    0,   47,   14,
   10,   14,   14,    0,   31,    0,   31,    0,   31,    0,
   31,    0,   31,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,    0,    0,   29,    0,    0,    0,
    0,    0,   29,    0,    0,    0,    0,   29,    0,    0,
   29,    0,    0,    0,    0,    0,   29,    0,    0,    0,
    0,   29,    0,    0,    0,   29,    0,    0,    0,    0,
    0,   29,    0,    0,    0,    0,    0,    0,   29,    0,
    0,    0,   27,    0,   27,    0,   27,    0,   27,    0,
   27,    0,   32,    0,   32,    0,   32,    0,   32,    0,
   32,    0,    0,   30,    0,    0,    0,    0,    0,   30,
    0,    0,    0,    0,   30,    0,    0,   30,    0,    0,
    0,    0,    0,   30,    0,    0,    0,    0,   30,    0,
    0,    0,   30,    0,    0,    0,    0,    0,   30,    0,
    0,    0,    0,    0,    0,   30,    0,    0,    0,   28,
    0,   28,    0,   28,    0,   28,    0,   28,   47,   14,
   11,   14,   29,   29,    0,   29,    0,   29,   29,    0,
   29,   29,    0,   29,    0,   29,   29,    0,   29,   29,
    0,   29,    0,   29,   29,    0,   30,   30,    0,   30,
    0,   30,   30,    0,   30,   30,    0,   30,    0,   30,
   30,    0,   30,   30,    0,   30,    0,   30,   30,    0,
   47,   14,   14,    0,   29,    0,   29,    0,   29,    0,
   29,    0,   29,    0,   29,    0,   29,    0,   29,    0,
   29,    0,   30,    0,   30,    0,   30,    0,   30,    0,
   30,    0,   30,    0,   30,    0,   30,    0,   30,   47,
   14,   14,   47,    3,   14,   47,   13,   47,   47,   47,
   47,   47,    1,   47,    1,    1,    1,    1,    1,    0
};


const int Lexer::ec[256] =
{   0,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    4,    5,    6,    7,    5,    5,    5,    1,    5,
    5,    5,    8,    2,    8,    9,    5,   10,   11,   12,
   11,   11,   11,   11,   11,   13,   11,    5,    5,    5,
    5,    5,    5,    5,   14,   15,   15,   16,   17,   18,
    5,    5,   19,    5,    5,   20,   21,   22,   23,   24,
    5,   25,   26,   27,   28,   29,    5,   30,    5,    5,
   31,   32,   33,    5,    5,    5,   15,   15,   15,   34,
   35,   36,    5,    5,   37,    5,    5,   38,    5,   39,
   40,   41,    5,    5,   42,   43,   44,   45,    5,   46,
    5,    5,    1,    5,    1,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5
};


const int Lexer::meta[47] =
{   0,
    1,    2,    3,    2,    4,    5,    6,    4,    1,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    8,    9,    8,    7,    7,    7,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4
};


const short int Lexer::base[1183] =
{   0,
    0,    6,   13,    0,   58,   84,  110,    0,   58,   70,
   84,   96,  122,  128,  134,  140,  152,  158,  170,  176,
  182,  188,  194,  200,  206,  232,  258,  284,  310,  336,
  362,  388,  420,  452,  478,  504,  530,  556,   69,  217,
  218,  223,  582,  594,  913, 9853,  165,  226,  250,    0,
  257, 9853,  885,  871,  864,  864,  838,  829,  801,   18,
  781,  779,  758,  734,  115,  163,  612,  263,  270,  639,
  274,  673,   43,  288,  294,  298,  321,  315,  718,    0,
 9853,  350,  726,  326,  348,  745,  353,  366,  779,  373,
  377,  813,  393,  398,  847,  724, 9853, 9853,  403,  418,
  874,  422,  430,  434,  452,  456,  908,    0, 9853,  942,
  722,  468,  462,  974,  483,  488, 1008,    0, 9853, 9853,
  386, 9853,  492,  514,  508,  526,  543,  549,  555,  569,
  575,  581,  624,  630,    0,  706,  696,    0,  674,  660,
    0,  656,  627,  613,  585,  561, 9853,  552,  586,    0,
  599, 1042, 1054,   81,  628,  632,    0,  647,  655,  679,
    0, 1066, 1078,  691,  659,    0,  689,    0,  695, 1090,
 1102,  221,  701,    0,  730,  736,    0,  705,    0,  734,
  753,  760,  764,    0,  788, 1114, 1126,  333,  794,  798,
    0,  822, 1138, 1150,  403,  828,  832,    0,  856, 1162,
 1174,  435,  862, 9853,  866, 1179,  887,  882,  895,  916,
    0,  920, 1213,  925, 1247, 1259,  519,  942,    0, 1271,
 1303,    0,  929, 1335,  947, 1369, 1381,  583,  953,  957,
 1393,  983, 1427, 1439,  600,  989,    0, 9853, 9853, 9853,
  993,    0, 1020, 1024, 1028, 1191,    0,  555,  528,  519,
    0,  495,  491,  472,  482,  490, 1027, 1189, 1451, 1485,
 1497,    0,    0,    0, 1509, 1193, 1543, 1197, 1221, 1225,
 1555,   44, 1600, 1612, 1624, 1636, 1648,   54, 1237,    0,
 1270, 1274, 1693, 1727, 1739,    0,    0,    0, 1751, 1278,
 1785, 1282, 1286, 1302, 1306, 1790, 1824, 1836,    0,    0,
    0,  644, 1310, 1848, 1315, 1319, 1860, 1894, 1906,    0,
    0,    0, 1918, 1343, 1952, 1348, 1352, 1964, 1998, 2010,
    0,    0,    0, 2022, 1356, 2056, 1401, 1405,    0, 1410,
 1414, 2068, 2102, 2114,    0,    0,    0, 2126, 1459, 2160,
 1464, 1468, 2165, 2199, 2211,    0,    0,    0,  732, 1472,
 2223, 1510, 1517, 2235, 2269, 2281,    0,    0,    0, 2293,
 1521, 2327,    0, 1567,  459,  459,  440,  407,  407,  414,
  420, 9853, 1526, 2339, 2351,  646, 1565, 2363, 2375, 2387,
 2399, 2411, 2423, 2435, 1577, 2447, 2459, 2471, 2483, 2518,
 2552, 2564,  661, 1578, 2576, 2588, 2600, 2612, 2624, 1582,
 1530, 1654, 2636, 2648, 2660, 2694, 2706,  743, 1660, 2718,
 2730, 2742, 2754, 2766, 2778, 2812, 2824,  744, 1669, 2836,
 2848, 2860, 2872, 2884, 2896, 2930, 2942,  768, 1675, 2954,
 2966, 2978, 2990, 3002, 1709, 1679, 1701, 3014, 3026, 3038,
 3072, 3084,  777, 1751, 3096, 3108, 3120, 3132, 3144, 1763,
  414,    0,    0,  147,  382,    0, 9853, 1762, 1705, 3149,
 3183, 3195,    0,    0,    0,  778, 1766, 3207, 3219, 3231,
 3243, 3277, 1771, 1798, 3289, 3323,    0,    0,    0,    0,
  812, 1802, 3328, 1806, 1811, 1868, 3362, 3374, 3386, 3398,
 3410,   69, 1880, 3455, 3467,  201, 3512, 1878, 3524,  202,
 3569, 3581, 3593, 3605, 3617,  216, 3654,  476,  502, 1919,
 1926, 3699, 3733, 3745,    0,    0,    0, 3757, 1930, 3791,
 3803, 3815, 3827, 3861, 1935, 1939, 3873, 3907,    0,    0,
    0,    0, 3919, 1972, 3953, 1976, 1980, 3987, 3999, 1985,
 2022, 4026, 4060, 4072,    0,    0,    0,  846, 2030, 4084,
 4096, 4108, 4120, 4154, 2035, 2039, 4166, 4200,    0,    0,
    0,    0,  879, 2043, 4205, 2077, 2081, 4232, 4266, 4278,
    0,    0,    0,  963, 2085, 4290, 4302, 4314, 4326, 4360,
 2127, 2089, 4372, 4406,    0,    0,    0,    0,  973, 2134,
 4411, 2139, 2143, 4445, 4479, 4491,    0,    0,    0, 4503,
 2147, 4537, 4549, 4561, 4573, 4607, 2174, 2178, 4619, 4653,
    0,    0,    0,    0, 4665, 2182, 4699, 2186, 2243, 4733,
 4745, 2248, 2252, 4772, 4806, 4818,    0,    0,    0, 1024,
 2256, 4830, 4842, 4854, 4866, 4900, 2294, 2301, 4912, 4946,
    0,    0,    0,    0, 1025, 2305, 4951, 2503,  370,  352,
  336,  317, 2309, 2501, 2526, 4985, 4997, 5009, 5043, 5055,
 5067,  802, 2532, 5101, 5113,    0, 5125, 5160, 5205, 2544,
 5240, 5275, 5309, 5321,  811, 2668, 5333, 5345, 5357, 5369,
 5381, 5393, 5427, 5439, 5451, 2674, 5463, 5475, 5509,  836,
 2680, 5521, 5533, 5545, 5557, 2794, 2786, 2904, 5569, 5581,
 5593, 5627, 5639, 5651,  845, 2910, 5685, 5697, 3054, 2790,
 2916, 5709, 5721, 5733, 5767, 5779, 5791,  954, 3046, 5825,
 5837, 5849, 5883, 5895, 1012, 3157, 5907, 5919, 5931, 5943,
 5955, 5967, 6001, 6013, 6025, 3163, 6037, 6049, 6083, 1162,
 3169, 6095, 6107, 6119, 6131, 3259, 3050, 3251, 6143, 6155,
 6167, 6201, 6213, 6225, 1194, 3297, 6259, 6271, 3309,  317,
    0,  273,  296, 3255, 3307, 6283, 6295, 6329, 6341, 3336,
 6375, 6387, 6399,    0, 6434,  528,  540, 6480,  600,  680,
 3348, 6526,  977, 1041, 3347, 3414, 6564, 6598, 6610,    0,
    0,    0, 1210, 3418, 6622, 6634, 6646, 6658, 3423, 3431,
 6692, 6726, 6738,    0,    0,    0, 1690, 3435, 6743, 6777,
 6789, 6801, 6835, 3440, 3471, 6847, 6881,    0,    0,    0,
    0, 1857, 3475, 6886, 3479, 6920, 6932, 6944, 6956, 3483,
 6983, 3488, 3492, 7017, 7029, 7063, 7075, 3496, 7109, 7121,
 7133, 3528, 3532, 7167, 7179, 7213, 7225, 3536, 7259, 7271,
 7283, 3546, 3540, 7310, 7344, 7356,    0,    0,    0, 1859,
 3550, 7368, 7380, 7392, 7404, 3555, 3621, 7438, 7472, 7484,
    0,    0,    0, 1876, 3625, 7489, 7523, 7535, 7547, 7581,
 3630, 3638, 7593, 7627,    0,    0,    0,    0, 2292, 3642,
 7632, 3646, 7666, 7678, 7690, 7702, 3663, 7729, 3667, 3681,
 7763, 7775, 7809, 7821, 3685, 7855, 7867, 7879, 3711,  290,
    0,  275, 3715, 3711, 3757, 7913, 7925, 7937, 7971, 7983,
 7995, 1211, 3765, 8029, 8041, 8053, 8087, 8099, 8111, 1230,
 3771, 8145, 8157, 8169, 8203, 8215, 3843, 3775, 3835,    0,
 3881, 3886, 3679, 3892, 3920, 1316, 3927,    0, 3933, 3938,
 3965, 3963, 3968, 1547, 3974,    0, 4007, 4012, 4024, 4034,
 4046,  275,  255, 3839, 4047,  280, 2775, 8227, 8232, 4128,
 4132,  270, 3035, 8266, 8271, 4136, 4140,  250, 3240, 8305,
 8310, 4174, 4178, 4182, 8337, 4186, 8364, 4213, 4217, 4221,
 8391, 4225, 8418, 4240, 4244, 4248, 8445, 4252, 8472, 4338,
  213,  197, 4344,    0,  200, 4350,    0, 4393, 4399, 4423,
 4429, 4435, 4457, 4463, 4467, 4471, 4507, 4511, 4515, 9853,
 8507, 8516, 8525, 8534, 8543, 8549, 8556, 8565, 8574, 8583,
 8592, 8600, 8609, 8618, 8626,  220, 8633, 8642, 8651, 8660,
  215, 8669, 8678, 8687, 8696, 8705, 8714,  156, 8722, 8731,
 8737, 8744, 8753, 8761,  150, 8768, 8777, 8786, 8795,  103,
 8804, 8813, 8822, 8831, 8840, 8849, 8858, 8866, 8873, 8882,
 8891, 8900, 8909, 8918, 8927, 8936, 8945, 8954, 8963, 8972,
 8981, 8990, 8999, 9008, 9017, 9026, 9035, 9044, 9050, 9057,
 9066, 9075, 9084, 9092, 9099, 9108, 9117, 9126, 9135, 9144,
 9153, 9162, 9171, 9180, 9189, 9198, 9207, 9216, 9225, 9234,
 9243, 9252, 9261, 9270, 9276, 9283, 9292, 9301,    5, 9310,
 9319, 9327, 9334, 9343, 9352, 9361, 9370, 9379, 9388, 9397,
 9406, 9415, 9424, 9433, 9442, 9451, 9460, 9469, 9478, 9487,
 9496, 9505, 9514, 9523, 9532, 9538, 9545, 9554, 9563,    4,
 9571, 9578, 9587, 9596, 9605, 9614, 9623, 9632, 9641, 9650,
 9659, 9668, 9677, 9686, 9695, 9704, 9713, 9722, 9731, 9740,
 9749, 9758, 9767, 9773, 9780, 9789, 9798, 9807, 9816, 9825,
 9834, 9843
};


const short int Lexer::def[1183] =
{   0,
 1021, 1021, 1020,    3, 1021, 1021, 1021,    7,    7,    7,
    7,    7,    7,    7,    7,    7, 1022, 1022,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7, 1023, 1023,    7,    7,    7,    7, 1024, 1024,
 1024, 1024,    7,    7, 1020, 1020, 1020, 1020, 1025, 1026,
 1025, 1020, 1026, 1026, 1026, 1026, 1026, 1026, 1026, 1026,
 1026, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020,   72, 1020, 1020, 1020, 1020, 1020, 1020, 1027,
 1020, 1028, 1027, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1029, 1020, 1030,
 1029, 1020, 1020, 1020, 1020, 1020, 1020, 1031, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1025, 1020, 1032,
 1025, 1025, 1025, 1025, 1026, 1026, 1026, 1026, 1026, 1026,
 1026, 1026, 1026, 1026, 1026, 1020, 1020, 1020, 1020,   67,
   67, 1020, 1033,  151, 1020, 1020,   70, 1020, 1020, 1020,
   73, 1020, 1034, 1035, 1020, 1036, 1020,   79,   79, 1020,
 1037,  169, 1020, 1027, 1028, 1028, 1027, 1020,   86, 1020,
 1020, 1020, 1020,   89,   89, 1020, 1038,  185, 1020, 1020,
   92,   92, 1020, 1039,  192, 1020, 1020,   95,   95, 1020,
 1040,  199, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1041, 1020, 1020,  213, 1020, 1042,  214, 1020, 1043, 1044,
 1044, 1043, 1020, 1020,  224, 1020, 1045,  225, 1020, 1020,
 1020,  231, 1020, 1046,  232, 1020, 1047, 1020, 1020, 1020,
 1020, 1048, 1049, 1049, 1049, 1050, 1051, 1051, 1051, 1051,
 1051, 1051, 1051, 1051, 1020, 1020, 1020, 1020, 1020, 1052,
 1052,  261,  261,  261,  261, 1020, 1020, 1020, 1020, 1020,
 1020,  271, 1053, 1053, 1053, 1053, 1053,  277, 1054, 1055,
 1020, 1020, 1020, 1056, 1056,  285,  285,  285,  285, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1057, 1057,  298,  298,
  298,  298, 1020, 1020, 1020, 1020, 1020, 1058, 1058,  309,
  309,  309,  309, 1020, 1020, 1020, 1020, 1020, 1059, 1059,
  320,  320,  320,  320, 1020, 1020, 1020, 1020, 1060, 1020,
 1020, 1020, 1061, 1061,  334,  334,  334,  334, 1020, 1020,
 1020, 1020, 1020, 1062, 1062,  345,  345,  345,  345, 1020,
 1020, 1020, 1020, 1020, 1063, 1063,  356,  356,  356,  356,
 1020, 1020, 1048, 1050, 1051, 1051, 1051, 1051, 1051, 1051,
 1020, 1020,  259, 1020, 1064,  373, 1020, 1065, 1020, 1066,
 1065,  381, 1020, 1067, 1068, 1069, 1020, 1070, 1069, 1020,
 1020, 1071,  390, 1020, 1072, 1020, 1073, 1072,  398, 1020,
 1020, 1020, 1074, 1074, 1020, 1020, 1075,  405, 1020, 1076,
 1020, 1077, 1076,  413, 1020, 1020, 1078,  415, 1020, 1079,
 1020, 1080, 1079,  423, 1020, 1020, 1081,  425, 1020, 1082,
 1020, 1083, 1082,  433, 1020, 1020, 1020, 1084, 1084, 1020,
 1020, 1085,  440, 1020, 1086, 1020, 1087, 1086,  448, 1088,
 1089, 1089, 1089, 1089, 1089, 1089, 1020, 1020, 1020, 1020,
 1090, 1090,  462,  462,  462,  462, 1020, 1020, 1091, 1091,
  470, 1092, 1020, 1020, 1020, 1092,  476,  476,  476,  476,
  476,  470,  471, 1020, 1020, 1020, 1093, 1093, 1093, 1093,
 1093,  491, 1094, 1095, 1095,  495, 1096, 1020, 1020,  499,
 1096, 1096, 1096, 1096, 1096,  505,  495,  507,  507, 1020,
 1020, 1020, 1097, 1097,  514,  514,  514,  514, 1020, 1020,
 1098, 1098,  522, 1099, 1020, 1020, 1020, 1099,  528,  528,
  528,  528,  528,  522,  522, 1020, 1020, 1100, 1100, 1020,
 1020, 1020, 1101, 1101,  544,  544,  544,  544, 1020, 1020,
 1102, 1102,  552, 1103, 1020, 1020, 1020, 1103,  558,  558,
  558,  558,  558,  552,  553, 1020, 1020, 1020, 1104, 1104,
  570,  570,  570,  570, 1020, 1020, 1105, 1105,  578, 1106,
 1020, 1020, 1020, 1106,  584,  584,  584,  584,  584,  578,
  579, 1020, 1020, 1020, 1107, 1107,  596,  596,  596,  596,
 1020, 1020, 1108, 1108,  604, 1109, 1020, 1020, 1020, 1109,
  610,  610,  610,  610,  610,  604,  604, 1020, 1020, 1110,
 1110, 1020, 1020, 1020, 1111, 1111,  626,  626,  626,  626,
 1020, 1020, 1112, 1112,  634, 1113, 1020, 1020, 1020, 1113,
  640,  640,  640,  640,  640,  634,  635, 1114, 1115, 1115,
 1115, 1115, 1020, 1020, 1020, 1116, 1116, 1117, 1117,  659,
 1020,  661, 1020, 1118, 1118, 1119, 1120, 1121, 1121, 1122,
 1123, 1020, 1020, 1124,  672, 1020, 1125, 1020, 1126, 1125,
  680, 1127, 1127, 1020, 1128,  683,  683, 1020, 1126,  688,
 1020, 1129, 1128, 1129,  694, 1020, 1020, 1020, 1130, 1130,
 1131, 1131,  702, 1020,  704, 1020, 1132, 1132, 1020, 1020,
 1020, 1133, 1133, 1134, 1134,  715, 1020,  717, 1020, 1135,
 1135, 1020, 1020, 1136,  722, 1020, 1137, 1020, 1138, 1137,
  730, 1139, 1139, 1020, 1140,  733,  733, 1020, 1138,  738,
 1020, 1141, 1140, 1141,  744, 1020, 1020, 1020, 1142, 1142,
 1143, 1143,  752, 1020,  754, 1020, 1144, 1144, 1145, 1146,
 1146, 1146, 1146, 1020, 1020, 1147, 1147, 1148, 1148, 1020,
 1020, 1149, 1149, 1150, 1020,  775,  775, 1020,  778,  778,
 1151, 1020,  782,  782, 1020, 1020, 1020, 1152, 1152,  789,
  789,  789,  789, 1020, 1020, 1153, 1153,  797, 1020, 1020,
 1020, 1154, 1154,  803,  803,  803,  803,  797,  798, 1155,
 1155,  811, 1156, 1020, 1020, 1020, 1156,  817,  817,  817,
  817,  817,  811,  812, 1020, 1020, 1157, 1157,  828,  828,
  829, 1020, 1020, 1158, 1158, 1159, 1159, 1020, 1020, 1160,
 1160, 1020, 1020, 1161, 1161, 1162, 1162, 1020, 1020, 1163,
 1163, 1020, 1020, 1020, 1164, 1164,  856,  856,  856,  856,
 1020, 1020, 1165, 1165,  864, 1020, 1020, 1020, 1166, 1166,
  870,  870,  870,  870,  864,  865, 1167, 1167,  878, 1168,
 1020, 1020, 1020, 1168,  884,  884,  884,  884,  884,  878,
  879, 1020, 1020, 1169, 1169,  895,  895,  896, 1020, 1020,
 1170, 1170, 1171, 1171, 1020, 1020, 1172, 1172, 1173, 1174,
 1174, 1174, 1020, 1020, 1020, 1175, 1175, 1176, 1176,  919,
 1020,  921, 1020, 1177, 1177, 1178, 1178,  927, 1020,  929,
 1020, 1179, 1179, 1180, 1180,  935, 1020, 1020, 1020,  856,
  856,  865,  864,  864,  868,  945, 1020,  870,  870,  879,
  878,  878,  883,  953, 1020,  884,  884,  896,  895,  895,
 1173, 1174, 1174, 1020, 1020,  917,  917,  919,  919, 1020,
  922,  925,  925,  927,  927, 1020,  930,  933,  933,  935,
  935, 1020, 1020,  856,  856,  864,  865, 1020,  946,  870,
  870,  878,  879, 1020,  954,  884,  884,  895,  896, 1173,
 1174, 1174, 1173, 1174, 1174, 1173, 1174, 1173, 1173, 1181,
 1181, 1181, 1020, 1181, 1020, 1182, 1182, 1182, 1182,    0,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020
};


const short int Lexer::nxt[9900] =
{   0,
 1020,   47,   48,   47, 1020, 1020,   49,   47,   48,   47,
  774,  774,   49,   46,   47,   48,   47,   50,   46,   51,
   46,   46,   52,   46,   46,   46,   50,   50,   53,   54,
   50,   55,   50,   50,   50,   50,   56,   57,   50,   58,
   59,   50,   50,   46,   46,   46,   50,   60,   61,   50,
   50,   50,   50,   50,   50,   50,   50,   50,   50,   47,
   48,   47,  143,  144,   51,   68,   69,   70,   70,   70,
   70,  119, 1020, 1020,  120,   62,   63,   68,   69,   70,
   70,   70,   70,  273,   64,   47,   48,   47, 1020, 1020,
   51,   71,   46,   72,   73,   73,   73, 1020,  487,  273,
  121,   62,   63,   71,   46,   72,   73,   73,   73,  329,
   64,   47,   48,   47,  487, 1020,   51,   65,   66,   67,
   67,   67,   67,  149,  150,  150,  150,  150,   63,   74,
   46,   75,   76,   76,   76,   74,   46,   75,   76,   76,
   76,   77,   78,   79,   79,   79,   79,   77,   78,   79,
   79,   79,   79,   47,   48,   47,  280,   81,   82,   47,
   48,   47,  363,   81,   82,  650,  126,  127,  126,  651,
   83,  128,  151,  151,  151,  151,   83,   84,   85,   86,
   86,   86,   86,   84,   85,   86,   86,   86,   86,   87,
   88,   89,   89,   89,   89,   87,   88,   89,   89,   89,
   89,   90,   91,   92,   92,   92,   92,   90,   91,   92,
   92,   92,   92,   93,   94,   95,   95,   95,   95,  119,
  119,  329,  120,  122,   96,  119,  280,  129,  122,  129,
  273, 1020,  130, 1007, 1005, 1004,   97, 1020,   98,   93,
   94,   95,   95,   95,   95,  501,  273, 1020,  121,  121,
   96,  132,  127,  132,  121, 1020,  133,  820,  132,  127,
  132,  501,   97,  133,   98,   99,  100,  101,  101,  101,
  101,  156,  157,  157,  157,  157,   96,  805,  134,  158,
  158,  158,  158,  161,  161,  161,  161,  791,   97, 1002,
   98,   99,  100,  101,  101,  101,  101,  165,  165,  165,
  165, 1001,   96,  165,  165,  165,  165,  165,  165,  165,
  165,  963,  962,  912,   97,  911,   98,  102,   46,  103,
  104,  104,  104,  166,  169,  169,  169,  169,   96,  167,
  168,  168,  168,  168,  178,  179,  179,  179,  179,  166,
   97,  910,   98,  102,   46,  103,  104,  104,  104, 1020,
  763,  132,  127,  132,   96,  131,  176,  180,  180,  180,
  180,  183,  184,  184,  184,  184,   97, 1020,   98,  105,
  106,  107,  107,  107,  107,  185,  185,  185,  185,  762,
   96,  190,  191,  191,  191,  191,  192,  192,  192,  192,
  761,  238,   97,  760,   98,  105,  106,  107,  107,  107,
  107,  197,  198,  198,  198,  198,   96,  199,  199,  199,
  199,  205,  206,  206,  206,  206,  652,  239,   97, 1020,
   98,   47,   48,   47,  240,  109,  110,  207,  207,  207,
  207,  210,  210,  210,  210,  649,  457, 1020,  111,  210,
  210,  210,  210,  210,  210,  210,  210,  456,  455,  454,
   97, 1020,   98,   47,   48,   47,  453,  109,  110,  211,
  212,  213,  213,  213,  213,  214,  214,  214,  214, 1020,
  111,  225,  225,  225,  225,  211,  223,  224,  224,  224,
  224,  452,   97,  451,   98,  112,  113,  114,  114,  114,
  114,  230,  231,  231,  231,  231,   96,  232,  232,  232,
  232,  241,  241,  241,  241,  273,  372,  371,   97,  370,
   98,  112,  113,  114,  114,  114,  114,  241,  241,  241,
  241,  273,   96,  241,  241,  241,  241,  126,  127,  126,
  369,  273,  128,  368,   97, 1020,   98,  115,  116,  117,
  117,  117,  117,  242,  129,  367,  129,  273,   96,  130,
  132,  127,  132, 1020,  366,  133,  129,  487,  129,  242,
   97,  130,   98,  115,  116,  117,  117,  117,  117,  487,
  244,  365,  244,  487,   96,  245,  132,  127,  132,  256,
  255,  133,  132,  127,  132,  487,   97,  133,   98,  123,
   46,  124,  125,  125,  125,  151,  151,  151,  151, 1020,
   46,  123,   46,  124,  125,  125,  125, 1020,  151,  151,
  151,  151,   46,  152,  152,  152, 1020, 1020,  153,  254,
  154,  150,  150,  150,  150,  132,  127,  132,  155,  273,
  133,  132,  127,  132, 1020,  266,  133,  267,  267,  267,
  267,  158,  158,  158,  158,  273,  155,  159,  157,  157,
  157,  157,  403,  253,  246,  160,  158,  158,  158,  158,
  404,  252, 1020,  160,  158,  158,  158,  158,  165,  165,
  165,  165,  251,  160,  162,  162,  162, 1020,  404,  163,
 1020,  160,  161,  161,  161,  161,  268,  250,  269,  269,
  269,  269,  162,  162,  162, 1020,  249,  163,  169,  169,
  169,  169,  164, 1020,  169,  169,  169,  169,  290,  273,
  291,  291,  291,  291,  180,  180,  180,  180,  164,  170,
  170,  170,  248,  247,  171,  273,  172,  168,  168,  168,
  168,  132,  127,  132,  173,  131,  176,  132,  127,  132,
  438,  131,  176,  180,  180,  180,  180,  222,  439,  204,
  182,  177,  173,  181,  179,  179,  179,  179,  148, 1020,
 1020,  182,  180,  180,  180,  180,  439,  292,  182,  293,
  293,  293,  293,  185,  185,  185,  185, 1020, 1020,  182,
  186,  186,  186,  147, 1020,  187,  656,  188,  184,  184,
  184,  184,  146, 1020,  657,  189, 1020,  185,  185,  185,
  185,  303, 1020,  304,  304,  304,  304,  192,  192,  192,
  192, 1020,  657,  189,  193,  193,  193,  145, 1020,  194,
  664,  195,  191,  191,  191,  191,  142, 1020,  665,  196,
 1020,  192,  192,  192,  192,  314, 1020,  315,  315,  315,
  315,  199,  199,  199,  199, 1020,  665,  196,  200,  200,
  200,  141, 1020,  201,  699,  202,  198,  198,  198,  198,
  140, 1020,  700,  203, 1020,  199,  199,  199,  199,  325,
 1020,  326,  326,  326,  326,  207,  207,  207,  207, 1020,
  700,  203,  208,  206,  206,  206,  206,  707,  139,  138,
  209,  207,  207,  207,  207,  708,  207,  207,  207,  207,
  137,  136,  327,  209,  328,  328,  328,  328,  209,  215,
  215,  215, 1020,  708,  216, 1020,  217,  213,  213,  213,
  213,  209, 1020, 1020,  218,  210,  210,  210,  210,  214,
  214,  214,  214, 1020,  214,  214,  214,  214,  225,  225,
  225,  225,  218,  132,  127,  132, 1020,  131,  221,  339,
 1020,  340,  340,  340,  340, 1020,  225,  225,  225,  225,
  350, 1020,  351,  351,  351,  351,  232,  232,  232,  232,
 1020,  712,  131, 1020,  131,  226,  226,  226, 1020,  713,
  227,  720,  228,  224,  224,  224,  224, 1020, 1020,  721,
  229, 1020,  232,  232,  232,  232,  361,  713,  362,  362,
  362,  362,  241,  241,  241,  241,  501,  721,  229,  233,
  233,  233, 1020, 1020,  234, 1020,  235,  231,  231,  231,
  231,  244,  501,  244,  236,  244,  245,  244, 1020,  244,
  245,  244,  749,  757,  245,  258,  259,  259,  259,  259,
  750,  758,  236,  152,  152,  152, 1020, 1020,  153,  257,
  258,  259,  259,  259,  259,  261,  152,  261,  750,  758,
  262,  263,  264,  265,  265,  265,  265,  162,  162,  162,
  501, 1020,  163,  270, 1020,  271,  272,  272,  272,  274,
  162,  274, 1020, 1020,  275,  276,  501,  277,  278,  278,
  278,  170,  170,  170, 1020, 1020,  171,  281,  282,  283,
  283,  283,  283,  285,  170,  285, 1020, 1020,  286,  287,
  288,  289,  289,  289,  289,  186,  186,  186, 1020, 1020,
  187,  294,  295,  296,  296,  296,  296,  298,  186,  298,
 1020, 1020,  299,  300,  301,  302,  302,  302,  302,  193,
  193,  193, 1020, 1020,  194,  305,  306,  307,  307,  307,
  307,  309,  193,  309, 1020, 1020,  310,  311,  312,  313,
  313,  313,  313,  200,  200,  200, 1020, 1020,  201,  316,
  317,  318,  318,  318,  318,  320,  200,  320, 1020, 1020,
  321,  322,  323,  324,  324,  324,  324,  208,  206,  206,
  206,  206,  132,  127,  132,  209, 1020,  133,  373,  373,
  373,  373,  267,  267,  267,  267,  269,  269,  269,  269,
 1020,  364, 1020,  209,  215,  215,  215, 1020,  916,  216,
 1020,  217,  213,  213,  213,  213,  917, 1020, 1020,  218,
  269,  269,  269,  269,  272,  272,  272,  272,  162,  162,
  162, 1020, 1020,  163,  917, 1020, 1020,  218,  215,  215,
  215, 1020, 1020,  216,  330,  331,  332,  332,  332,  332,
  334,  215,  334, 1020, 1020,  335,  336,  337,  338,  338,
  338,  338,  132,  127,  132, 1020,  131,  221,  282,  283,
  283,  283,  283,  390,  390,  390,  390,  291,  291,  291,
  291,  293,  293,  293,  293,  293,  293,  293,  293, 1020,
 1020,  131, 1020,  131,  132,  127,  132, 1020,  131,  221,
  295,  296,  296,  296,  296,  400,  400,  400,  400,  304,
  304,  304,  304,  306,  307,  307,  307,  307,  405,  405,
  405,  405, 1020,  131, 1020,  131,  226,  226,  226, 1020,
 1020,  227, 1020,  228,  224,  224,  224,  224, 1020, 1020,
 1020,  229,  315,  315,  315,  315,  317,  318,  318,  318,
  318,  415,  415,  415,  415,  326,  326,  326,  326,  229,
  226,  226,  226, 1020, 1020,  227,  341,  342,  343,  343,
  343,  343,  345,  226,  345, 1020, 1020,  346,  347,  348,
  349,  349,  349,  349,  233,  233,  233, 1020, 1020,  234,
 1020,  235,  231,  231,  231,  231, 1020, 1020, 1020,  236,
  328,  328,  328,  328,  328,  328,  328,  328,  331,  332,
  332,  332,  332,  425,  425,  425,  425,  236,  233,  233,
  233, 1020, 1020,  234,  352,  353,  354,  354,  354,  354,
  356,  233,  356, 1020, 1020,  357,  358,  359,  360,  360,
  360,  360,  374,  374,  374, 1020, 1020,  375, 1020,  376,
  259,  259,  259,  259, 1020, 1020, 1020,  377,  340,  340,
  340,  340,  342,  343,  343,  343,  343,  435,  435,  435,
  435,  351,  351,  351,  351,  377,  261,  152,  261, 1020,
 1020,  262,  263,  264,  265,  265,  265,  265,  261,  152,
  261, 1020, 1020,  262,  263,  264,  265,  265,  265,  265,
  378,  379,  378, 1020, 1020,  380, 1020,  381,  353,  354,
  354,  354,  354, 1020, 1020,  382,  440,  440,  440,  440,
  362,  362,  362,  362, 1020,  373,  373,  373,  373,  400,
  400,  400,  400,  382,  152,  152,  152, 1020, 1020,  153,
 1020, 1020,  267,  267,  267,  267,  383,  383,  383, 1020,
 1020,  384, 1020, 1020,  272,  272,  272,  272,  132,  127,
  132, 1020,  467,  133,  468,  468,  468,  468,  383,  383,
  383, 1020, 1020,  384,  385,  519,  450,  520,  520,  520,
  520,  400,  400,  400,  400, 1020, 1020, 1020,  402, 1020,
  385,  274,  162,  274, 1020, 1020,  275,  276, 1020,  277,
  278,  278,  278,  274,  162,  274,  402, 1020,  275,  276,
 1020,  277,  278,  278,  278,  274,  162,  274, 1020, 1020,
  275,  276, 1020,  277,  278,  278,  278,  274,  162,  274,
 1020, 1020,  275,  276, 1020,  277,  278,  278,  278,  386,
  387,  386, 1020, 1020,  388,  276, 1020,  277,  278,  278,
  278,  536, 1020,  537,  537,  537,  537,  549, 1020,  550,
  550,  550,  550, 1020, 1020, 1020,  575,  389,  576,  576,
  576,  576,  601, 1020,  602,  602,  602,  602,  435,  435,
  435,  435, 1020,  389,  391,  391,  391, 1020,  924,  392,
 1020,  393,  283,  283,  283,  283,  925, 1020,  618,  394,
  619,  619,  619,  619,  653,  653,  653,  653,  435,  435,
  435,  435, 1020, 1020,  925,  437, 1020,  394,  285,  170,
  285, 1020, 1020,  286,  287,  288,  289,  289,  289,  289,
  285,  170,  285,  437, 1020,  286,  287,  288,  289,  289,
  289,  289,  395,  396,  395, 1020, 1020,  397,  631,  398,
  632,  632,  632,  632,  132,  127,  648,  399, 1020,  133,
  459,  460,  460,  460,  460,  468,  468,  468,  468,  474,
  475,  475,  475,  475, 1020,  399,  170,  170,  170, 1020,
 1020,  171, 1020, 1020,  291,  291,  291,  291,  401,  296,
  296,  296,  296, 1020, 1020, 1020,  402,  661,  661,  661,
  661,  483,  483,  483,  483,  486,  486,  486,  486, 1020,
  486,  486,  486,  486,  402,  298,  186,  298, 1020, 1020,
  299,  300,  301,  302,  302,  302,  302,  298,  186,  298,
  666, 1020,  299,  300,  301,  302,  302,  302,  302,  186,
  186,  186, 1020, 1020,  187, 1020,  666,  304,  304,  304,
  304,  406,  406,  406, 1020,  932,  407,  940,  408,  307,
  307,  307,  307,  933, 1020,  941,  409,  486,  486,  486,
  486,  383,  383,  383,  948, 1020,  384,  500,  500,  500,
  500,  933,  949,  941,  409,  309,  193,  309, 1020, 1020,
  310,  311,  312,  313,  313,  313,  313,  309,  193,  309,
  949, 1020,  310,  311,  312,  313,  313,  313,  313,  410,
  411,  410, 1020, 1020,  412, 1020,  413,  511,  512,  512,
  512,  512, 1020, 1020,  414,  672,  672,  672,  672,  520,
  520,  520,  520,  526,  527,  527,  527,  527,  688,  688,
  688,  688,  414,  193,  193,  193, 1020, 1020,  194, 1020,
 1020,  315,  315,  315,  315,  416,  416,  416, 1020, 1020,
  417, 1020,  418,  318,  318,  318,  318, 1020, 1020, 1020,
  419,  535,  535,  535,  535,  537,  537,  537,  537,  537,
  537,  537,  537,  541,  542,  542,  542,  542,  419,  320,
  200,  320, 1020, 1020,  321,  322,  323,  324,  324,  324,
  324,  320,  200,  320, 1020, 1020,  321,  322,  323,  324,
  324,  324,  324,  420,  421,  420, 1020, 1020,  422, 1020,
  423,  696,  696,  696,  696, 1020, 1020, 1020,  424,  550,
  550,  550,  550,  556,  557,  557,  557,  557,  704,  704,
  704,  704,  565,  565,  565,  565,  424,  200,  200,  200,
 1020, 1020,  201, 1020, 1020,  326,  326,  326,  326,  426,
  426,  426, 1020, 1020,  427, 1020,  428,  332,  332,  332,
  332, 1020, 1020, 1020,  429,  567,  568,  568,  568,  568,
  709,  709,  709,  709,  576,  576,  576,  576,  717,  717,
  717,  717,  429,  334,  215,  334, 1020, 1020,  335,  336,
  337,  338,  338,  338,  338,  334,  215,  334, 1020, 1020,
  335,  336,  337,  338,  338,  338,  338,  430,  431,  430,
 1020, 1020,  432, 1020,  433,  582,  583,  583,  583,  583,
 1020, 1020,  434,  591,  591,  591,  591,  593,  594,  594,
  594,  594,  722,  722,  722,  722,  602,  602,  602,  602,
  434,  215,  215,  215, 1020, 1020,  216, 1020, 1020,  340,
  340,  340,  340,  436,  343,  343,  343,  343, 1020, 1020,
 1020,  437,  608,  609,  609,  609,  609,  738,  738,  738,
  738,  617,  617,  617,  617,  619,  619,  619,  619,  437,
  345,  226,  345, 1020, 1020,  346,  347,  348,  349,  349,
  349,  349,  345,  226,  345, 1020, 1020,  346,  347,  348,
  349,  349,  349,  349,  226,  226,  226, 1020, 1020,  227,
 1020, 1020,  351,  351,  351,  351,  441,  441,  441, 1020,
 1020,  442, 1020,  443,  354,  354,  354,  354, 1020, 1020,
 1020,  444,  619,  619,  619,  619,  623,  624,  624,  624,
  624,  746,  746,  746,  746,  632,  632,  632,  632,  444,
  356,  233,  356, 1020, 1020,  357,  358,  359,  360,  360,
  360,  360,  356,  233,  356, 1020, 1020,  357,  358,  359,
  360,  360,  360,  360,  445,  446,  445, 1020, 1020,  447,
  956,  448,  638,  639,  639,  639,  639, 1020,  957,  449,
  754,  754,  754,  754,  647,  647,  647,  647,  653,  653,
  653,  653, 1020, 1020, 1020,  655,  957,  449,  233,  233,
  233, 1020, 1020,  234, 1020, 1020,  362,  362,  362,  362,
  374,  374,  374,  655, 1020,  375,  458,  459,  460,  460,
  460,  460,  462,  374,  462, 1020, 1020,  463,  464,  465,
  466,  466,  466,  466,  378,  379,  378, 1020, 1020,  380,
  469,  470,  471,  471,  471,  471,  379,  379,  379, 1020,
 1020,  472,  473,  474,  475,  475,  475,  475,  477,  379,
  477, 1020, 1020,  478,  479,  480,  481,  481,  481,  481,
  378,  379,  378, 1020, 1020,  380,  263,  264,  265,  265,
  265,  265,  261,  152,  261, 1020, 1020,  262,  482, 1020,
  483,  483,  483,  483,  383,  383,  383, 1020, 1020,  384,
  484, 1020,  485,  486,  486,  486,  488,  383,  488, 1020,
 1020,  489,  490, 1020,  491,  492,  492,  492,  386,  387,
  386, 1020, 1020,  388,  494, 1020,  495,  496,  496,  496,
  387,  387,  387, 1020, 1020,  497,  498, 1020,  499,  500,
  500,  500,  502,  387,  502, 1020, 1020,  503,  504, 1020,
  505,  506,  506,  506,  386,  387,  386, 1020, 1020,  388,
  276, 1020,  507,  508,  508,  508,  509,  509,  509,  509,
  509, 1020, 1020, 1020,  132,  127,  132, 1020, 1020,  133,
  653,  653,  653,  653, 1020, 1020,  509,  509,  509,  391,
  391,  391, 1020, 1020,  392, 1020, 1020,  390,  390,  390,
  390,  759, 1020,  764,  394,  765,  765,  765,  765,  770,
 1020,  771,  771,  771,  771,  383,  383,  383, 1020, 1020,
  384, 1020,  394,  391,  391,  391, 1020, 1020,  392,  510,
  511,  512,  512,  512,  512,  514,  391,  514, 1020, 1020,
  515,  516,  517,  518,  518,  518,  518,  395,  396,  395,
 1020, 1020,  397,  521,  522,  523,  523,  523,  523,  396,
  396,  396, 1020, 1020,  524,  525,  526,  527,  527,  527,
  527,  529,  396,  529, 1020, 1020,  530,  531,  532,  533,
  533,  533,  533,  395,  396,  395, 1020, 1020,  397,  287,
  288,  289,  289,  289,  289,  285,  170,  285, 1020, 1020,
  286,  534, 1020,  535,  535,  535,  535,  298,  186,  298,
 1020, 1020,  299,  300,  301,  302,  302,  302,  302,  298,
  186,  298, 1020, 1020,  299,  538,  301,  539,  539,  539,
  539,  406,  406,  406, 1020, 1020,  407, 1020, 1020,  405,
  405,  405,  405, 1020, 1020,  794,  409,  795,  795,  795,
  795,  287,  288,  682,  682,  682,  682,  825, 1020,  826,
  826,  826,  826, 1020,  409,  406,  406,  406, 1020, 1020,
  407,  540,  541,  542,  542,  542,  542,  544,  406,  544,
 1020, 1020,  545,  546,  547,  548,  548,  548,  548,  410,
  411,  410, 1020, 1020,  412,  551,  552,  553,  553,  553,
  553,  411,  411,  411, 1020, 1020,  554,  555,  556,  557,
  557,  557,  557,  559,  411,  559, 1020, 1020,  560,  561,
  562,  563,  563,  563,  563,  410,  411,  410, 1020, 1020,
  412,  311,  312,  313,  313,  313,  313,  309,  193,  309,
 1020, 1020,  310,  564, 1020,  565,  565,  565,  565,  416,
  416,  416,  791,  916,  417, 1020, 1020,  415,  415,  415,
  415,  917, 1020, 1020,  419,  696,  696,  696,  696,  709,
  709,  709,  709,  696,  696,  696,  696, 1020, 1020,  917,
  698, 1020,  419,  416,  416,  416, 1020, 1020,  417,  566,
  567,  568,  568,  568,  568,  570,  416,  570,  698, 1020,
  571,  572,  573,  574,  574,  574,  574,  420,  421,  420,
 1020, 1020,  422,  577,  578,  579,  579,  579,  579,  421,
  421,  421, 1020, 1020,  580,  581,  582,  583,  583,  583,
  583,  585,  421,  585, 1020, 1020,  586,  587,  588,  589,
  589,  589,  589,  420,  421,  420, 1020, 1020,  422,  322,
  323,  324,  324,  324,  324,  320,  200,  320, 1020, 1020,
  321,  590, 1020,  591,  591,  591,  591,  426,  426,  426,
 1020, 1020,  427, 1020, 1020,  425,  425,  425,  425, 1020,
 1020,  832,  429,  833,  833,  833,  833,  838, 1020,  839,
  839,  839,  839,  842, 1020,  843,  843,  843,  843, 1020,
  429,  426,  426,  426, 1020, 1020,  427,  592,  593,  594,
  594,  594,  594,  596,  426,  596, 1020, 1020,  597,  598,
  599,  600,  600,  600,  600,  430,  431,  430, 1020, 1020,
  432,  603,  604,  605,  605,  605,  605,  431,  431,  431,
 1020, 1020,  606,  607,  608,  609,  609,  609,  609,  611,
  431,  611, 1020, 1020,  612,  613,  614,  615,  615,  615,
  615,  430,  431,  430, 1020, 1020,  432,  336,  337,  338,
  338,  338,  338,  334,  215,  334, 1020, 1020,  335,  616,
 1020,  617,  617,  617,  617,  345,  226,  345, 1020, 1020,
  346,  347,  348,  349,  349,  349,  349,  345,  226,  345,
 1020, 1020,  346,  620,  348,  621,  621,  621,  621,  441,
  441,  441,  805,  924,  442, 1020, 1020,  440,  440,  440,
  440,  925, 1020,  848,  444,  849,  849,  849,  849,  746,
  746,  746,  746,  709,  709,  709,  709, 1020, 1020,  925,
  711, 1020,  444,  441,  441,  441, 1020, 1020,  442,  622,
  623,  624,  624,  624,  624,  626,  441,  626,  711, 1020,
  627,  628,  629,  630,  630,  630,  630,  445,  446,  445,
 1020, 1020,  447,  633,  634,  635,  635,  635,  635,  446,
  446,  446, 1020, 1020,  636,  637,  638,  639,  639,  639,
  639,  641,  446,  641, 1020, 1020,  642,  643,  644,  645,
  645,  645,  645,  445,  446,  445, 1020, 1020,  447,  358,
  359,  360,  360,  360,  360,  356,  233,  356, 1020, 1020,
  357,  646, 1020,  647,  647,  647,  647,  654,  460,  460,
  460,  460, 1020, 1020,  861,  655,  862,  862,  862,  862,
  336,  337,  732,  732,  732,  732,  892, 1020,  893,  893,
  893,  893, 1020,  655,  462,  374,  462, 1020, 1020,  463,
  464,  465,  466,  466,  466,  466,  462,  374,  462, 1020,
 1020,  463,  464,  465,  466,  466,  466,  466,  374,  374,
  374, 1020, 1020,  375, 1020, 1020,  468,  468,  468,  468,
  261,  152,  261, 1020, 1020,  262,  263,  470,  471,  471,
  471,  471,  261,  152,  261, 1020, 1020,  262,  263,  264,
  658,  658,  658,  658,  378,  379,  378,  820,  932,  380,
 1020,  659,  471,  471,  471,  471,  933, 1020,  899,  660,
  900,  900,  900,  900,  765,  765,  765,  765,  746,  746,
  746,  746, 1020, 1020,  933,  748, 1020,  660,  477,  379,
  477, 1020, 1020,  478,  479,  480,  481,  481,  481,  481,
  374,  374,  374,  748, 1020,  375, 1020,  662,  475,  475,
  475,  475, 1020, 1020,  905,  663,  906,  906,  906,  906,
  132,  127,  132, 1020, 1020,  133,  765,  765,  765,  765,
  909, 1020, 1020,  663,  477,  379,  477, 1020, 1020,  478,
  479,  480,  481,  481,  481,  481,  381,  483,  483,  483,
  483, 1020, 1020, 1020,  382,  771,  771,  771,  771,  383,
  383,  383, 1020, 1020,  384,  786,  787,  787,  787,  787,
 1020, 1020,  382,  488,  383,  488, 1020, 1020,  489,  490,
 1020,  491,  492,  492,  492,  488,  383,  488, 1020, 1020,
  489,  490, 1020,  491,  492,  492,  492,  488,  383,  488,
 1020, 1020,  489,  490, 1020,  491,  492,  492,  492,  488,
  383,  488, 1020, 1020,  489,  490, 1020,  491,  492,  492,
  492,  488,  383,  488, 1020, 1020,  489,  490, 1020,  491,
  492,  492,  492,  913,  913,  913,  913,  795,  795,  795,
  795,  800,  801,  801,  801,  801, 1020, 1020, 1020,  667,
  921,  921,  921,  921,  809,  809,  809,  809,  815,  816,
  816,  816,  816, 1020, 1020,  667,  274,  162,  274, 1020,
 1020,  275,  276, 1020,  668,  496,  496,  496,  386,  387,
  386, 1020, 1020,  388,  276, 1020,  668,  496,  496,  496,
  929,  929,  929,  929,  824,  824,  824,  824,  826,  826,
  826,  826,  831,  831,  831,  831,  669,  833,  833,  833,
  833,  833,  833,  833,  833,  839,  839,  839,  839, 1020,
 1020, 1020,  669,  502,  387,  502, 1020, 1020,  503,  504,
 1020,  505,  506,  506,  506,  383,  383,  383, 1020, 1020,
  384, 1020, 1020,  500,  500,  500,  500,  843,  843,  843,
  843,  843,  843,  843,  843,  849,  849,  849,  849,  937,
  937,  937,  937,  670,  853,  854,  854,  854,  854,  862,
  862,  862,  862,  867,  868,  868,  868,  868, 1020,  670,
  502,  387,  502, 1020, 1020,  503,  504, 1020,  505,  506,
  506,  506,  502,  387,  502, 1020, 1020,  503,  504, 1020,
  505,  506,  506,  506,  502,  387,  502, 1020, 1020,  503,
  504, 1020,  505,  506,  506,  506,  502,  387,  502, 1020,
 1020,  503,  504, 1020,  505,  506,  506,  506,  502,  387,
  502, 1020, 1020,  503,  504, 1020,  505,  506,  506,  506,
  945,  945,  945,  945,  876,  876,  876,  876,  882,  883,
  883,  883,  883, 1020, 1020, 1020,  671,  953,  953,  953,
  953,  891,  891,  891,  891,  893,  893,  893,  893, 1020,
 1020, 1020,  671,  507,  508,  508,  508,  509,  509,  509,
  509,  509,  898,  898,  898,  898,  900,  900,  900,  900,
  727,  728,  727,  389, 1020,  729, 1020,  509,  509,  509,
  900,  900,  900,  900,  906,  906,  906,  906, 1020,  389,
  673,  673,  673, 1020, 1020,  674, 1020,  675,  512,  512,
  512,  512,  132,  127,  132,  676, 1020,  133, 1020,  961,
  913,  913,  913,  913,  913,  913,  913,  913, 1020, 1020,
 1020,  915, 1020,  676,  514,  391,  514, 1020, 1020,  515,
  516,  517,  518,  518,  518,  518,  514,  391,  514,  915,
 1020,  515,  516,  517,  518,  518,  518,  518,  677,  678,
  677, 1020, 1020,  679,  964,  680,  965,  965,  965,  965,
 1020, 1020,  970,  681,  971,  971,  971,  971,  976, 1020,
  977,  977,  977,  977,  937,  937,  937,  937, 1020, 1020,
 1020,  681,  391,  391,  391, 1020, 1020,  392, 1020, 1020,
  520,  520,  520,  520,  285,  170,  285, 1020, 1020,  286,
  287,  522,  523,  523,  523,  523,  285,  170,  285, 1020,
 1020,  286,  287,  288,  682,  682,  682,  682,  683,  684,
  683, 1020, 1020,  685, 1020,  686,  523,  523,  523,  523,
 1020, 1020,  982,  687,  983,  983,  983,  983,  965,  965,
  965,  965,  937,  937,  937,  937, 1020, 1020, 1020,  939,
 1020,  687,  529,  396,  529, 1020, 1020,  530,  531,  532,
  533,  533,  533,  533,  678,  678,  678,  939, 1020,  689,
 1020,  690,  527,  527,  527,  527, 1020, 1020,  984,  691,
  985,  985,  985,  985,  730,  942,  942,  942,  942,  986,
 1020,  987,  987,  987,  987, 1020, 1020,  691,  529,  396,
  529, 1020, 1020,  530,  531,  532,  533,  533,  533,  533,
  692,  684,  692, 1020, 1020,  693, 1020,  694, 1020,  945,
  945,  945,  945, 1020,  988,  695,  989,  989,  989,  989,
  990, 1020,  991,  991,  991,  991,  433,  950,  950,  950,
  950, 1020, 1020,  695,  395,  396,  395, 1020, 1020,  397,
 1020,  398,  535,  535,  535,  535,  733,  734,  733,  399,
  992,  735,  993,  993,  993,  993, 1020,  953,  953,  953,
  953,  994, 1020,  995,  995,  995,  995,  399,  298,  186,
  298, 1020, 1020,  299,  300,  301,  539,  539,  539,  539,
  298,  186,  298, 1020, 1020,  299,  300,  403,  539,  539,
  539,  539, 1020, 1020,  996,  404,  997,  997,  997,  997,
  744,  958,  958,  958,  958,  742,  734,  742, 1020, 1020,
  743, 1020, 1020,  404,  697,  542,  542,  542,  542, 1020,
 1020,  998,  698,  999,  999,  999,  999,  132,  127,  132,
 1020, 1020,  133, 1020, 1020, 1000,  965,  965,  965,  965,
  698,  544,  406,  544, 1020, 1020,  545,  546,  547,  548,
  548,  548,  548,  544,  406,  544, 1020, 1020,  545,  546,
  547,  548,  548,  548,  548,  406,  406,  406, 1020, 1020,
  407, 1020, 1020,  550,  550,  550,  550,  309,  193,  309,
 1020, 1020,  310,  311,  552,  553,  553,  553,  553,  309,
  193,  309, 1020, 1020,  310,  311,  312,  701,  701,  701,
  701,  410,  411,  410, 1020, 1020,  412, 1020,  702,  553,
  553,  553,  553, 1020, 1020, 1020,  703,  971,  971,  971,
  971,  971,  971,  971,  971,  977,  977,  977,  977,  977,
  977,  977,  977, 1020,  703,  559,  411,  559, 1020, 1020,
  560,  561,  562,  563,  563,  563,  563,  406,  406,  406,
 1020, 1020,  407, 1020,  705,  557,  557,  557,  557, 1020,
 1020, 1020,  706,  983,  983,  983,  983,  983,  983,  983,
  983,  985,  985,  985,  985,  987,  987,  987,  987, 1020,
  706,  559,  411,  559, 1020, 1020,  560,  561,  562,  563,
  563,  563,  563,  413,  565,  565,  565,  565, 1020, 1020,
 1020,  414,  989,  989,  989,  989,  989,  989,  989,  989,
  991,  991,  991,  991,  993,  993,  993,  993, 1020,  414,
  710,  568,  568,  568,  568, 1020, 1020, 1020,  711,  995,
  995,  995,  995,  995,  995,  995,  995,  997,  997,  997,
  997,  999,  999,  999,  999, 1020,  711,  570,  416,  570,
 1020, 1020,  571,  572,  573,  574,  574,  574,  574,  570,
  416,  570, 1020, 1020,  571,  572,  573,  574,  574,  574,
  574,  416,  416,  416, 1020, 1020,  417, 1020, 1020,  576,
  576,  576,  576,  320,  200,  320, 1020, 1020,  321,  322,
  578,  579,  579,  579,  579,  320,  200,  320, 1020, 1020,
  321,  322,  323,  714,  714,  714,  714,  420,  421,  420,
 1020, 1020,  422, 1020,  715,  579,  579,  579,  579,  132,
  127, 1003,  716, 1020,  133,  132,  127,  132, 1020, 1020,
  133,  132,  127,  132, 1020, 1020,  133, 1020, 1020, 1020,
  716,  585,  421,  585, 1020, 1020,  586,  587,  588,  589,
  589,  589,  589,  416,  416,  416, 1020, 1020,  417, 1020,
  718,  583,  583,  583,  583, 1020, 1020, 1006,  719, 1020,
 1020, 1020, 1008, 1020,  132,  127,  132, 1020, 1020,  133,
  132,  127,  132, 1020, 1020,  133,  719,  585,  421,  585,
 1020, 1010,  586,  587,  588,  589,  589,  589,  589,  423,
  591,  591,  591,  591, 1012, 1013, 1012,  424, 1009, 1014,
 1012, 1013, 1012, 1020, 1020, 1014, 1012, 1013, 1012, 1020,
 1020, 1014, 1020, 1020, 1020,  424,  723,  723,  723, 1020,
 1020,  724, 1020,  725,  594,  594,  594,  594, 1015, 1020,
 1015,  726, 1020, 1016, 1012, 1013, 1012, 1020, 1015, 1014,
 1015, 1020, 1018, 1016, 1018, 1020, 1020, 1019, 1020,  726,
  596,  426,  596, 1020, 1020,  597,  598,  599,  600,  600,
  600,  600,  596,  426,  596, 1020, 1020,  597,  598,  599,
  600,  600,  600,  600,  727,  728,  727, 1020, 1018,  729,
 1018,  730, 1018, 1019, 1018, 1020, 1018, 1019, 1018,  731,
 1020, 1019, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  731,  426,  426,
  426, 1020, 1020,  427, 1020, 1020,  602,  602,  602,  602,
  334,  215,  334, 1020, 1020,  335,  336,  604,  605,  605,
  605,  605,  334,  215,  334, 1020, 1020,  335,  336,  337,
  732,  732,  732,  732,  733,  734,  733, 1020, 1020,  735,
 1020,  736,  605,  605,  605,  605, 1020, 1020, 1020,  737,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  737,  611,  431,
  611, 1020, 1020,  612,  613,  614,  615,  615,  615,  615,
  728,  728,  728, 1020, 1020,  739, 1020,  740,  609,  609,
  609,  609, 1020, 1020, 1020,  741, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  741,  611,  431,  611, 1020, 1020,  612,
  613,  614,  615,  615,  615,  615,  742,  734,  742, 1020,
 1020,  743, 1020,  744, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  745, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  745,
  430,  431,  430, 1020, 1020,  432, 1020,  433,  617,  617,
  617,  617, 1020, 1020, 1020,  434, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  434,  345,  226,  345, 1020, 1020,  346,
  347,  348,  621,  621,  621,  621,  345,  226,  345, 1020,
 1020,  346,  347,  438,  621,  621,  621,  621, 1020, 1020,
 1020,  439, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  439,
  747,  624,  624,  624,  624, 1020, 1020, 1020,  748, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  748,  626,  441,  626,
 1020, 1020,  627,  628,  629,  630,  630,  630,  630,  626,
  441,  626, 1020, 1020,  627,  628,  629,  630,  630,  630,
  630,  441,  441,  441, 1020, 1020,  442, 1020, 1020,  632,
  632,  632,  632,  356,  233,  356, 1020, 1020,  357,  358,
  634,  635,  635,  635,  635,  356,  233,  356, 1020, 1020,
  357,  358,  359,  751,  751,  751,  751,  445,  446,  445,
 1020, 1020,  447, 1020,  752,  635,  635,  635,  635, 1020,
 1020, 1020,  753, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
  753,  641,  446,  641, 1020, 1020,  642,  643,  644,  645,
  645,  645,  645,  441,  441,  441, 1020, 1020,  442, 1020,
  755,  639,  639,  639,  639, 1020, 1020, 1020,  756, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  756,  641,  446,  641,
 1020, 1020,  642,  643,  644,  645,  645,  645,  645,  448,
  647,  647,  647,  647, 1020, 1020, 1020,  449, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  449,  462,  374,  462, 1020,
 1020,  463,  464,  465,  466,  466,  466,  466,  462,  374,
  462, 1020, 1020,  463,  766,  465,  767,  767,  767,  767,
  378,  379,  378, 1020, 1020,  380,  263,  381,  658,  658,
  658,  658, 1020, 1020, 1020,  660, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  660,  378,  379,  378, 1020, 1020,  380,
  263,  264,  658,  658,  658,  658,  261,  152,  261, 1020,
 1020,  262,  768, 1020,  769,  769,  769,  769,  374,  374,
  374, 1020, 1020,  375, 1020, 1020,  661,  661,  661,  661,
 1020, 1020, 1020,  663, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  663,  477,  379,  477, 1020, 1020,  478,  479,  480,
  481,  481,  481,  481,  477,  379,  477, 1020, 1020,  478,
  772,  480,  773,  773,  773,  773,  488,  383,  488, 1020,
 1020,  489,  490, 1020,  775,  776,  776,  776,  777,  777,
  777,  777,  777, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  777,  777,
  777,  386,  387,  386, 1020, 1020,  388,  276, 1020,  668,
  496,  496,  496, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  389,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  389,  386,  387,  386, 1020,
 1020,  388,  276, 1020,  778,  779,  779,  779,  780,  780,
  780,  780,  780, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  780,  780,
  780,  502,  387,  502, 1020, 1020,  503,  504, 1020,  782,
  783,  783,  783,  784,  784,  784,  784,  784, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  784,  784,  784,  673,  673,  673, 1020,
 1020,  674, 1020, 1020,  672,  672,  672,  672, 1020, 1020,
 1020,  676, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  676,
  673,  673,  673, 1020, 1020,  674,  785,  786,  787,  787,
  787,  787,  789,  673,  789, 1020, 1020,  790,  791,  792,
  793,  793,  793,  793,  677,  678,  677, 1020, 1020,  679,
  796,  797,  798,  798,  798,  798,  678,  678,  678, 1020,
 1020,  689,  799,  800,  801,  801,  801,  801,  803,  678,
  803, 1020, 1020,  804,  805,  806,  807,  807,  807,  807,
  677,  678,  677, 1020, 1020,  679,  516,  517,  518,  518,
  518,  518,  514,  391,  514, 1020, 1020,  515,  808, 1020,
  809,  809,  809,  809,  683,  684,  683, 1020, 1020,  685,
  287,  398,  682,  682,  682,  682, 1020, 1020, 1020,  687,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  687,  683,  684,
  683, 1020, 1020,  685,  810,  811,  812,  812,  812,  812,
  684,  684,  684, 1020, 1020,  813,  814,  815,  816,  816,
  816,  816,  818,  684,  818, 1020, 1020,  819,  820,  821,
  822,  822,  822,  822,  285,  170,  285, 1020, 1020,  286,
  823,  288,  824,  824,  824,  824,  678,  678,  678, 1020,
 1020,  689, 1020, 1020,  688,  688,  688,  688, 1020, 1020,
 1020,  691, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  691,
  803,  678,  803, 1020, 1020,  804,  805,  806,  807,  807,
  807,  807,  692,  684,  692, 1020, 1020,  693,  827,  828,
  829,  829,  829,  829,  818,  684,  818, 1020, 1020,  819,
  820,  821,  822,  822,  822,  822,  692,  684,  692, 1020,
 1020,  693,  531,  532,  533,  533,  533,  533,  529,  396,
  529, 1020, 1020,  530,  830, 1020,  831,  831,  831,  831,
  544,  406,  544, 1020, 1020,  545,  546,  547,  548,  548,
  548,  548,  544,  406,  544, 1020, 1020,  545,  834,  547,
  835,  835,  835,  835,  410,  411,  410, 1020, 1020,  412,
  311,  413,  701,  701,  701,  701, 1020, 1020, 1020,  703,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  703,  410,  411,
  410, 1020, 1020,  412,  311,  312,  701,  701,  701,  701,
  309,  193,  309, 1020, 1020,  310,  836, 1020,  837,  837,
  837,  837,  406,  406,  406, 1020, 1020,  407, 1020, 1020,
  704,  704,  704,  704, 1020, 1020, 1020,  706, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  706,  559,  411,  559, 1020,
 1020,  560,  561,  562,  563,  563,  563,  563,  559,  411,
  559, 1020, 1020,  560,  840,  562,  841,  841,  841,  841,
  570,  416,  570, 1020, 1020,  571,  572,  573,  574,  574,
  574,  574,  570,  416,  570, 1020, 1020,  571,  844,  573,
  845,  845,  845,  845,  420,  421,  420, 1020, 1020,  422,
  322,  423,  714,  714,  714,  714, 1020, 1020, 1020,  716,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  716,  420,  421,
  420, 1020, 1020,  422,  322,  323,  714,  714,  714,  714,
  320,  200,  320, 1020, 1020,  321,  846, 1020,  847,  847,
  847,  847,  416,  416,  416, 1020, 1020,  417, 1020, 1020,
  717,  717,  717,  717, 1020, 1020, 1020,  719, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  719,  585,  421,  585, 1020,
 1020,  586,  587,  588,  589,  589,  589,  589,  585,  421,
  585, 1020, 1020,  586,  850,  588,  851,  851,  851,  851,
  723,  723,  723, 1020, 1020,  724, 1020, 1020,  722,  722,
  722,  722, 1020, 1020, 1020,  726, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  726,  723,  723,  723, 1020, 1020,  724,
  852,  853,  854,  854,  854,  854,  856,  723,  856, 1020,
 1020,  857,  858,  859,  860,  860,  860,  860,  727,  728,
  727, 1020, 1020,  729,  863,  864,  865,  865,  865,  865,
  728,  728,  728, 1020, 1020,  739,  866,  867,  868,  868,
  868,  868,  870,  728,  870, 1020, 1020,  871,  872,  873,
  874,  874,  874,  874,  727,  728,  727, 1020, 1020,  729,
  598,  599,  600,  600,  600,  600,  596,  426,  596, 1020,
 1020,  597,  875, 1020,  876,  876,  876,  876,  733,  734,
  733, 1020, 1020,  735,  336,  433,  732,  732,  732,  732,
 1020, 1020, 1020,  737, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  737,  733,  734,  733, 1020, 1020,  735,  877,  878,
  879,  879,  879,  879,  734,  734,  734, 1020, 1020,  880,
  881,  882,  883,  883,  883,  883,  885,  734,  885, 1020,
 1020,  886,  887,  888,  889,  889,  889,  889,  334,  215,
  334, 1020, 1020,  335,  890,  337,  891,  891,  891,  891,
  728,  728,  728, 1020, 1020,  739, 1020, 1020,  738,  738,
  738,  738, 1020, 1020, 1020,  741, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  741,  870,  728,  870, 1020, 1020,  871,
  872,  873,  874,  874,  874,  874,  742,  734,  742, 1020,
 1020,  743,  894,  895,  896,  896,  896,  896,  885,  734,
  885, 1020, 1020,  886,  887,  888,  889,  889,  889,  889,
  742,  734,  742, 1020, 1020,  743,  613,  614,  615,  615,
  615,  615,  611,  431,  611, 1020, 1020,  612,  897, 1020,
  898,  898,  898,  898,  626,  441,  626, 1020, 1020,  627,
  628,  629,  630,  630,  630,  630,  626,  441,  626, 1020,
 1020,  627,  901,  629,  902,  902,  902,  902,  445,  446,
  445, 1020, 1020,  447,  358,  448,  751,  751,  751,  751,
 1020, 1020, 1020,  753, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  753,  445,  446,  445, 1020, 1020,  447,  358,  359,
  751,  751,  751,  751,  356,  233,  356, 1020, 1020,  357,
  903, 1020,  904,  904,  904,  904,  441,  441,  441, 1020,
 1020,  442, 1020, 1020,  754,  754,  754,  754, 1020, 1020,
 1020,  756, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  756,
  641,  446,  641, 1020, 1020,  642,  643,  644,  645,  645,
  645,  645,  641,  446,  641, 1020, 1020,  642,  907,  644,
  908,  908,  908,  908,  462,  374,  462, 1020, 1020,  463,
  464,  465,  767,  767,  767,  767,  462,  374,  462, 1020,
 1020,  463,  464,  656,  767,  767,  767,  767, 1020, 1020,
 1020,  657, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  657,
  261,  152,  261, 1020, 1020,  262,  263,  264,  769,  769,
  769,  769,  378,  379,  378, 1020, 1020,  380,  263,  381,
  769,  769,  769,  769, 1020, 1020, 1020,  382, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  382,  374,  374,  374, 1020,
 1020,  375, 1020, 1020,  771,  771,  771,  771,  477,  379,
  477, 1020, 1020,  478,  479,  480,  773,  773,  773,  773,
  477,  379,  477, 1020, 1020,  478,  479,  664,  773,  773,
  773,  773, 1020, 1020, 1020,  665, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  665,  487,  488,  383,  488,  487,  487,
  489,  490,  487,  775,  776,  776,  776,  777,  777,  777,
  777,  777,  487,  487,  487,  487,  487,  487,  487,  487,
  487,  487,  487,  667,  487,  487,  487,  777,  777,  777,
  487,  487,  487,  487,  487,  487,  487,  487,  487,  667,
  273,  386,  387,  386,  273,  273,  388,  276,  273,  778,
  779,  779,  779,  780,  780,  780,  780,  780,  273,  273,
  273,  273,  273,  273,  273,  273,  273,  273,  273,  389,
  273,  273,  273,  780,  780,  780,  273,  273,  273,  273,
  273,  273,  273,  273,  273,  389,  501,  502,  387,  502,
  501,  501,  503,  504,  501,  782,  783,  783,  783,  784,
  784,  784,  784,  784,  501,  501,  501,  501,  501,  501,
  501,  501,  501,  501,  501,  671,  501,  501,  501,  784,
  784,  784,  501,  501,  501,  501,  501,  501,  501,  501,
  501,  671,  914,  787,  787,  787,  787, 1020, 1020, 1020,
  915, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  915,  789,
  673,  789, 1020, 1020,  790,  791,  792,  793,  793,  793,
  793,  789,  673,  789, 1020, 1020,  790,  791,  792,  793,
  793,  793,  793,  673,  673,  673, 1020, 1020,  674, 1020,
 1020,  795,  795,  795,  795,  514,  391,  514, 1020, 1020,
  515,  516,  797,  798,  798,  798,  798,  514,  391,  514,
 1020, 1020,  515,  516,  517,  918,  918,  918,  918,  677,
  678,  677, 1020, 1020,  679, 1020,  919,  798,  798,  798,
  798, 1020, 1020, 1020,  920, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020,  920,  673,  673,  673, 1020, 1020,  674, 1020,
  922,  801,  801,  801,  801, 1020, 1020, 1020,  923, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  923,  803,  678,  803,
 1020, 1020,  804,  805,  806,  807,  807,  807,  807,  803,
  678,  803, 1020, 1020,  804,  805,  806,  807,  807,  807,
  807,  680,  809,  809,  809,  809, 1020, 1020, 1020,  681,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  681,  285,  170,
  285, 1020, 1020,  286,  287,  811,  812,  812,  812,  812,
  285,  170,  285, 1020, 1020,  286,  287,  288,  926,  926,
  926,  926,  683,  684,  683, 1020, 1020,  685, 1020,  927,
  812,  812,  812,  812, 1020, 1020, 1020,  928, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  928,  818,  684,  818, 1020,
 1020,  819,  820,  821,  822,  822,  822,  822,  678,  678,
  678, 1020, 1020,  689, 1020,  930,  816,  816,  816,  816,
 1020, 1020, 1020,  931, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  931,  818,  684,  818, 1020, 1020,  819,  820,  821,
  822,  822,  822,  822,  398,  824,  824,  824,  824, 1020,
 1020, 1020,  399, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
  399,  678,  678,  678, 1020, 1020,  689, 1020, 1020,  826,
  826,  826,  826,  529,  396,  529, 1020, 1020,  530,  531,
  828,  829,  829,  829,  829,  529,  396,  529, 1020, 1020,
  530,  531,  532,  934,  934,  934,  934,  692,  684,  692,
 1020, 1020,  693, 1020,  935,  829,  829,  829,  829, 1020,
 1020, 1020,  936, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
  936,  694,  831,  831,  831,  831, 1020, 1020, 1020,  695,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  695,  544,  406,
  544, 1020, 1020,  545,  546,  547,  835,  835,  835,  835,
  544,  406,  544, 1020, 1020,  545,  546,  699,  835,  835,
  835,  835, 1020, 1020, 1020,  700, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  700,  309,  193,  309, 1020, 1020,  310,
  311,  312,  837,  837,  837,  837,  410,  411,  410, 1020,
 1020,  412,  311,  413,  837,  837,  837,  837, 1020, 1020,
 1020,  414, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  414,
  406,  406,  406, 1020, 1020,  407, 1020, 1020,  839,  839,
  839,  839,  559,  411,  559, 1020, 1020,  560,  561,  562,
  841,  841,  841,  841,  559,  411,  559, 1020, 1020,  560,
  561,  707,  841,  841,  841,  841, 1020, 1020, 1020,  708,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  708,  570,  416,
  570, 1020, 1020,  571,  572,  573,  845,  845,  845,  845,
  570,  416,  570, 1020, 1020,  571,  572,  712,  845,  845,
  845,  845, 1020, 1020, 1020,  713, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  713,  320,  200,  320, 1020, 1020,  321,
  322,  323,  847,  847,  847,  847,  420,  421,  420, 1020,
 1020,  422,  322,  423,  847,  847,  847,  847, 1020, 1020,
 1020,  424, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  424,
  416,  416,  416, 1020, 1020,  417, 1020, 1020,  849,  849,
  849,  849,  585,  421,  585, 1020, 1020,  586,  587,  588,
  851,  851,  851,  851,  585,  421,  585, 1020, 1020,  586,
  587,  720,  851,  851,  851,  851, 1020, 1020, 1020,  721,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  721,  938,  854,
  854,  854,  854, 1020, 1020, 1020,  939, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020,  939,  856,  723,  856, 1020, 1020,
  857,  858,  859,  860,  860,  860,  860,  856,  723,  856,
 1020, 1020,  857,  858,  859,  860,  860,  860,  860,  723,
  723,  723, 1020, 1020,  724, 1020, 1020,  862,  862,  862,
  862,  596,  426,  596, 1020, 1020,  597,  598,  864,  865,
  865,  865,  865,  596,  426,  596, 1020, 1020,  597,  598,
  599,  942,  942,  942,  942,  727,  728,  727, 1020, 1020,
  729, 1020,  943,  865,  865,  865,  865, 1020, 1020, 1020,
  944, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  944,  723,
  723,  723, 1020, 1020,  724, 1020,  946,  868,  868,  868,
  868, 1020, 1020, 1020,  947, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020,  947,  870,  728,  870, 1020, 1020,  871,  872,
  873,  874,  874,  874,  874,  870,  728,  870, 1020, 1020,
  871,  872,  873,  874,  874,  874,  874,  730,  876,  876,
  876,  876, 1020, 1020, 1020,  731, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  731,  334,  215,  334, 1020, 1020,  335,
  336,  878,  879,  879,  879,  879,  334,  215,  334, 1020,
 1020,  335,  336,  337,  950,  950,  950,  950,  733,  734,
  733, 1020, 1020,  735, 1020,  951,  879,  879,  879,  879,
 1020, 1020, 1020,  952, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  952,  885,  734,  885, 1020, 1020,  886,  887,  888,
  889,  889,  889,  889,  728,  728,  728, 1020, 1020,  739,
 1020,  954,  883,  883,  883,  883, 1020, 1020, 1020,  955,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  955,  885,  734,
  885, 1020, 1020,  886,  887,  888,  889,  889,  889,  889,
  433,  891,  891,  891,  891, 1020, 1020, 1020,  434, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  434,  728,  728,  728,
 1020, 1020,  739, 1020, 1020,  893,  893,  893,  893,  611,
  431,  611, 1020, 1020,  612,  613,  895,  896,  896,  896,
  896,  611,  431,  611, 1020, 1020,  612,  613,  614,  958,
  958,  958,  958,  742,  734,  742, 1020, 1020,  743, 1020,
  959,  896,  896,  896,  896, 1020, 1020, 1020,  960, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  960,  744,  898,  898,
  898,  898, 1020, 1020, 1020,  745, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  745,  626,  441,  626, 1020, 1020,  627,
  628,  629,  902,  902,  902,  902,  626,  441,  626, 1020,
 1020,  627,  628,  749,  902,  902,  902,  902, 1020, 1020,
 1020,  750, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  750,
  356,  233,  356, 1020, 1020,  357,  358,  359,  904,  904,
  904,  904,  445,  446,  445, 1020, 1020,  447,  358,  448,
  904,  904,  904,  904, 1020, 1020, 1020,  449, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  449,  441,  441,  441, 1020,
 1020,  442, 1020, 1020,  906,  906,  906,  906,  641,  446,
  641, 1020, 1020,  642,  643,  644,  908,  908,  908,  908,
  641,  446,  641, 1020, 1020,  642,  643,  757,  908,  908,
  908,  908, 1020, 1020, 1020,  758, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  758,  789,  673,  789, 1020, 1020,  790,
  791,  792,  793,  793,  793,  793,  789,  673,  789, 1020,
 1020,  790,  966,  792,  967,  967,  967,  967,  677,  678,
  677, 1020, 1020,  679,  516,  680,  918,  918,  918,  918,
 1020, 1020, 1020,  920, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  920,  677,  678,  677, 1020, 1020,  679,  516,  517,
  918,  918,  918,  918,  514,  391,  514, 1020, 1020,  515,
  968, 1020,  969,  969,  969,  969,  673,  673,  673, 1020,
 1020,  674, 1020, 1020,  921,  921,  921,  921, 1020, 1020,
 1020,  923, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  923,
  803,  678,  803, 1020, 1020,  804,  805,  806,  807,  807,
  807,  807,  803,  678,  803, 1020, 1020,  804,  972,  806,
  973,  973,  973,  973,  683,  684,  683, 1020, 1020,  685,
  287,  398,  926,  926,  926,  926, 1020, 1020, 1020,  928,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020,  928,  683,  684,
  683, 1020, 1020,  685,  287,  288,  926,  926,  926,  926,
  285,  170,  285, 1020, 1020,  286,  974, 1020,  975,  975,
  975,  975,  678,  678,  678, 1020, 1020,  689, 1020, 1020,
  929,  929,  929,  929, 1020, 1020, 1020,  931, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  931,  818,  684,  818, 1020,
 1020,  819,  820,  821,  822,  822,  822,  822,  818,  684,
  818, 1020, 1020,  819,  978,  821,  979,  979,  979,  979,
  692,  684,  692, 1020, 1020,  693,  531,  694,  934,  934,
  934,  934, 1020, 1020, 1020,  936, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020,  936,  692,  684,  692, 1020, 1020,  693,
  531,  532,  934,  934,  934,  934,  529,  396,  529, 1020,
 1020,  530,  980, 1020,  981,  981,  981,  981,  514,  391,
  514, 1020, 1020,  515, 1020, 1020,  969,  969,  969,  969,
  680,  969,  969,  969,  969, 1020, 1020, 1020,  681, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  681,  285,  170,  285,
 1020, 1020,  286, 1020, 1020,  975,  975,  975,  975,  398,
  975,  975,  975,  975, 1020, 1020, 1020,  399, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  399,  529,  396,  529, 1020,
 1020,  530, 1020, 1020,  981,  981,  981,  981,  694,  981,
  981,  981,  981, 1020, 1020, 1020,  695, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020,  695,  940,  985,  985,  985,  985,
 1020, 1020, 1020,  941, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020,  941,  730,  987,  987,  987,  987, 1020, 1020, 1020,
  731, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  731,  948,
  991,  991,  991,  991, 1020, 1020, 1020,  949, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020,  949,  433,  993,  993,  993,
  993, 1020, 1020, 1020,  434, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020,  434,  956,  997,  997,  997,  997, 1020, 1020,
 1020,  957, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,  957,
  744,  999,  999,  999,  999, 1020, 1020, 1020,  745, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020,  745,   46,   46,   46,
   46,   46,   46,   46,   46,   46,   80,   80,   80,   80,
   80,   80,   80,   80,   80,  108,  108,  108,  108,  108,
  108,  108,  108,  108,  118,  118,  118,  118,  118,  118,
  118,  118,  118,  131,  131,  131,  131,  131,  131,  131,
  131,  131,  135, 1020, 1020,  135,  174, 1020, 1020,  174,
 1020,  174,  174,  174,  174,  175,  175,  175,  175,  175,
  175,  175,  175,  175,  219, 1020, 1020,  219, 1020,  219,
  219, 1020,  219,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  237,  237, 1020,  237, 1020,  237,  237,  237,
  243,  243, 1020,  243,  243,  243,  243,  243,  243,  260,
  260,  260,  260,  260,  260,  260,  260,  260,  273,  273,
  273,  273,  273,  273,  273,  273,  273,  279,  279, 1020,
 1020,  279,  279,  284,  284,  284,  284,  284,  284,  284,
  284,  284,  297,  297,  297,  297,  297,  297,  297,  297,
  297,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  333,
  333,  333,  333,  333,  333,  333,  333,  333,  219, 1020,
 1020,  219, 1020,  219,  219, 1020,  219,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  344,  344,  344,  344,
  344,  344,  344,  344,  344,  355,  355,  355,  355,  355,
  355,  355,  355,  355,  237,  237, 1020,  237, 1020,  237,
  237,  237,  243,  243, 1020,  243,  243,  243,  243,  243,
  243,  131,  131,  131,  131,  131,  131,  131,  131,  131,
  135, 1020, 1020,  135,  260,  260,  260,  260,  260,  260,
  260,  260,  260,  273,  273,  273,  273,  273,  273,  273,
  273,  273,  279,  279, 1020, 1020,  279,  279,  284,  284,
  284,  284,  284,  284,  284,  284,  284,  297,  297,  297,
  297,  297,  297,  297,  297,  297,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  333,  333,  333,  333,  333,  333,
  333,  333,  333,  344,  344,  344,  344,  344,  344,  344,
  344,  344,  355,  355,  355,  355,  355,  355,  355,  355,
  355,  461,  461,  461,  461,  461,  461,  461,  461,  461,
  260,  260,  260,  260,  260,  260,  260,  260,  260,  476,
  476,  476,  476,  476,  476,  476,  476,  476,  487,  487,
  487,  487,  487,  487,  487,  487,  487,  493,  493, 1020,
 1020,  493,  493,  273,  273,  273,  273,  273,  273,  273,
  273,  273,  501,  501,  501,  501,  501,  501,  501,  501,
  501,  513,  513,  513,  513,  513,  513,  513,  513,  513,
  284,  284,  284,  284,  284,  284,  284,  284,  284,  528,
  528,  528,  528,  528,  528,  528,  528,  528,  297,  297,
  297,  297,  297,  297,  297,  297,  297,  543,  543,  543,
  543,  543,  543,  543,  543,  543,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  558,  558,  558,  558,  558,
  558,  558,  558,  558,  569,  569,  569,  569,  569,  569,
  569,  569,  569,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  584,  584,  584,  584,  584,  584,  584,  584,
  584,  595,  595,  595,  595,  595,  595,  595,  595,  595,
  333,  333,  333,  333,  333,  333,  333,  333,  333,  610,
  610,  610,  610,  610,  610,  610,  610,  610,  344,  344,
  344,  344,  344,  344,  344,  344,  344,  625,  625,  625,
  625,  625,  625,  625,  625,  625,  355,  355,  355,  355,
  355,  355,  355,  355,  355,  640,  640,  640,  640,  640,
  640,  640,  640,  640,  131,  131,  131,  131,  131,  131,
  131,  131,  131,  135, 1020, 1020,  135,  461,  461,  461,
  461,  461,  461,  461,  461,  461,  260,  260,  260,  260,
  260,  260,  260,  260,  260,  476,  476,  476,  476,  476,
  476,  476,  476,  476,  487,  487,  487,  487,  487,  487,
  487,  487,  487,  493,  493, 1020, 1020,  493,  493,  273,
  273,  273,  273,  273,  273,  273,  273,  273,  501,  501,
  501,  501,  501,  501,  501,  501,  501,  513,  513,  513,
  513,  513,  513,  513,  513,  513,  284,  284,  284,  284,
  284,  284,  284,  284,  284,  528,  528,  528,  528,  528,
  528,  528,  528,  528,  297,  297,  297,  297,  297,  297,
  297,  297,  297,  543,  543,  543,  543,  543,  543,  543,
  543,  543,  308,  308,  308,  308,  308,  308,  308,  308,
  308,  558,  558,  558,  558,  558,  558,  558,  558,  558,
  569,  569,  569,  569,  569,  569,  569,  569,  569,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  584,  584,
  584,  584,  584,  584,  584,  584,  584,  595,  595,  595,
  595,  595,  595,  595,  595,  595,  333,  333,  333,  333,
  333,  333,  333,  333,  333,  610,  610,  610,  610,  610,
  610,  610,  610,  610,  344,  344,  344,  344,  344,  344,
  344,  344,  344,  625,  625,  625,  625,  625,  625,  625,
  625,  625,  355,  355,  355,  355,  355,  355,  355,  355,
  355,  640,  640,  640,  640,  640,  640,  640,  640,  640,
  131,  131,  131,  131,  131,  131,  131,  131,  131,  135,
 1020, 1020,  135,  461,  461,  461,  461,  461,  461,  461,
  461,  461,  260,  260,  260,  260,  260,  260,  260,  260,
  260,  476,  476,  476,  476,  476,  476,  476,  476,  476,
  487,  487,  487,  487,  487,  487,  487,  487,  487,  273,
  273,  273,  273,  273,  273,  273,  273,  273,  781,  781,
 1020, 1020,  781,  781,  501,  501,  501,  501,  501,  501,
  501,  501,  501,  788,  788,  788,  788,  788,  788,  788,
  788,  788,  513,  513,  513,  513,  513,  513,  513,  513,
  513,  802,  802,  802,  802,  802,  802,  802,  802,  802,
  284,  284,  284,  284,  284,  284,  284,  284,  284,  817,
  817,  817,  817,  817,  817,  817,  817,  817,  528,  528,
  528,  528,  528,  528,  528,  528,  528,  543,  543,  543,
  543,  543,  543,  543,  543,  543,  308,  308,  308,  308,
  308,  308,  308,  308,  308,  558,  558,  558,  558,  558,
  558,  558,  558,  558,  569,  569,  569,  569,  569,  569,
  569,  569,  569,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  584,  584,  584,  584,  584,  584,  584,  584,
  584,  855,  855,  855,  855,  855,  855,  855,  855,  855,
  595,  595,  595,  595,  595,  595,  595,  595,  595,  869,
  869,  869,  869,  869,  869,  869,  869,  869,  333,  333,
  333,  333,  333,  333,  333,  333,  333,  884,  884,  884,
  884,  884,  884,  884,  884,  884,  610,  610,  610,  610,
  610,  610,  610,  610,  610,  625,  625,  625,  625,  625,
  625,  625,  625,  625,  355,  355,  355,  355,  355,  355,
  355,  355,  355,  640,  640,  640,  640,  640,  640,  640,
  640,  640,  131,  131,  131,  131,  131,  131,  131,  131,
  131,  135, 1020, 1020,  135,  461,  461,  461,  461,  461,
  461,  461,  461,  461,  260,  260,  260,  260,  260,  260,
  260,  260,  260,  476,  476,  476,  476,  476,  476,  476,
  476,  476,  781,  781, 1020, 1020,  781,  781,  788,  788,
  788,  788,  788,  788,  788,  788,  788,  513,  513,  513,
  513,  513,  513,  513,  513,  513,  802,  802,  802,  802,
  802,  802,  802,  802,  802,  284,  284,  284,  284,  284,
  284,  284,  284,  284,  817,  817,  817,  817,  817,  817,
  817,  817,  817,  528,  528,  528,  528,  528,  528,  528,
  528,  528,  543,  543,  543,  543,  543,  543,  543,  543,
  543,  308,  308,  308,  308,  308,  308,  308,  308,  308,
  558,  558,  558,  558,  558,  558,  558,  558,  558,  569,
  569,  569,  569,  569,  569,  569,  569,  569,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  584,  584,  584,
  584,  584,  584,  584,  584,  584,  855,  855,  855,  855,
  855,  855,  855,  855,  855,  595,  595,  595,  595,  595,
  595,  595,  595,  595,  869,  869,  869,  869,  869,  869,
  869,  869,  869,  333,  333,  333,  333,  333,  333,  333,
  333,  333,  884,  884,  884,  884,  884,  884,  884,  884,
  884,  610,  610,  610,  610,  610,  610,  610,  610,  610,
  625,  625,  625,  625,  625,  625,  625,  625,  625,  355,
  355,  355,  355,  355,  355,  355,  355,  355,  640,  640,
  640,  640,  640,  640,  640,  640,  640,  131,  131,  131,
  131,  131,  131,  131,  131,  131,  135, 1020, 1020,  135,
  788,  788,  788,  788,  788,  788,  788,  788,  788,  513,
  513,  513,  513,  513,  513,  513,  513,  513,  802,  802,
  802,  802,  802,  802,  802,  802,  802,  284,  284,  284,
  284,  284,  284,  284,  284,  284,  817,  817,  817,  817,
  817,  817,  817,  817,  817,  528,  528,  528,  528,  528,
  528,  528,  528,  528, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1017, 1017, 1020, 1017, 1017, 1017, 1017,
 1017, 1017,   45, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020
};


const short int Lexer::chk[9900] =
{   0,
    0,    1,    1,    1,    0,    0,    1,    2,    2,    2,
 1150, 1119,    2,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    5,
    5,    5,   60,   60,    5,    9,    9,    9,    9,    9,
    9,   39,   73,  272,   39,    5,    5,   10,   10,   10,
   10,   10,   10,  278,    5,    6,    6,    6,   73,  272,
    6,   11,   11,   11,   11,   11,   11,  154,  492,  278,
   39,    6,    6,   12,   12,   12,   12,   12,   12, 1060,
    6,    7,    7,    7,  492,  154,    7,    7,    7,    7,
    7,    7,    7,   65,   65,   65,   65,   65,    7,   13,
   13,   13,   13,   13,   13,   14,   14,   14,   14,   14,
   14,   15,   15,   15,   15,   15,   15,   16,   16,   16,
   16,   16,   16,   17,   17,   17, 1055,   17,   17,   18,
   18,   18, 1048,   18,   18,  454,   47,   47,   47,  454,
   17,   47,   66,   66,   66,   66,   18,   19,   19,   19,
   19,   19,   19,   20,   20,   20,   20,   20,   20,   21,
   21,   21,   21,   21,   21,   22,   22,   22,   22,   22,
   22,   23,   23,   23,   23,   23,   23,   24,   24,   24,
   24,   24,   24,   25,   25,   25,   25,   25,   25,   40,
   41, 1041,   40,   41,   25,   42, 1036,   48,   42,   48,
  496,  500,   48, 1005, 1002, 1001,   25,  172,   25,   26,
   26,   26,   26,   26,   26,  506,  496,  500,   40,   41,
   26,   49,   49,   49,   42,  172,   49,  978,   51,   51,
   51,  506,   26,   51,   26,   27,   27,   27,   27,   27,
   27,   68,   68,   68,   68,   68,   27,  972,   49,   69,
   69,   69,   69,   71,   71,   71,   71,  966,   27,  963,
   27,   28,   28,   28,   28,   28,   28,   74,   74,   74,
   74,  962,   28,   75,   75,   75,   75,   76,   76,   76,
   76,  912,  910,  763,   28,  762,   28,   29,   29,   29,
   29,   29,   29,   75,   78,   78,   78,   78,   29,   77,
   77,   77,   77,   77,   84,   84,   84,   84,   84,   75,
   29,  760,   29,   30,   30,   30,   30,   30,   30,  188,
  652,   82,   82,   82,   30,   82,   82,   85,   85,   85,
   85,   87,   87,   87,   87,   87,   30,  188,   30,   31,
   31,   31,   31,   31,   31,   88,   88,   88,   88,  651,
   31,   90,   90,   90,   90,   90,   91,   91,   91,   91,
  650,  121,   31,  649,   31,   32,   32,   32,   32,   32,
   32,   93,   93,   93,   93,   93,   32,   94,   94,   94,
   94,   99,   99,   99,   99,   99,  455,  121,   32,  195,
   32,   33,   33,   33,  121,   33,   33,  100,  100,  100,
  100,  102,  102,  102,  102,  451,  371,  195,   33,  103,
  103,  103,  103,  104,  104,  104,  104,  370,  369,  368,
   33,  202,   33,   34,   34,   34,  367,   34,   34,  103,
  105,  105,  105,  105,  105,  106,  106,  106,  106,  202,
   34,  113,  113,  113,  113,  103,  112,  112,  112,  112,
  112,  366,   34,  365,   34,   35,   35,   35,   35,   35,
   35,  115,  115,  115,  115,  115,   35,  116,  116,  116,
  116,  123,  123,  123,  123,  508,  256,  255,   35,  254,
   35,   36,   36,   36,   36,   36,   36,  125,  125,  125,
  125,  508,   36,  124,  124,  124,  124,  126,  126,  126,
  253,  509,  126,  252,   36,  217,   36,   37,   37,   37,
   37,   37,   37,  124,  127,  250,  127,  509,   37,  127,
  128,  128,  128,  217,  249,  128,  129,  776,  129,  124,
   37,  129,   37,   38,   38,   38,   38,   38,   38,  777,
  130,  248,  130,  776,   38,  130,  131,  131,  131,  148,
  146,  131,  132,  132,  132,  777,   38,  132,   38,   43,
   43,   43,   43,   43,   43,  149,  149,  149,  149,  228,
   43,   44,   44,   44,   44,   44,   44,  151,  151,  151,
  151,  151,   44,   67,   67,   67,  235,  228,   67,  145,
   67,   67,   67,   67,   67,  133,  133,  133,   67,  779,
  133,  134,  134,  134,  235,  155,  134,  155,  155,  155,
  155,  156,  156,  156,  156,  779,   67,   70,   70,   70,
   70,   70,  302,  144,  134,   70,  158,  158,  158,  158,
  302,  143,  376,  158,  159,  159,  159,  159,  165,  165,
  165,  165,  142,   70,   72,   72,   72,  393,  302,   72,
  376,  158,   72,   72,   72,   72,  160,  140,  160,  160,
  160,  160,  164,  164,  164,  393,  139,  164,  167,  167,
  167,  167,   72,  169,  169,  169,  169,  169,  173,  780,
  173,  173,  173,  173,  178,  178,  178,  178,   72,   79,
   79,   79,  137,  136,   79,  780,   79,   79,   79,   79,
   79,  175,  175,  175,   79,  175,  175,  176,  176,  176,
  349,  176,  176,  180,  180,  180,  180,  111,  349,   96,
  180,   83,   79,   86,   86,   86,   86,   86,   64,  408,
  418,   86,  181,  181,  181,  181,  349,  182,  180,  182,
  182,  182,  182,  183,  183,  183,  183,  408,  418,   86,
   89,   89,   89,   63,  428,   89,  466,   89,   89,   89,
   89,   89,   62,  443,  466,   89,  185,  185,  185,  185,
  185,  189,  428,  189,  189,  189,  189,  190,  190,  190,
  190,  443,  466,   89,   92,   92,   92,   61,  662,   92,
  481,   92,   92,   92,   92,   92,   59,  675,  481,   92,
  192,  192,  192,  192,  192,  196,  662,  196,  196,  196,
  196,  197,  197,  197,  197,  675,  481,   92,   95,   95,
   95,   58,  690,   95,  548,   95,   95,   95,   95,   95,
   57,  705,  548,   95,  199,  199,  199,  199,  199,  203,
  690,  203,  203,  203,  203,  205,  205,  205,  205,  705,
  548,   95,  101,  101,  101,  101,  101,  563,   56,   55,
  101,  208,  208,  208,  208,  563,  207,  207,  207,  207,
   54,   53,  209,  207,  209,  209,  209,  209,  101,  107,
  107,  107,   45,  563,  107,    0,  107,  107,  107,  107,
  107,  207,    0,    0,  107,  210,  210,  210,  210,  212,
  212,  212,  212,  214,  214,  214,  214,  214,  223,  223,
  223,  223,  107,  110,  110,  110,    0,  110,  110,  218,
    0,  218,  218,  218,  218,  225,  225,  225,  225,  225,
  229,    0,  229,  229,  229,  229,  230,  230,  230,  230,
  718,  574,  110,    0,  110,  114,  114,  114,    0,  574,
  114,  589,  114,  114,  114,  114,  114,    0,  718,  589,
  114,  232,  232,  232,  232,  232,  236,  574,  236,  236,
  236,  236,  241,  241,  241,  241,  783,  589,  114,  117,
  117,  117,    0,    0,  117,    0,  117,  117,  117,  117,
  117,  243,  783,  243,  117,  244,  243,  244,  725,  245,
  244,  245,  630,  645,  245,  257,  257,  257,  257,  257,
  630,  645,  117,  152,  152,  152,  725,    0,  152,  152,
  152,  152,  152,  152,  152,  153,  153,  153,  630,  645,
  153,  153,  153,  153,  153,  153,  153,  162,  162,  162,
  784,    0,  162,  162,    0,  162,  162,  162,  162,  163,
  163,  163,    0,    0,  163,  163,  784,  163,  163,  163,
  163,  170,  170,  170,    0,    0,  170,  170,  170,  170,
  170,  170,  170,  171,  171,  171,    0,    0,  171,  171,
  171,  171,  171,  171,  171,  186,  186,  186,    0,    0,
  186,  186,  186,  186,  186,  186,  186,  187,  187,  187,
    0,    0,  187,  187,  187,  187,  187,  187,  187,  193,
  193,  193,    0,    0,  193,  193,  193,  193,  193,  193,
  193,  194,  194,  194,    0,    0,  194,  194,  194,  194,
  194,  194,  194,  200,  200,  200,    0,    0,  200,  200,
  200,  200,  200,  200,  200,  201,  201,  201,  740,    0,
  201,  201,  201,  201,  201,  201,  201,  206,  206,  206,
  206,  206,  246,  246,  246,  206,  740,  246,  258,  258,
  258,  258,  266,  266,  266,  266,  268,  268,  268,  268,
  755,  246,    0,  206,  213,  213,  213,    0,  793,  213,
    0,  213,  213,  213,  213,  213,  793,  922,  755,  213,
  269,  269,  269,  269,  270,  270,  270,  270,  279,  279,
  279,    0,    0,  279,  793,  922,  930,  213,  215,  215,
  215,    0,    0,  215,  215,  215,  215,  215,  215,  215,
  216,  216,  216,    0,  930,  216,  216,  216,  216,  216,
  216,  216,  220,  220,  220,    0,  220,  220,  281,  281,
  281,  281,  281,  282,  282,  282,  282,  290,  290,  290,
  290,  292,  292,  292,  292,  293,  293,  293,  293,    0,
    0,  220,    0,  220,  221,  221,  221,    0,  221,  221,
  294,  294,  294,  294,  294,  295,  295,  295,  295,  303,
  303,  303,  303,  305,  305,  305,  305,  305,  306,  306,
  306,  306,  946,  221,    0,  221,  224,  224,  224,    0,
    0,  224,    0,  224,  224,  224,  224,  224,    0,    0,
  946,  224,  314,  314,  314,  314,  316,  316,  316,  316,
  316,  317,  317,  317,  317,  325,  325,  325,  325,  224,
  226,  226,  226,    0,    0,  226,  226,  226,  226,  226,
  226,  226,  227,  227,  227,    0,    0,  227,  227,  227,
  227,  227,  227,  227,  231,  231,  231,    0,    0,  231,
    0,  231,  231,  231,  231,  231,    0,    0,    0,  231,
  327,  327,  327,  327,  328,  328,  328,  328,  330,  330,
  330,  330,  330,  331,  331,  331,  331,  231,  233,  233,
  233,    0,    0,  233,  233,  233,  233,  233,  233,  233,
  234,  234,  234,    0,    0,  234,  234,  234,  234,  234,
  234,  234,  259,  259,  259,    0,    0,  259,    0,  259,
  259,  259,  259,  259,    0,    0,    0,  259,  339,  339,
  339,  339,  341,  341,  341,  341,  341,  342,  342,  342,
  342,  350,  350,  350,  350,  259,  260,  260,  260,    0,
    0,  260,  260,  260,  260,  260,  260,  260,  261,  261,
  261,    0,    0,  261,  261,  261,  261,  261,  261,  261,
  265,  265,  265,    0,    0,  265,    0,  265,  352,  352,
  352,  352,  352,    0,    0,  265,  353,  353,  353,  353,
  361,  361,  361,  361,  373,  373,  373,  373,  373,  401,
  401,  401,  401,  265,  267,  267,  267,    0,    0,  267,
    0,    0,  267,  267,  267,  267,  271,  271,  271,    0,
    0,  271,    0,  954,  271,  271,  271,  271,  364,  364,
  364,    0,  377,  364,  377,  377,  377,  377,  385,  385,
  385,  954,    0,  385,  271,  394,  364,  394,  394,  394,
  394,  400,  400,  400,  400,    0,    0,    0,  400,    0,
  271,  273,  273,  273,    0,    0,  273,  273,    0,  273,
  273,  273,  273,  274,  274,  274,  400,    0,  274,  274,
    0,  274,  274,  274,  274,  275,  275,  275,    0,    0,
  275,  275,    0,  275,  275,  275,  275,  276,  276,  276,
    0,    0,  276,  276,    0,  276,  276,  276,  276,  277,
  277,  277,    0,    0,  277,  277,    0,  277,  277,  277,
  277,  402,    0,  402,  402,  402,  402,  409,    0,  409,
  409,  409,  409,    0,    0,    0,  419,  277,  419,  419,
  419,  419,  429,    0,  429,  429,  429,  429,  436,  436,
  436,  436,    0,  277,  283,  283,  283,    0,  807,  283,
    0,  283,  283,  283,  283,  283,  807,    0,  437,  283,
  437,  437,  437,  437,  459,  459,  459,  459,  435,  435,
  435,  435,    0,    0,  807,  435,    0,  283,  284,  284,
  284,    0,    0,  284,  284,  284,  284,  284,  284,  284,
  285,  285,  285,  435,    0,  285,  285,  285,  285,  285,
  285,  285,  289,  289,  289,    0,    0,  289,  444,  289,
  444,  444,  444,  444,  450,  450,  450,  289,    0,  450,
  458,  458,  458,  458,  458,  467,  467,  467,  467,  473,
  473,  473,  473,  473,    0,  289,  291,  291,  291,    0,
    0,  291,    0,    0,  291,  291,  291,  291,  296,  296,
  296,  296,  296,    0,    0,    0,  296,  474,  474,  474,
  474,  482,  482,  482,  482,  484,  484,  484,  484,    0,
  485,  485,  485,  485,  296,  297,  297,  297,    0,    0,
  297,  297,  297,  297,  297,  297,  297,  298,  298,  298,
  485,    0,  298,  298,  298,  298,  298,  298,  298,  304,
  304,  304,    0,    0,  304,    0,  485,  304,  304,  304,
  304,  307,  307,  307,    0,  822,  307,  860,  307,  307,
  307,  307,  307,  822,    0,  860,  307,  486,  486,  486,
  486,  493,  493,  493,  874,    0,  493,  498,  498,  498,
  498,  822,  874,  860,  307,  308,  308,  308,    0,    0,
  308,  308,  308,  308,  308,  308,  308,  309,  309,  309,
  874,    0,  309,  309,  309,  309,  309,  309,  309,  313,
  313,  313,    0,    0,  313,    0,  313,  510,  510,  510,
  510,  510,    0,    0,  313,  511,  511,  511,  511,  519,
  519,  519,  519,  525,  525,  525,  525,  525,  526,  526,
  526,  526,  313,  315,  315,  315,    0,    0,  315,    0,
    0,  315,  315,  315,  315,  318,  318,  318,    0,    0,
  318,    0,  318,  318,  318,  318,  318,    0,    0,    0,
  318,  534,  534,  534,  534,  536,  536,  536,  536,  537,
  537,  537,  537,  540,  540,  540,  540,  540,  318,  319,
  319,  319,    0,    0,  319,  319,  319,  319,  319,  319,
  319,  320,  320,  320,    0,    0,  320,  320,  320,  320,
  320,  320,  320,  324,  324,  324,    0,    0,  324,    0,
  324,  541,  541,  541,  541,    0,    0,    0,  324,  549,
  549,  549,  549,  555,  555,  555,  555,  555,  556,  556,
  556,  556,  564,  564,  564,  564,  324,  326,  326,  326,
    0,    0,  326,    0,    0,  326,  326,  326,  326,  332,
  332,  332,    0,    0,  332,    0,  332,  332,  332,  332,
  332,    0,    0,    0,  332,  566,  566,  566,  566,  566,
  567,  567,  567,  567,  575,  575,  575,  575,  582,  582,
  582,  582,  332,  333,  333,  333,    0,    0,  333,  333,
  333,  333,  333,  333,  333,  334,  334,  334,    0,    0,
  334,  334,  334,  334,  334,  334,  334,  338,  338,  338,
    0,    0,  338,    0,  338,  581,  581,  581,  581,  581,
    0,    0,  338,  590,  590,  590,  590,  592,  592,  592,
  592,  592,  593,  593,  593,  593,  601,  601,  601,  601,
  338,  340,  340,  340,    0,    0,  340,    0,    0,  340,
  340,  340,  340,  343,  343,  343,  343,  343,    0,    0,
    0,  343,  607,  607,  607,  607,  607,  608,  608,  608,
  608,  616,  616,  616,  616,  618,  618,  618,  618,  343,
  344,  344,  344,    0,    0,  344,  344,  344,  344,  344,
  344,  344,  345,  345,  345,    0,    0,  345,  345,  345,
  345,  345,  345,  345,  351,  351,  351,    0,    0,  351,
    0,    0,  351,  351,  351,  351,  354,  354,  354,    0,
    0,  354,    0,  354,  354,  354,  354,  354,    0,    0,
    0,  354,  619,  619,  619,  619,  622,  622,  622,  622,
  622,  623,  623,  623,  623,  631,  631,  631,  631,  354,
  355,  355,  355,    0,    0,  355,  355,  355,  355,  355,
  355,  355,  356,  356,  356,    0,    0,  356,  356,  356,
  356,  356,  356,  356,  360,  360,  360,    0,    0,  360,
  889,  360,  637,  637,  637,  637,  637,    0,  889,  360,
  638,  638,  638,  638,  646,  646,  646,  646,  653,  653,
  653,  653,    0,    0,    0,  653,  889,  360,  362,  362,
  362,    0,    0,  362,    0,    0,  362,  362,  362,  362,
  374,  374,  374,  653,    0,  374,  374,  374,  374,  374,
  374,  374,  375,  375,  375,    0,    0,  375,  375,  375,
  375,  375,  375,  375,  378,  378,  378,    0,    0,  378,
  378,  378,  378,  378,  378,  378,  379,  379,  379,    0,
    0,  379,  379,  379,  379,  379,  379,  379,  380,  380,
  380,    0,    0,  380,  380,  380,  380,  380,  380,  380,
  381,  381,  381,    0,    0,  381,  381,  381,  381,  381,
  381,  381,  382,  382,  382,    0,    0,  382,  382,    0,
  382,  382,  382,  382,  383,  383,  383,    0,    0,  383,
  383,    0,  383,  383,  383,  383,  384,  384,  384,    0,
    0,  384,  384,    0,  384,  384,  384,  384,  386,  386,
  386,    0,    0,  386,  386,    0,  386,  386,  386,  386,
  387,  387,  387,    0,    0,  387,  387,    0,  387,  387,
  387,  387,  388,  388,  388,    0,    0,  388,  388,    0,
  388,  388,  388,  388,  389,  389,  389,    0,    0,  389,
  389,    0,  389,  389,  389,  389,  389,  389,  389,  389,
  389,    0,    0,    0,  648,  648,  648,    0,    0,  648,
  654,  654,  654,  654,    0,    0,  389,  389,  389,  390,
  390,  390,    0,    0,  390,    0,    0,  390,  390,  390,
  390,  648,    0,  655,  390,  655,  655,  655,  655,  663,
    0,  663,  663,  663,  663,  670,  670,  670,    0,    0,
  670,    0,  390,  391,  391,  391,    0,    0,  391,  391,
  391,  391,  391,  391,  391,  392,  392,  392,    0,    0,
  392,  392,  392,  392,  392,  392,  392,  395,  395,  395,
    0,    0,  395,  395,  395,  395,  395,  395,  395,  396,
  396,  396,    0,    0,  396,  396,  396,  396,  396,  396,
  396,  397,  397,  397,    0,    0,  397,  397,  397,  397,
  397,  397,  397,  398,  398,  398,    0,    0,  398,  398,
  398,  398,  398,  398,  398,  399,  399,  399,    0,    0,
  399,  399,    0,  399,  399,  399,  399,  403,  403,  403,
    0,    0,  403,  403,  403,  403,  403,  403,  403,  404,
  404,  404,    0,    0,  404,  404,  404,  404,  404,  404,
  404,  405,  405,  405,    0,    0,  405,    0,    0,  405,
  405,  405,  405,    0,    0,  676,  405,  676,  676,  676,
  676,  686,  686,  686,  686,  686,  686,  691,    0,  691,
  691,  691,  691,    0,  405,  406,  406,  406,    0,    0,
  406,  406,  406,  406,  406,  406,  406,  407,  407,  407,
    0,    0,  407,  407,  407,  407,  407,  407,  407,  410,
  410,  410,    0,    0,  410,  410,  410,  410,  410,  410,
  410,  411,  411,  411,    0,    0,  411,  411,  411,  411,
  411,  411,  411,  412,  412,  412,    0,    0,  412,  412,
  412,  412,  412,  412,  412,  413,  413,  413,    0,    0,
  413,  413,  413,  413,  413,  413,  413,  414,  414,  414,
    0,    0,  414,  414,    0,  414,  414,  414,  414,  415,
  415,  415,  967,  967,  415,    0,    0,  415,  415,  415,
  415,  967,    0,    0,  415,  697,  697,  697,  697,  710,
  710,  710,  710,  696,  696,  696,  696,    0,    0,  967,
  696,    0,  415,  416,  416,  416,    0,    0,  416,  416,
  416,  416,  416,  416,  416,  417,  417,  417,  696,    0,
  417,  417,  417,  417,  417,  417,  417,  420,  420,  420,
    0,    0,  420,  420,  420,  420,  420,  420,  420,  421,
  421,  421,    0,    0,  421,  421,  421,  421,  421,  421,
  421,  422,  422,  422,    0,    0,  422,  422,  422,  422,
  422,  422,  422,  423,  423,  423,    0,    0,  423,  423,
  423,  423,  423,  423,  423,  424,  424,  424,    0,    0,
  424,  424,    0,  424,  424,  424,  424,  425,  425,  425,
    0,    0,  425,    0,    0,  425,  425,  425,  425,    0,
    0,  698,  425,  698,  698,  698,  698,  706,    0,  706,
  706,  706,  706,  711,    0,  711,  711,  711,  711,    0,
  425,  426,  426,  426,    0,    0,  426,  426,  426,  426,
  426,  426,  426,  427,  427,  427,    0,    0,  427,  427,
  427,  427,  427,  427,  427,  430,  430,  430,    0,    0,
  430,  430,  430,  430,  430,  430,  430,  431,  431,  431,
    0,    0,  431,  431,  431,  431,  431,  431,  431,  432,
  432,  432,    0,    0,  432,  432,  432,  432,  432,  432,
  432,  433,  433,  433,    0,    0,  433,  433,  433,  433,
  433,  433,  433,  434,  434,  434,    0,    0,  434,  434,
    0,  434,  434,  434,  434,  438,  438,  438,    0,    0,
  438,  438,  438,  438,  438,  438,  438,  439,  439,  439,
    0,    0,  439,  439,  439,  439,  439,  439,  439,  440,
  440,  440,  973,  973,  440,    0,    0,  440,  440,  440,
  440,  973,    0,  719,  440,  719,  719,  719,  719,  747,
  747,  747,  747,  709,  709,  709,  709,    0,    0,  973,
  709,    0,  440,  441,  441,  441,    0,    0,  441,  441,
  441,  441,  441,  441,  441,  442,  442,  442,  709,    0,
  442,  442,  442,  442,  442,  442,  442,  445,  445,  445,
    0,    0,  445,  445,  445,  445,  445,  445,  445,  446,
  446,  446,    0,    0,  446,  446,  446,  446,  446,  446,
  446,  447,  447,  447,    0,    0,  447,  447,  447,  447,
  447,  447,  447,  448,  448,  448,    0,    0,  448,  448,
  448,  448,  448,  448,  448,  449,  449,  449,    0,    0,
  449,  449,    0,  449,  449,  449,  449,  460,  460,  460,
  460,  460,    0,    0,  726,  460,  726,  726,  726,  726,
  736,  736,  736,  736,  736,  736,  741,    0,  741,  741,
  741,  741,    0,  460,  461,  461,  461,    0,    0,  461,
  461,  461,  461,  461,  461,  461,  462,  462,  462,    0,
    0,  462,  462,  462,  462,  462,  462,  462,  468,  468,
  468,    0,    0,  468,    0,    0,  468,  468,  468,  468,
  469,  469,  469,    0,    0,  469,  469,  469,  469,  469,
  469,  469,  470,  470,  470,    0,    0,  470,  470,  470,
  470,  470,  470,  470,  471,  471,  471,  979,  979,  471,
    0,  471,  471,  471,  471,  471,  979,    0,  748,  471,
  748,  748,  748,  748,  764,  764,  764,  764,  746,  746,
  746,  746,    0,    0,  979,  746,    0,  471,  472,  472,
  472,    0,    0,  472,  472,  472,  472,  472,  472,  472,
  475,  475,  475,  746,    0,  475,    0,  475,  475,  475,
  475,  475,    0,    0,  756,  475,  756,  756,  756,  756,
  759,  759,  759,    0,    0,  759,  765,  765,  765,  765,
  759,    0,    0,  475,  476,  476,  476,    0,    0,  476,
  476,  476,  476,  476,  476,  476,  483,  483,  483,  483,
  483,    0,    0,    0,  483,  770,  770,  770,  770,  781,
  781,  781,    0,    0,  781,  785,  785,  785,  785,  785,
    0,    0,  483,  487,  487,  487,    0,    0,  487,  487,
    0,  487,  487,  487,  487,  488,  488,  488,    0,    0,
  488,  488,    0,  488,  488,  488,  488,  489,  489,  489,
    0,    0,  489,  489,    0,  489,  489,  489,  489,  490,
  490,  490,    0,    0,  490,  490,    0,  490,  490,  490,
  490,  491,  491,  491,    0,    0,  491,  491,    0,  491,
  491,  491,  491,  786,  786,  786,  786,  794,  794,  794,
  794,  799,  799,  799,  799,  799,    0,    0,    0,  491,
  800,  800,  800,  800,  808,  808,  808,  808,  814,  814,
  814,  814,  814,    0,    0,  491,  494,  494,  494,    0,
    0,  494,  494,    0,  494,  494,  494,  494,  495,  495,
  495,    0,    0,  495,  495,    0,  495,  495,  495,  495,
  815,  815,  815,  815,  823,  823,  823,  823,  825,  825,
  825,  825,  830,  830,  830,  830,  495,  832,  832,  832,
  832,  833,  833,  833,  833,  838,  838,  838,  838,    0,
    0,    0,  495,  497,  497,  497,    0,    0,  497,  497,
    0,  497,  497,  497,  497,  499,  499,  499,    0,    0,
  499,    0,    0,  499,  499,  499,  499,  842,  842,  842,
  842,  843,  843,  843,  843,  848,  848,  848,  848,  853,
  853,  853,  853,  499,  852,  852,  852,  852,  852,  861,
  861,  861,  861,  866,  866,  866,  866,  866,    0,  499,
  501,  501,  501,    0,    0,  501,  501,    0,  501,  501,
  501,  501,  502,  502,  502,    0,    0,  502,  502,    0,
  502,  502,  502,  502,  503,  503,  503,    0,    0,  503,
  503,    0,  503,  503,  503,  503,  504,  504,  504,    0,
    0,  504,  504,    0,  504,  504,  504,  504,  505,  505,
  505,    0,    0,  505,  505,    0,  505,  505,  505,  505,
  867,  867,  867,  867,  875,  875,  875,  875,  881,  881,
  881,  881,  881,    0,    0,    0,  505,  882,  882,  882,
  882,  890,  890,  890,  890,  892,  892,  892,  892,    0,
    0,    0,  505,  507,  507,  507,  507,  507,  507,  507,
  507,  507,  897,  897,  897,  897,  899,  899,  899,  899,
  943,  943,  943,  507,    0,  943,    0,  507,  507,  507,
  900,  900,  900,  900,  905,  905,  905,  905,    0,  507,
  512,  512,  512,    0,    0,  512,    0,  512,  512,  512,
  512,  512,  909,  909,  909,  512,    0,  909,    0,  909,
  914,  914,  914,  914,  913,  913,  913,  913,    0,    0,
    0,  913,    0,  512,  513,  513,  513,    0,    0,  513,
  513,  513,  513,  513,  513,  513,  514,  514,  514,  913,
    0,  514,  514,  514,  514,  514,  514,  514,  518,  518,
  518,    0,    0,  518,  915,  518,  915,  915,  915,  915,
    0,    0,  923,  518,  923,  923,  923,  923,  931,    0,
  931,  931,  931,  931,  938,  938,  938,  938,    0,    0,
    0,  518,  520,  520,  520,    0,    0,  520,    0,    0,
  520,  520,  520,  520,  521,  521,  521,    0,    0,  521,
  521,  521,  521,  521,  521,  521,  522,  522,  522,    0,
    0,  522,  522,  522,  522,  522,  522,  522,  523,  523,
  523,    0,    0,  523,    0,  523,  523,  523,  523,  523,
    0,    0,  939,  523,  939,  939,  939,  939,  964,  964,
  964,  964,  937,  937,  937,  937,    0,    0,    0,  937,
    0,  523,  524,  524,  524,    0,    0,  524,  524,  524,
  524,  524,  524,  524,  527,  527,  527,  937,    0,  527,
    0,  527,  527,  527,  527,  527,    0,    0,  941,  527,
  941,  941,  941,  941,  942,  942,  942,  942,  942,  944,
    0,  944,  944,  944,  944,    0,    0,  527,  528,  528,
  528,    0,    0,  528,  528,  528,  528,  528,  528,  528,
  533,  533,  533,    0,    0,  533,    0,  533,  945,  945,
  945,  945,  945,    0,  947,  533,  947,  947,  947,  947,
  949,    0,  949,  949,  949,  949,  950,  950,  950,  950,
  950,    0,    0,  533,  535,  535,  535,    0,    0,  535,
    0,  535,  535,  535,  535,  535,  951,  951,  951,  535,
  952,  951,  952,  952,  952,  952,  953,  953,  953,  953,
  953,  955,    0,  955,  955,  955,  955,  535,  538,  538,
  538,    0,    0,  538,  538,  538,  538,  538,  538,  538,
  539,  539,  539,    0,    0,  539,  539,  539,  539,  539,
  539,  539,    0,    0,  957,  539,  957,  957,  957,  957,
  958,  958,  958,  958,  958,  959,  959,  959,    0,    0,
  959,    0,    0,  539,  542,  542,  542,  542,  542,    0,
    0,  960,  542,  960,  960,  960,  960,  961,  961,  961,
    0,    0,  961,    0,    0,  961,  965,  965,  965,  965,
  542,  543,  543,  543,    0,    0,  543,  543,  543,  543,
  543,  543,  543,  544,  544,  544,    0,    0,  544,  544,
  544,  544,  544,  544,  544,  550,  550,  550,    0,    0,
  550,    0,    0,  550,  550,  550,  550,  551,  551,  551,
    0,    0,  551,  551,  551,  551,  551,  551,  551,  552,
  552,  552,    0,    0,  552,  552,  552,  552,  552,  552,
  552,  553,  553,  553,    0,    0,  553,    0,  553,  553,
  553,  553,  553,    0,    0,    0,  553,  970,  970,  970,
  970,  971,  971,  971,  971,  976,  976,  976,  976,  977,
  977,  977,  977,    0,  553,  554,  554,  554,    0,    0,
  554,  554,  554,  554,  554,  554,  554,  557,  557,  557,
    0,    0,  557,    0,  557,  557,  557,  557,  557,    0,
    0,    0,  557,  982,  982,  982,  982,  983,  983,  983,
  983,  984,  984,  984,  984,  986,  986,  986,  986,    0,
  557,  558,  558,  558,    0,    0,  558,  558,  558,  558,
  558,  558,  558,  565,  565,  565,  565,  565,    0,    0,
    0,  565,  988,  988,  988,  988,  989,  989,  989,  989,
  990,  990,  990,  990,  992,  992,  992,  992,    0,  565,
  568,  568,  568,  568,  568,    0,    0,    0,  568,  994,
  994,  994,  994,  995,  995,  995,  995,  996,  996,  996,
  996,  998,  998,  998,  998,    0,  568,  569,  569,  569,
    0,    0,  569,  569,  569,  569,  569,  569,  569,  570,
  570,  570,    0,    0,  570,  570,  570,  570,  570,  570,
  570,  576,  576,  576,    0,    0,  576,    0,    0,  576,
  576,  576,  576,  577,  577,  577,    0,    0,  577,  577,
  577,  577,  577,  577,  577,  578,  578,  578,    0,    0,
  578,  578,  578,  578,  578,  578,  578,  579,  579,  579,
    0,    0,  579,    0,  579,  579,  579,  579,  579, 1000,
 1000, 1000,  579,    0, 1000, 1003, 1003, 1003,    0,    0,
 1003, 1006, 1006, 1006,    0,    0, 1006,    0,    0,    0,
  579,  580,  580,  580,    0,    0,  580,  580,  580,  580,
  580,  580,  580,  583,  583,  583,    0,    0,  583,    0,
  583,  583,  583,  583,  583,    0,    0, 1003,  583,    0,
    0,    0, 1006,    0, 1008, 1008, 1008,    0,    0, 1008,
 1009, 1009, 1009,    0,    0, 1009,  583,  584,  584,  584,
    0, 1009,  584,  584,  584,  584,  584,  584,  584,  591,
  591,  591,  591,  591, 1010, 1010, 1010,  591, 1008, 1010,
 1011, 1011, 1011,    0,    0, 1011, 1012, 1012, 1012,    0,
    0, 1012,    0,    0,    0,  591,  594,  594,  594,    0,
    0,  594,    0,  594,  594,  594,  594,  594, 1013,    0,
 1013,  594,    0, 1013, 1014, 1014, 1014,    0, 1015, 1014,
 1015,    0, 1016, 1015, 1016,    0,    0, 1016,    0,  594,
  595,  595,  595,    0,    0,  595,  595,  595,  595,  595,
  595,  595,  596,  596,  596,    0,    0,  596,  596,  596,
  596,  596,  596,  596,  600,  600,  600,    0, 1017,  600,
 1017,  600, 1018, 1017, 1018,    0, 1019, 1018, 1019,  600,
    0, 1019,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  600,  602,  602,
  602,    0,    0,  602,    0,    0,  602,  602,  602,  602,
  603,  603,  603,    0,    0,  603,  603,  603,  603,  603,
  603,  603,  604,  604,  604,    0,    0,  604,  604,  604,
  604,  604,  604,  604,  605,  605,  605,    0,    0,  605,
    0,  605,  605,  605,  605,  605,    0,    0,    0,  605,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  605,  606,  606,
  606,    0,    0,  606,  606,  606,  606,  606,  606,  606,
  609,  609,  609,    0,    0,  609,    0,  609,  609,  609,
  609,  609,    0,    0,    0,  609,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  609,  610,  610,  610,    0,    0,  610,
  610,  610,  610,  610,  610,  610,  615,  615,  615,    0,
    0,  615,    0,  615,    0,    0,    0,    0,    0,    0,
    0,  615,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  615,
  617,  617,  617,    0,    0,  617,    0,  617,  617,  617,
  617,  617,    0,    0,    0,  617,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  617,  620,  620,  620,    0,    0,  620,
  620,  620,  620,  620,  620,  620,  621,  621,  621,    0,
    0,  621,  621,  621,  621,  621,  621,  621,    0,    0,
    0,  621,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  621,
  624,  624,  624,  624,  624,    0,    0,    0,  624,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  624,  625,  625,  625,
    0,    0,  625,  625,  625,  625,  625,  625,  625,  626,
  626,  626,    0,    0,  626,  626,  626,  626,  626,  626,
  626,  632,  632,  632,    0,    0,  632,    0,    0,  632,
  632,  632,  632,  633,  633,  633,    0,    0,  633,  633,
  633,  633,  633,  633,  633,  634,  634,  634,    0,    0,
  634,  634,  634,  634,  634,  634,  634,  635,  635,  635,
    0,    0,  635,    0,  635,  635,  635,  635,  635,    0,
    0,    0,  635,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  635,  636,  636,  636,    0,    0,  636,  636,  636,  636,
  636,  636,  636,  639,  639,  639,    0,    0,  639,    0,
  639,  639,  639,  639,  639,    0,    0,    0,  639,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  639,  640,  640,  640,
    0,    0,  640,  640,  640,  640,  640,  640,  640,  647,
  647,  647,  647,  647,    0,    0,    0,  647,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  647,  656,  656,  656,    0,
    0,  656,  656,  656,  656,  656,  656,  656,  657,  657,
  657,    0,    0,  657,  657,  657,  657,  657,  657,  657,
  658,  658,  658,    0,    0,  658,  658,  658,  658,  658,
  658,  658,    0,    0,    0,  658,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  658,  659,  659,  659,    0,    0,  659,
  659,  659,  659,  659,  659,  659,  660,  660,  660,    0,
    0,  660,  660,    0,  660,  660,  660,  660,  661,  661,
  661,    0,    0,  661,    0,    0,  661,  661,  661,  661,
    0,    0,    0,  661,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  661,  664,  664,  664,    0,    0,  664,  664,  664,
  664,  664,  664,  664,  665,  665,  665,    0,    0,  665,
  665,  665,  665,  665,  665,  665,  667,  667,  667,    0,
    0,  667,  667,    0,  667,  667,  667,  667,  667,  667,
  667,  667,  667,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  667,  667,
  667,  668,  668,  668,    0,    0,  668,  668,    0,  668,
  668,  668,  668,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  668,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  668,  669,  669,  669,    0,
    0,  669,  669,    0,  669,  669,  669,  669,  669,  669,
  669,  669,  669,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  669,  669,
  669,  671,  671,  671,    0,    0,  671,  671,    0,  671,
  671,  671,  671,  671,  671,  671,  671,  671,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  671,  671,  671,  672,  672,  672,    0,
    0,  672,    0,    0,  672,  672,  672,  672,    0,    0,
    0,  672,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  672,
  673,  673,  673,    0,    0,  673,  673,  673,  673,  673,
  673,  673,  674,  674,  674,    0,    0,  674,  674,  674,
  674,  674,  674,  674,  677,  677,  677,    0,    0,  677,
  677,  677,  677,  677,  677,  677,  678,  678,  678,    0,
    0,  678,  678,  678,  678,  678,  678,  678,  679,  679,
  679,    0,    0,  679,  679,  679,  679,  679,  679,  679,
  680,  680,  680,    0,    0,  680,  680,  680,  680,  680,
  680,  680,  681,  681,  681,    0,    0,  681,  681,    0,
  681,  681,  681,  681,  682,  682,  682,    0,    0,  682,
  682,  682,  682,  682,  682,  682,    0,    0,    0,  682,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  682,  683,  683,
  683,    0,    0,  683,  683,  683,  683,  683,  683,  683,
  684,  684,  684,    0,    0,  684,  684,  684,  684,  684,
  684,  684,  685,  685,  685,    0,    0,  685,  685,  685,
  685,  685,  685,  685,  687,  687,  687,    0,    0,  687,
  687,  687,  687,  687,  687,  687,  688,  688,  688,    0,
    0,  688,    0,    0,  688,  688,  688,  688,    0,    0,
    0,  688,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  688,
  689,  689,  689,    0,    0,  689,  689,  689,  689,  689,
  689,  689,  692,  692,  692,    0,    0,  692,  692,  692,
  692,  692,  692,  692,  693,  693,  693,    0,    0,  693,
  693,  693,  693,  693,  693,  693,  694,  694,  694,    0,
    0,  694,  694,  694,  694,  694,  694,  694,  695,  695,
  695,    0,    0,  695,  695,    0,  695,  695,  695,  695,
  699,  699,  699,    0,    0,  699,  699,  699,  699,  699,
  699,  699,  700,  700,  700,    0,    0,  700,  700,  700,
  700,  700,  700,  700,  701,  701,  701,    0,    0,  701,
  701,  701,  701,  701,  701,  701,    0,    0,    0,  701,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  701,  702,  702,
  702,    0,    0,  702,  702,  702,  702,  702,  702,  702,
  703,  703,  703,    0,    0,  703,  703,    0,  703,  703,
  703,  703,  704,  704,  704,    0,    0,  704,    0,    0,
  704,  704,  704,  704,    0,    0,    0,  704,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  704,  707,  707,  707,    0,
    0,  707,  707,  707,  707,  707,  707,  707,  708,  708,
  708,    0,    0,  708,  708,  708,  708,  708,  708,  708,
  712,  712,  712,    0,    0,  712,  712,  712,  712,  712,
  712,  712,  713,  713,  713,    0,    0,  713,  713,  713,
  713,  713,  713,  713,  714,  714,  714,    0,    0,  714,
  714,  714,  714,  714,  714,  714,    0,    0,    0,  714,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  714,  715,  715,
  715,    0,    0,  715,  715,  715,  715,  715,  715,  715,
  716,  716,  716,    0,    0,  716,  716,    0,  716,  716,
  716,  716,  717,  717,  717,    0,    0,  717,    0,    0,
  717,  717,  717,  717,    0,    0,    0,  717,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  717,  720,  720,  720,    0,
    0,  720,  720,  720,  720,  720,  720,  720,  721,  721,
  721,    0,    0,  721,  721,  721,  721,  721,  721,  721,
  722,  722,  722,    0,    0,  722,    0,    0,  722,  722,
  722,  722,    0,    0,    0,  722,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  722,  723,  723,  723,    0,    0,  723,
  723,  723,  723,  723,  723,  723,  724,  724,  724,    0,
    0,  724,  724,  724,  724,  724,  724,  724,  727,  727,
  727,    0,    0,  727,  727,  727,  727,  727,  727,  727,
  728,  728,  728,    0,    0,  728,  728,  728,  728,  728,
  728,  728,  729,  729,  729,    0,    0,  729,  729,  729,
  729,  729,  729,  729,  730,  730,  730,    0,    0,  730,
  730,  730,  730,  730,  730,  730,  731,  731,  731,    0,
    0,  731,  731,    0,  731,  731,  731,  731,  732,  732,
  732,    0,    0,  732,  732,  732,  732,  732,  732,  732,
    0,    0,    0,  732,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  732,  733,  733,  733,    0,    0,  733,  733,  733,
  733,  733,  733,  733,  734,  734,  734,    0,    0,  734,
  734,  734,  734,  734,  734,  734,  735,  735,  735,    0,
    0,  735,  735,  735,  735,  735,  735,  735,  737,  737,
  737,    0,    0,  737,  737,  737,  737,  737,  737,  737,
  738,  738,  738,    0,    0,  738,    0,    0,  738,  738,
  738,  738,    0,    0,    0,  738,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  738,  739,  739,  739,    0,    0,  739,
  739,  739,  739,  739,  739,  739,  742,  742,  742,    0,
    0,  742,  742,  742,  742,  742,  742,  742,  743,  743,
  743,    0,    0,  743,  743,  743,  743,  743,  743,  743,
  744,  744,  744,    0,    0,  744,  744,  744,  744,  744,
  744,  744,  745,  745,  745,    0,    0,  745,  745,    0,
  745,  745,  745,  745,  749,  749,  749,    0,    0,  749,
  749,  749,  749,  749,  749,  749,  750,  750,  750,    0,
    0,  750,  750,  750,  750,  750,  750,  750,  751,  751,
  751,    0,    0,  751,  751,  751,  751,  751,  751,  751,
    0,    0,    0,  751,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  751,  752,  752,  752,    0,    0,  752,  752,  752,
  752,  752,  752,  752,  753,  753,  753,    0,    0,  753,
  753,    0,  753,  753,  753,  753,  754,  754,  754,    0,
    0,  754,    0,    0,  754,  754,  754,  754,    0,    0,
    0,  754,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  754,
  757,  757,  757,    0,    0,  757,  757,  757,  757,  757,
  757,  757,  758,  758,  758,    0,    0,  758,  758,  758,
  758,  758,  758,  758,  766,  766,  766,    0,    0,  766,
  766,  766,  766,  766,  766,  766,  767,  767,  767,    0,
    0,  767,  767,  767,  767,  767,  767,  767,    0,    0,
    0,  767,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  767,
  768,  768,  768,    0,    0,  768,  768,  768,  768,  768,
  768,  768,  769,  769,  769,    0,    0,  769,  769,  769,
  769,  769,  769,  769,    0,    0,    0,  769,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  769,  771,  771,  771,    0,
    0,  771,    0,    0,  771,  771,  771,  771,  772,  772,
  772,    0,    0,  772,  772,  772,  772,  772,  772,  772,
  773,  773,  773,    0,    0,  773,  773,  773,  773,  773,
  773,  773,    0,    0,    0,  773,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  773,  775,  775,  775,  775,  775,  775,
  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
  775,  775,  775,  775,  775,  775,  775,  775,  775,  775,
  778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
  778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
  778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
  778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
  778,  778,  778,  778,  778,  778,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  787,  787,  787,  787,  787,    0,    0,    0,
  787,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  787,  788,
  788,  788,    0,    0,  788,  788,  788,  788,  788,  788,
  788,  789,  789,  789,    0,    0,  789,  789,  789,  789,
  789,  789,  789,  795,  795,  795,    0,    0,  795,    0,
    0,  795,  795,  795,  795,  796,  796,  796,    0,    0,
  796,  796,  796,  796,  796,  796,  796,  797,  797,  797,
    0,    0,  797,  797,  797,  797,  797,  797,  797,  798,
  798,  798,    0,    0,  798,    0,  798,  798,  798,  798,
  798,    0,    0,    0,  798,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  798,  801,  801,  801,    0,    0,  801,    0,
  801,  801,  801,  801,  801,    0,    0,    0,  801,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  801,  802,  802,  802,
    0,    0,  802,  802,  802,  802,  802,  802,  802,  803,
  803,  803,    0,    0,  803,  803,  803,  803,  803,  803,
  803,  809,  809,  809,  809,  809,    0,    0,    0,  809,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  809,  810,  810,
  810,    0,    0,  810,  810,  810,  810,  810,  810,  810,
  811,  811,  811,    0,    0,  811,  811,  811,  811,  811,
  811,  811,  812,  812,  812,    0,    0,  812,    0,  812,
  812,  812,  812,  812,    0,    0,    0,  812,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  812,  813,  813,  813,    0,
    0,  813,  813,  813,  813,  813,  813,  813,  816,  816,
  816,    0,    0,  816,    0,  816,  816,  816,  816,  816,
    0,    0,    0,  816,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  816,  817,  817,  817,    0,    0,  817,  817,  817,
  817,  817,  817,  817,  824,  824,  824,  824,  824,    0,
    0,    0,  824,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  824,  826,  826,  826,    0,    0,  826,    0,    0,  826,
  826,  826,  826,  827,  827,  827,    0,    0,  827,  827,
  827,  827,  827,  827,  827,  828,  828,  828,    0,    0,
  828,  828,  828,  828,  828,  828,  828,  829,  829,  829,
    0,    0,  829,    0,  829,  829,  829,  829,  829,    0,
    0,    0,  829,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  829,  831,  831,  831,  831,  831,    0,    0,    0,  831,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  831,  834,  834,
  834,    0,    0,  834,  834,  834,  834,  834,  834,  834,
  835,  835,  835,    0,    0,  835,  835,  835,  835,  835,
  835,  835,    0,    0,    0,  835,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  835,  836,  836,  836,    0,    0,  836,
  836,  836,  836,  836,  836,  836,  837,  837,  837,    0,
    0,  837,  837,  837,  837,  837,  837,  837,    0,    0,
    0,  837,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  837,
  839,  839,  839,    0,    0,  839,    0,    0,  839,  839,
  839,  839,  840,  840,  840,    0,    0,  840,  840,  840,
  840,  840,  840,  840,  841,  841,  841,    0,    0,  841,
  841,  841,  841,  841,  841,  841,    0,    0,    0,  841,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  841,  844,  844,
  844,    0,    0,  844,  844,  844,  844,  844,  844,  844,
  845,  845,  845,    0,    0,  845,  845,  845,  845,  845,
  845,  845,    0,    0,    0,  845,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  845,  846,  846,  846,    0,    0,  846,
  846,  846,  846,  846,  846,  846,  847,  847,  847,    0,
    0,  847,  847,  847,  847,  847,  847,  847,    0,    0,
    0,  847,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  847,
  849,  849,  849,    0,    0,  849,    0,    0,  849,  849,
  849,  849,  850,  850,  850,    0,    0,  850,  850,  850,
  850,  850,  850,  850,  851,  851,  851,    0,    0,  851,
  851,  851,  851,  851,  851,  851,    0,    0,    0,  851,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  851,  854,  854,
  854,  854,  854,    0,    0,    0,  854,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  854,  855,  855,  855,    0,    0,
  855,  855,  855,  855,  855,  855,  855,  856,  856,  856,
    0,    0,  856,  856,  856,  856,  856,  856,  856,  862,
  862,  862,    0,    0,  862,    0,    0,  862,  862,  862,
  862,  863,  863,  863,    0,    0,  863,  863,  863,  863,
  863,  863,  863,  864,  864,  864,    0,    0,  864,  864,
  864,  864,  864,  864,  864,  865,  865,  865,    0,    0,
  865,    0,  865,  865,  865,  865,  865,    0,    0,    0,
  865,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  865,  868,
  868,  868,    0,    0,  868,    0,  868,  868,  868,  868,
  868,    0,    0,    0,  868,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  868,  869,  869,  869,    0,    0,  869,  869,
  869,  869,  869,  869,  869,  870,  870,  870,    0,    0,
  870,  870,  870,  870,  870,  870,  870,  876,  876,  876,
  876,  876,    0,    0,    0,  876,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  876,  877,  877,  877,    0,    0,  877,
  877,  877,  877,  877,  877,  877,  878,  878,  878,    0,
    0,  878,  878,  878,  878,  878,  878,  878,  879,  879,
  879,    0,    0,  879,    0,  879,  879,  879,  879,  879,
    0,    0,    0,  879,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  879,  880,  880,  880,    0,    0,  880,  880,  880,
  880,  880,  880,  880,  883,  883,  883,    0,    0,  883,
    0,  883,  883,  883,  883,  883,    0,    0,    0,  883,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  883,  884,  884,
  884,    0,    0,  884,  884,  884,  884,  884,  884,  884,
  891,  891,  891,  891,  891,    0,    0,    0,  891,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  891,  893,  893,  893,
    0,    0,  893,    0,    0,  893,  893,  893,  893,  894,
  894,  894,    0,    0,  894,  894,  894,  894,  894,  894,
  894,  895,  895,  895,    0,    0,  895,  895,  895,  895,
  895,  895,  895,  896,  896,  896,    0,    0,  896,    0,
  896,  896,  896,  896,  896,    0,    0,    0,  896,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  896,  898,  898,  898,
  898,  898,    0,    0,    0,  898,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  898,  901,  901,  901,    0,    0,  901,
  901,  901,  901,  901,  901,  901,  902,  902,  902,    0,
    0,  902,  902,  902,  902,  902,  902,  902,    0,    0,
    0,  902,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  902,
  903,  903,  903,    0,    0,  903,  903,  903,  903,  903,
  903,  903,  904,  904,  904,    0,    0,  904,  904,  904,
  904,  904,  904,  904,    0,    0,    0,  904,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  904,  906,  906,  906,    0,
    0,  906,    0,    0,  906,  906,  906,  906,  907,  907,
  907,    0,    0,  907,  907,  907,  907,  907,  907,  907,
  908,  908,  908,    0,    0,  908,  908,  908,  908,  908,
  908,  908,    0,    0,    0,  908,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  908,  916,  916,  916,    0,    0,  916,
  916,  916,  916,  916,  916,  916,  917,  917,  917,    0,
    0,  917,  917,  917,  917,  917,  917,  917,  918,  918,
  918,    0,    0,  918,  918,  918,  918,  918,  918,  918,
    0,    0,    0,  918,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  918,  919,  919,  919,    0,    0,  919,  919,  919,
  919,  919,  919,  919,  920,  920,  920,    0,    0,  920,
  920,    0,  920,  920,  920,  920,  921,  921,  921,    0,
    0,  921,    0,    0,  921,  921,  921,  921,    0,    0,
    0,  921,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  921,
  924,  924,  924,    0,    0,  924,  924,  924,  924,  924,
  924,  924,  925,  925,  925,    0,    0,  925,  925,  925,
  925,  925,  925,  925,  926,  926,  926,    0,    0,  926,
  926,  926,  926,  926,  926,  926,    0,    0,    0,  926,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  926,  927,  927,
  927,    0,    0,  927,  927,  927,  927,  927,  927,  927,
  928,  928,  928,    0,    0,  928,  928,    0,  928,  928,
  928,  928,  929,  929,  929,    0,    0,  929,    0,    0,
  929,  929,  929,  929,    0,    0,    0,  929,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  929,  932,  932,  932,    0,
    0,  932,  932,  932,  932,  932,  932,  932,  933,  933,
  933,    0,    0,  933,  933,  933,  933,  933,  933,  933,
  934,  934,  934,    0,    0,  934,  934,  934,  934,  934,
  934,  934,    0,    0,    0,  934,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  934,  935,  935,  935,    0,    0,  935,
  935,  935,  935,  935,  935,  935,  936,  936,  936,    0,
    0,  936,  936,    0,  936,  936,  936,  936,  968,  968,
  968,    0,    0,  968,    0,    0,  968,  968,  968,  968,
  969,  969,  969,  969,  969,    0,    0,    0,  969,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  969,  974,  974,  974,
    0,    0,  974,    0,    0,  974,  974,  974,  974,  975,
  975,  975,  975,  975,    0,    0,    0,  975,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  975,  980,  980,  980,    0,
    0,  980,    0,    0,  980,  980,  980,  980,  981,  981,
  981,  981,  981,    0,    0,    0,  981,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  981,  985,  985,  985,  985,  985,
    0,    0,    0,  985,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  985,  987,  987,  987,  987,  987,    0,    0,    0,
  987,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  987,  991,
  991,  991,  991,  991,    0,    0,    0,  991,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  991,  993,  993,  993,  993,
  993,    0,    0,    0,  993,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  993,  997,  997,  997,  997,  997,    0,    0,
    0,  997,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  997,
  999,  999,  999,  999,  999,    0,    0,    0,  999,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  999, 1021, 1021, 1021,
 1021, 1021, 1021, 1021, 1021, 1021, 1022, 1022, 1022, 1022,
 1022, 1022, 1022, 1022, 1022, 1023, 1023, 1023, 1023, 1023,
 1023, 1023, 1023, 1023, 1024, 1024, 1024, 1024, 1024, 1024,
 1024, 1024, 1024, 1025, 1025, 1025, 1025, 1025, 1025, 1025,
 1025, 1025, 1026,    0,    0, 1026, 1027,    0,    0, 1027,
    0, 1027, 1027, 1027, 1027, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1029,    0,    0, 1029,    0, 1029,
 1029,    0, 1029, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
 1030, 1030, 1031, 1031,    0, 1031,    0, 1031, 1031, 1031,
 1032, 1032,    0, 1032, 1032, 1032, 1032, 1032, 1032, 1033,
 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1034, 1034,
 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1035, 1035,    0,
    0, 1035, 1035, 1037, 1037, 1037, 1037, 1037, 1037, 1037,
 1037, 1037, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
 1038, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039,
 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1042,
 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1043,    0,
    0, 1043,    0, 1043, 1043,    0, 1043, 1044, 1044, 1044,
 1044, 1044, 1044, 1044, 1044, 1044, 1045, 1045, 1045, 1045,
 1045, 1045, 1045, 1045, 1045, 1046, 1046, 1046, 1046, 1046,
 1046, 1046, 1046, 1046, 1047, 1047,    0, 1047,    0, 1047,
 1047, 1047, 1049, 1049,    0, 1049, 1049, 1049, 1049, 1049,
 1049, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050, 1050,
 1051,    0,    0, 1051, 1052, 1052, 1052, 1052, 1052, 1052,
 1052, 1052, 1052, 1053, 1053, 1053, 1053, 1053, 1053, 1053,
 1053, 1053, 1054, 1054,    0,    0, 1054, 1054, 1056, 1056,
 1056, 1056, 1056, 1056, 1056, 1056, 1056, 1057, 1057, 1057,
 1057, 1057, 1057, 1057, 1057, 1057, 1058, 1058, 1058, 1058,
 1058, 1058, 1058, 1058, 1058, 1059, 1059, 1059, 1059, 1059,
 1059, 1059, 1059, 1059, 1061, 1061, 1061, 1061, 1061, 1061,
 1061, 1061, 1061, 1062, 1062, 1062, 1062, 1062, 1062, 1062,
 1062, 1062, 1063, 1063, 1063, 1063, 1063, 1063, 1063, 1063,
 1063, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064, 1064,
 1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 1065, 1066,
 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1066, 1067, 1067,
 1067, 1067, 1067, 1067, 1067, 1067, 1067, 1068, 1068,    0,
    0, 1068, 1068, 1069, 1069, 1069, 1069, 1069, 1069, 1069,
 1069, 1069, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
 1070, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1072, 1073,
 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1074, 1074,
 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1075, 1075, 1075,
 1075, 1075, 1075, 1075, 1075, 1075, 1076, 1076, 1076, 1076,
 1076, 1076, 1076, 1076, 1076, 1077, 1077, 1077, 1077, 1077,
 1077, 1077, 1077, 1077, 1078, 1078, 1078, 1078, 1078, 1078,
 1078, 1078, 1078, 1079, 1079, 1079, 1079, 1079, 1079, 1079,
 1079, 1079, 1080, 1080, 1080, 1080, 1080, 1080, 1080, 1080,
 1080, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1084, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1085, 1085, 1085,
 1085, 1085, 1085, 1085, 1085, 1085, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1089,    0,    0, 1089, 1090, 1090, 1090,
 1090, 1090, 1090, 1090, 1090, 1090, 1091, 1091, 1091, 1091,
 1091, 1091, 1091, 1091, 1091, 1092, 1092, 1092, 1092, 1092,
 1092, 1092, 1092, 1092, 1093, 1093, 1093, 1093, 1093, 1093,
 1093, 1093, 1093, 1094, 1094,    0,    0, 1094, 1094, 1095,
 1095, 1095, 1095, 1095, 1095, 1095, 1095, 1095, 1096, 1096,
 1096, 1096, 1096, 1096, 1096, 1096, 1096, 1097, 1097, 1097,
 1097, 1097, 1097, 1097, 1097, 1097, 1098, 1098, 1098, 1098,
 1098, 1098, 1098, 1098, 1098, 1099, 1099, 1099, 1099, 1099,
 1099, 1099, 1099, 1099, 1100, 1100, 1100, 1100, 1100, 1100,
 1100, 1100, 1100, 1101, 1101, 1101, 1101, 1101, 1101, 1101,
 1101, 1101, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
 1102, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1105,
 1105, 1105, 1105, 1105, 1105, 1105, 1105, 1105, 1106, 1106,
 1106, 1106, 1106, 1106, 1106, 1106, 1106, 1107, 1107, 1107,
 1107, 1107, 1107, 1107, 1107, 1107, 1108, 1108, 1108, 1108,
 1108, 1108, 1108, 1108, 1108, 1109, 1109, 1109, 1109, 1109,
 1109, 1109, 1109, 1109, 1110, 1110, 1110, 1110, 1110, 1110,
 1110, 1110, 1110, 1111, 1111, 1111, 1111, 1111, 1111, 1111,
 1111, 1111, 1112, 1112, 1112, 1112, 1112, 1112, 1112, 1112,
 1112, 1113, 1113, 1113, 1113, 1113, 1113, 1113, 1113, 1113,
 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1114, 1115,
    0,    0, 1115, 1116, 1116, 1116, 1116, 1116, 1116, 1116,
 1116, 1116, 1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117,
 1117, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118, 1118,
 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1120, 1121,
 1121, 1121, 1121, 1121, 1121, 1121, 1121, 1121, 1122, 1122,
    0,    0, 1122, 1122, 1123, 1123, 1123, 1123, 1123, 1123,
 1123, 1123, 1123, 1124, 1124, 1124, 1124, 1124, 1124, 1124,
 1124, 1124, 1125, 1125, 1125, 1125, 1125, 1125, 1125, 1125,
 1125, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126, 1126,
 1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127, 1127, 1128,
 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1128, 1129, 1129,
 1129, 1129, 1129, 1129, 1129, 1129, 1129, 1130, 1130, 1130,
 1130, 1130, 1130, 1130, 1130, 1130, 1131, 1131, 1131, 1131,
 1131, 1131, 1131, 1131, 1131, 1132, 1132, 1132, 1132, 1132,
 1132, 1132, 1132, 1132, 1133, 1133, 1133, 1133, 1133, 1133,
 1133, 1133, 1133, 1134, 1134, 1134, 1134, 1134, 1134, 1134,
 1134, 1134, 1135, 1135, 1135, 1135, 1135, 1135, 1135, 1135,
 1135, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136, 1136,
 1137, 1137, 1137, 1137, 1137, 1137, 1137, 1137, 1137, 1138,
 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1138, 1139, 1139,
 1139, 1139, 1139, 1139, 1139, 1139, 1139, 1140, 1140, 1140,
 1140, 1140, 1140, 1140, 1140, 1140, 1141, 1141, 1141, 1141,
 1141, 1141, 1141, 1141, 1141, 1142, 1142, 1142, 1142, 1142,
 1142, 1142, 1142, 1142, 1143, 1143, 1143, 1143, 1143, 1143,
 1143, 1143, 1143, 1144, 1144, 1144, 1144, 1144, 1144, 1144,
 1144, 1144, 1145, 1145, 1145, 1145, 1145, 1145, 1145, 1145,
 1145, 1146,    0,    0, 1146, 1147, 1147, 1147, 1147, 1147,
 1147, 1147, 1147, 1147, 1148, 1148, 1148, 1148, 1148, 1148,
 1148, 1148, 1148, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
 1149, 1149, 1151, 1151,    0,    0, 1151, 1151, 1152, 1152,
 1152, 1152, 1152, 1152, 1152, 1152, 1152, 1153, 1153, 1153,
 1153, 1153, 1153, 1153, 1153, 1153, 1154, 1154, 1154, 1154,
 1154, 1154, 1154, 1154, 1154, 1155, 1155, 1155, 1155, 1155,
 1155, 1155, 1155, 1155, 1156, 1156, 1156, 1156, 1156, 1156,
 1156, 1156, 1156, 1157, 1157, 1157, 1157, 1157, 1157, 1157,
 1157, 1157, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158,
 1158, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159,
 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1160, 1161,
 1161, 1161, 1161, 1161, 1161, 1161, 1161, 1161, 1162, 1162,
 1162, 1162, 1162, 1162, 1162, 1162, 1162, 1163, 1163, 1163,
 1163, 1163, 1163, 1163, 1163, 1163, 1164, 1164, 1164, 1164,
 1164, 1164, 1164, 1164, 1164, 1165, 1165, 1165, 1165, 1165,
 1165, 1165, 1165, 1165, 1166, 1166, 1166, 1166, 1166, 1166,
 1166, 1166, 1166, 1167, 1167, 1167, 1167, 1167, 1167, 1167,
 1167, 1167, 1168, 1168, 1168, 1168, 1168, 1168, 1168, 1168,
 1168, 1169, 1169, 1169, 1169, 1169, 1169, 1169, 1169, 1169,
 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1170, 1171,
 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1171, 1172, 1172,
 1172, 1172, 1172, 1172, 1172, 1172, 1172, 1173, 1173, 1173,
 1173, 1173, 1173, 1173, 1173, 1173, 1174,    0,    0, 1174,
 1175, 1175, 1175, 1175, 1175, 1175, 1175, 1175, 1175, 1176,
 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1177, 1177,
 1177, 1177, 1177, 1177, 1177, 1177, 1177, 1178, 1178, 1178,
 1178, 1178, 1178, 1178, 1178, 1178, 1179, 1179, 1179, 1179,
 1179, 1179, 1179, 1179, 1179, 1180, 1180, 1180, 1180, 1180,
 1180, 1180, 1180, 1180, 1181, 1181, 1181, 1181, 1181, 1181,
 1181, 1181, 1181, 1182, 1182,    0, 1182, 1182, 1182, 1182,
 1182, 1182, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020,
 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020, 1020
};



int Lexer::input()
{
  int c;

  *c_buf_p = hold_char;

  if ( *c_buf_p == END_OF_BUFFER_CHAR )
  {
    if ( c_buf_p < &current_buffer->ch_buf[n_chars] )
      *c_buf_p = '\0';
    else
    {
      int offset = (int)(c_buf_p - text);
      ++c_buf_p;

      switch ( get_next_buffer() )
      {
      case EOB_ACT_LAST_MATCH:
        restart();
      case EOB_ACT_END_OF_FILE:
      {
        if ( wrap() )
          return EOF;

        if ( ! did_buffer_switch_on_eof )
          restart();
        return input();
      }

      case EOB_ACT_CONTINUE_SCAN:
        c_buf_p = text + offset;
        break;
      }
    }
  }

  c = *(unsigned char *) c_buf_p;
  *c_buf_p = '\0';
  hold_char = *++c_buf_p;

  return c;
}


void Lexer::less( int n, CHAR *bp, CHAR *cp )
{
  for (;;)
  {
    *cp = hold_char;
    c_buf_p = cp = bp + n - MORE_ADJ;
    DO_BEFORE_ACTION( bp, cp );
  }
}

void Lexer::DO_BEFORE_ACTION( CHAR *bp, CHAR *cp )
{
  text = bp;
  leng = (int) (cp - bp);
  hold_char = *cp;
  *cp = '\0';
  c_buf_p = cp;
}

int Lexer::lex( LvalStruct &lval )
{
  int current_state;
  CHAR *cp = (char *)0;
  CHAR *bp = (char *)0;
  int act;





/* Switch into a new start state if the parser */
/* just told us that we've read a field name */
/* and should expect a field value (or IS) */
  if (expectToken != 0) {
    /*
     * Annoying.  This big switch is necessary because
     * LEX wants to assign particular numbers to start
     * tokens, and YACC wants to define all the tokens
     * used, too.  Sigh.
     */
    switch(expectToken) {
    case VP_SF_BOOL:     BEGIN(SFB);   break;
    case VP_SF_COLOR:    BEGIN(SFC);   break;
    case VP_SF_FLOAT:    BEGIN(SFF);   break;
    case VP_SF_IMAGE:    BEGIN(SFIMG); break;
    case VP_SF_INT32:    BEGIN(SFI);   break;
    case VP_SF_ROTATION: BEGIN(SFR);   break;
    case VP_SF_STRING:   BEGIN(SFS);   break;
    case VP_SF_TIME:     BEGIN(SFT);   break;
    case VP_SF_VEC2F:    BEGIN(SFV2);  break;
    case VP_SF_VEC3F:    BEGIN(SFV3);  break;
    case VP_MF_COLOR:    BEGIN(MFC);   break;
    case VP_MF_FLOAT:    BEGIN(MFF);   break;
    case VP_MF_INT32:    BEGIN(MFI);   break;
    case VP_MF_ROTATION: BEGIN(MFR);   break;
    case VP_MF_STRING:   BEGIN(MFS);   break;
    case VP_MF_VEC2F:    BEGIN(MFV2);  break;
    case VP_MF_VEC3F:    BEGIN(MFV3);  break;

      /* SFNode and MFNode are special.  Here the lexer just returns */
      /* "marker tokens" so the parser knows what type of field is */
      /* being parsed; unlike the other fields, parsing of SFNode/MFNode */
      /* field happens in the parser. */
    case VP_MF_NODE: expectToken = 0; return VP_MF_NODE;
    case VP_SF_NODE: expectToken = 0; return VP_SF_NODE;

    default:
        DIE();
        break;
    }
  }


 /* This is more complicated than they really need to be because */
 /* I was ambitious and made the whitespace-matching rule aggressive */


  if ( init )
  {
    init = 0;

    if ( ! start )
      start = 1;

    if ( ! current_buffer )
      current_buffer =
        create_buffer( BUF_SIZE );

    load_buffer_state();
  }

  for(;;)
  {
    cp = c_buf_p;


    *cp = hold_char;


    bp = cp;

    current_state = start;
match:
    do
    {
      UCHAR c = ec[(int unsigned)(UCHAR)*cp];
      if ( accept[current_state] )
        {
        last_accepting_state = current_state;
        last_accepting_cpos = cp;
        }
      while ( chk[base[current_state] + c] != current_state )
        {
        current_state = (int) def[current_state];
        if ( current_state >= CONSTANT1 )
                c = meta[(unsigned int) c];
        }
      current_state = nxt[base[current_state] + (unsigned int) c];
      ++cp;
    }
    while ( base[current_state] != CONSTANT2 );

find_action:
    act = accept[current_state];
    if ( act == 0 )
    {
      cp = last_accepting_cpos;
      current_state = last_accepting_state;
      act = accept[current_state];
    }

    text = bp;
    leng = (int) (cp - bp);
    hold_char = *cp;
    *cp = '\0';
    c_buf_p = cp;

do_action:

    switch ( act )
{
      case 0:

      *cp = hold_char;
      cp = last_accepting_cpos;
      current_state = last_accepting_state;
      goto find_action;

case 1:

{
  BEGIN(NODE); _lineno = 2; }
  break;
/* The lexer is in the NODE state when parsing nodes, either */
/* top-level nodes in the .wrl file, in a prototype implementation, */
/* or when parsing the contents of SFNode or MFNode fields. */
case 2:

{ return VP_PROTO; }
  break;
case 3:

{ return VP_EXTERNPROTO; }
  break;
case 4:

{ return VP_DEF; }
  break;
case 5:

{ return VP_USE; }
  break;
case 6:

{ return VP_TO; }
  break;
case 7:

{ return VP_IS; }
  break;
case 8:

{ return VP_ROUTE; }
  break;
case 9:

{ return VP_SFN_0; }
  break;
case 10:

{ return VP_EVENTIN; }
  break;
case 11:

{ return VP_EVENTOUT; }
  break;
case 12:

{ return VP_FIELD; }
  break;
case 13:

{ return VP_EXPOSEDFIELD; }
  break;
/* Legal identifiers. */
case 14:

{
  lval.type = LvalStruct::STRING;
  lval._string = text;
  return VP_IDENTIFIER;
 }
  break;
/* All fields may have an IS declaration: */
case 15:

{

  BEGIN(NODE);
  expectToken = 0;
  less(0, bp, cp );
}
  break;
case 16:

{

  BEGIN(NODE);
  expectToken = 0;
  less(0, bp, cp ); /* put back the IS */
}
  break;
/* beginning of vector */
/* All MF field types other than MFNode are completely parsed here */
/* in the lexer, and one token is returned to the parser.  They all */
/* share the same rules for open and closing brackets: */
case 17:

{

  if (parsing_mf)
  { error("Double ["); }
  parsing_mf = true;
  lval._intv.clear();
  lval._floatv.clear();
  lval._stringv.clear();

  switch (expectToken) {

  case VP_MF_COLOR:
    lval.type = LvalStruct::FLOATV3;
    break;
  case VP_MF_FLOAT:
    lval.type = LvalStruct::FLOATV;
    break;
  case VP_MF_INT32:
    lval.type = LvalStruct::INTV;
    break;
  case VP_MF_ROTATION:
    lval.type = LvalStruct::FLOATV4;
    break;
  case VP_MF_STRING:
    lval.type = LvalStruct::STRINGV;
    break;
  case VP_MF_VEC2F:
    lval.type = LvalStruct::FLOATV2;
    break;
  case VP_MF_VEC3F:
    lval.type = LvalStruct::FLOATV3;
    break;
  }
}
  break;
/* end of vector */
case 18:

{

  if (! parsing_mf) { error("Unmatched ]"); }
  int fieldType = expectToken;

  switch (fieldType) {

  case VP_MF_COLOR:
    break;
  case VP_MF_FLOAT:
    break;
  case VP_MF_INT32:
    /* append an extra -1 if missing */
    if (expectCoordIndex && lval._intv.size() > 0 &&
        -1 != lval._intv[lval._intv.size()-1])
    { lval._intv.push_back(-1); }
    break;
  case VP_MF_ROTATION:
    break;
  case VP_MF_STRING:
    break;
  case VP_MF_VEC2F:
    break;
  case VP_MF_VEC3F:
    break;
  }
  BEGIN(NODE);
  parsing_mf = 0;
  expectToken = 0;

  return fieldType;
}
  break;
/* bool: false */
case 19:

{
  BEGIN(NODE); expectToken = 0;
  lval.type = LvalStruct::BOOL;
  lval._bool = false;
  return VP_SF_BOOL;
}
  break;
/* bool: true */
case 20:

{
  BEGIN(NODE); expectToken = 0;
  lval.type = LvalStruct::BOOL;
  lval._bool = true;
  return VP_SF_BOOL; }
  break;
/* int */
case 21:

{
  BEGIN(NODE); expectToken = 0;
  lval.type = LvalStruct::INT;
  lval._int = (int)strtol(text,0,0);
  return VP_SF_INT32;
}
  break;
/* int */
case 22:

{
  int i = (int)strtol(text,0,0);
  if (parsing_mf)
  {
    lval._intv.push_back(i);
  }
  else
  {
    /* No open bracket means a single value: */
    lval.type = LvalStruct::INT;
    lval._int = i;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_INT32;
  }
}
  break;
/* Real */
case 23:

{

 lval.type = LvalStruct::FLOAT;
 lval._float = atof(text);
 BEGIN(NODE); expectToken = 0;
 return VP_SF_FLOAT;
}
  break;
/* Real */
case 24:

{

  Real f = atof(text);
  if (parsing_mf)
  {
    lval._floatv.push_back(f);
  }
  else {
    /* No open bracket means a single value: */
    lval.type = LvalStruct::FLOAT;
    lval._float = f;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_FLOAT;
  }
}
  break;
/* Real std::pair */
case 25:

{

  Real x = 0.0, y = 0.0;
  int n = 0;
  char *s = &text[0];

  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &y);
  lval.type = LvalStruct::FLOATP2;
  lval._floatp[0] = x;
  lval._floatp[1] = y;
  BEGIN(NODE); expectToken = 0;
  return VP_SF_VEC2F;
}
  break;
/* Real std::pair */
case 26:

{

  Real x = 0.0, y = 0.0;
  int n = 0;
  char *s = &text[0];

  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &y);
  if (parsing_mf) {
    lval._floatv.push_back(x);
    lval._floatv.push_back(y);
  } else {
    lval.type = LvalStruct::FLOATP2;
    lval._floatp[0] = x;
    lval._floatp[1] = y;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_VEC2F;
  }
}
  break;
/* Real triple */
case 27:

{

  Real x = 0.0, y = 0.0, z = 0.0;
  int n = 0;
  char *s = &text[0];

  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &y, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &z);

  lval.type = LvalStruct::FLOATP3;
  lval._floatp[0] = x;
  lval._floatp[1] = y;
  lval._floatp[2] = z;

  BEGIN(NODE); expectToken = 0;
  return VP_SF_VEC3F;
  }
  break;
case 28:

{

  Real x = 0.0, y = 0.0, z = 0.0;
  int n = 0;
  char *s = &text[0];

  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &y, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &z);

  if (parsing_mf) {
    lval._floatv.push_back(x);
    lval._floatv.push_back(y);
    lval._floatv.push_back(z);
  } else {
    lval.type = LvalStruct::FLOATP3;
    lval._floatp[0] = x;
    lval._floatp[1] = y;
    lval._floatp[2] = z;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_VEC3F;
  }
}
  break;
/* Real quad */
case 29:

{

  Real x = 0.0, y = 0.0, z = 0.0, r = 0.0;
  int n = 0;
  char *s = &text[0];
  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &y, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &z, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &r);
  lval.type = LvalStruct::FLOATP4;
  lval._floatp[0] = x;
  lval._floatp[1] = y;
  lval._floatp[2] = z;
  lval._floatp[3] = r;
  BEGIN(NODE); expectToken = 0;
  return VP_SF_ROTATION;
}
  break;
/* Real quad */
case 30:

{

  Real x = 0.0, y = 0.0, z = 0.0, r = 0.0;
  int n = 0;
  char *s = &text[0];
  sscanf(s, format2, &x, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &y, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &z, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &r);

  if (parsing_mf) {
    lval._floatv.push_back(x);
    lval._floatv.push_back(y);
    lval._floatv.push_back(z);
    lval._floatv.push_back(r);
  } else {
    lval.type = LvalStruct::FLOATP4;
    lval._floatp[0] = x;
    lval._floatp[1] = y;
    lval._floatp[2] = z;
    lval._floatp[3] = r;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_ROTATION;
  }
}
  break;
/* Real triple */
case 31:

{

  Real r = 0.0, g = 0.0, b = 0.0;
  int n = 0;
  char *s = &text[0];
  sscanf(s, format2, &r, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &g, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &b);

  lval.type = LvalStruct::FLOATP3;
  lval._floatp[0] = r;
  lval._floatp[1] = g;
  lval._floatp[2] = b;
  BEGIN(NODE); expectToken = 0;
  return VP_SF_COLOR;
  }
  break;
/* Real triple */
case 32:

{

  Real r = 0.0, g = 0.0, b = 0.0;
  int n = 0;
  char *s = &text[0];
  sscanf(s, format2, &r, &n);
  s = skip_ws(s+n);
  sscanf(s, format2, &g, &n);
  s = skip_ws(s+n);
  sscanf(s, format, &b);

  if (parsing_mf) {

    lval._floatv.push_back(r);
    lval._floatv.push_back(g);
    lval._floatv.push_back(b);
  } else {

  lval.type = LvalStruct::FLOATP3;
    lval._floatp[0] = r;
    lval._floatp[1] = g;
    lval._floatp[2] = b;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_COLOR;
  }
}
  break;
/* Real */
case 33:

{

  lval.type = LvalStruct::FLOAT;
  lval._float = atof(text);
  BEGIN(NODE); expectToken = 0;
  return VP_SF_TIME;
}
  break;
/* start of SFString */
case 34:

{
  lval.type = LvalStruct::STRING;
  tmpString.erase();
  BEGIN(IN_SFS);
}
  break;
/* start of MFString */
case 35:

{
  lval.type = LvalStruct::STRINGV;
  tmpString.erase();
  BEGIN(IN_MFS);
}
  break;
/* Anything besides open-quote (or whitespace) is an error: */
case 36:

{
  error("SFString missing open-quote");
  BEGIN(NODE); expectToken = 0;
  return VP_SF_STRING;
}
  break;
/* Expect open-quote, open-bracket, or whitespace: */
case 37:

{

  error("MFString missing open-quote");
  BEGIN(NODE); expectToken = 0;
  return VP_MF_STRING;
}
  break;
/* Backslashed-quotes and backslashed-backslashes: */
case 38:

{
  tmpString += "\"";
}
  break;
/* */
case 39:

{
  tmpString += "\\";
}
  break;
/* */
case 40:

{
  tmpString += "\\n";
}
  break;
/* Newline characters: */
case 41:

{
  tmpString += "\n";
  ++_lineno;
}
  break;
/* Eat anything besides quotes, backslashed (escaped) chars and newlines. */
case 42:

{
  tmpString.append( text, leng );
}
  break;
/* end of base::String, marked by \"  */
case 43:

{
  lval.type = LvalStruct::STRING;
  lval._string = tmpString;
  BEGIN(NODE); expectToken = 0;
  return VP_SF_STRING;
}
  break;
/* end of base::String, marked by \"  */
case 44:

{

  if (parsing_mf) {
    lval._stringv.push_back(tmpString);
    BEGIN(MFS);
  } else {
    lval._string = tmpString;
    BEGIN(NODE); expectToken = 0;
    return VP_MF_STRING;
  }
}
  break;
/* SFImage: width height numComponents then width*height integers: */
case 45:

{
}
  break;
case 46:

{
}
  break;
/* Whitespace rules apply to all start states except inside strings: */

case 47:

;
  break;
/* This is also whitespace, but we'll keep track of line number */
/* to report in errors: */
case 48:

{
    ++_lineno; }
  break;

/* This catch-all rule catches anything not covered by any of */
/* the above: */
case 49:

{
  return text[0];
}
  break;
case 50:
;
  break;

case (END_OF_BUFFER + INITIAL + 1):
case (END_OF_BUFFER + NODE + 1):
case (END_OF_BUFFER + SFB + 1):
case (END_OF_BUFFER + SFC + 1):
case (END_OF_BUFFER + SFF + 1):
case (END_OF_BUFFER + SFIMG + 1):
case (END_OF_BUFFER + SFI + 1):
case (END_OF_BUFFER + SFR + 1):
case (END_OF_BUFFER + SFS + 1):
case (END_OF_BUFFER + SFT + 1):
case (END_OF_BUFFER + SFV2 + 1):
case (END_OF_BUFFER + SFV3 + 1):
case (END_OF_BUFFER + MFC + 1):
case (END_OF_BUFFER + MFF + 1):
case (END_OF_BUFFER + MFI + 1):
case (END_OF_BUFFER + MFR + 1):
case (END_OF_BUFFER + MFS + 1):
case (END_OF_BUFFER + MFV2 + 1):
case (END_OF_BUFFER + MFV3 + 1):
case (END_OF_BUFFER + IN_SFS + 1):
case (END_OF_BUFFER + IN_MFS + 1):
case (END_OF_BUFFER + IN_SFIMG + 1):
	return 0;

  case END_OF_BUFFER:
  {

    int amount_of_matched_text = (int) (cp - text) - 1;

    *cp = hold_char;

    if ( current_buffer->buffer_status == BUFFER_NEW )
    {

      n_chars = current_buffer->n_chars;
      current_buffer->buffer_status = BUFFER_NORMAL;
    }


    if ( c_buf_p <= &current_buffer->ch_buf[n_chars] )
    {
      int next_state;

      c_buf_p = text + amount_of_matched_text;

      current_state = get_previous_state();



      next_state = try_NUL_trans( current_state );

      bp = text + MORE_ADJ;

      if ( next_state )
        {

        cp = ++c_buf_p;
        current_state = next_state;
        goto match;
        }

      else
        {
        cp = c_buf_p;
        goto find_action;
        }
    }

    else switch ( get_next_buffer() )
    {
      case EOB_ACT_END_OF_FILE:
        {
        did_buffer_switch_on_eof = 0;

        if ( wrap() )
                {

                c_buf_p = text + MORE_ADJ;

                act = STATE_EOF(START());
                goto do_action;
                }

        else
                {
                if ( ! did_buffer_switch_on_eof )
                        restart();
                }
        break;
        }

      case EOB_ACT_CONTINUE_SCAN:
        c_buf_p =
                text + amount_of_matched_text;

        current_state = get_previous_state();

        cp = c_buf_p;
        bp = text + MORE_ADJ;
        goto match;

      case EOB_ACT_LAST_MATCH:
        c_buf_p =
        &current_buffer->ch_buf[n_chars];

        current_state = get_previous_state();

        cp = c_buf_p;
        bp = text + MORE_ADJ;
        goto find_action;
    }
    break;
  }

  default:
    fatal_error(
      "flex internal error: no action found" );
}
  }
}

int Lexer::get_next_buffer()
{
  CHAR *dest = current_buffer->ch_buf;
  CHAR *source = text;
  int number_to_move, i;
  int ret_val;

  if ( c_buf_p > &current_buffer->ch_buf[n_chars + 1] )
    fatal_error(
    "flex internal error: end of buffer missed" );

  if ( current_buffer->fill_buffer == 0 )
  {
    if ( c_buf_p - text - MORE_ADJ == 1 )
    {

      return EOB_ACT_END_OF_FILE;
    }

    else
    {

      return EOB_ACT_LAST_MATCH;
    }
  }

  number_to_move = (int) (c_buf_p - text) - 1;

  for ( i = 0; i < number_to_move; ++i )
    *(dest++) = *(source++);

  if ( current_buffer->buffer_status == BUFFER_EOF_PENDING )

    current_buffer->n_chars = n_chars = 0;

  else
  {
    int num_to_read =
      (int)(current_buffer->buf_size - number_to_move - 1);

    while ( num_to_read <= 0 )
    {
      BufferState * b = current_buffer;

      int c_buf_p_offset =
        (int) (c_buf_p - b->ch_buf);

      if ( b->is_our_buffer )
        {
        int new_size = (int)(b->buf_size * 2);

        if ( new_size <= 0 )
                b->buf_size += b->buf_size / 8;
        else
                b->buf_size *= 2;

        b->ch_buf = (CHAR *)
                flex_realloc( (void *) b->ch_buf,
                                 b->buf_size + 2 );
        }
      else

        b->ch_buf = 0;

      if ( ! b->ch_buf )
        fatal_error(
        "flex internal error: scanner input buffer overflow" );

      c_buf_p = &b->ch_buf[c_buf_p_offset];

      num_to_read = (int)(current_buffer->buf_size -
                        number_to_move - 1);
    }

    if ( num_to_read > READ_BUF_SIZE )
      num_to_read = READ_BUF_SIZE;


    input( (&current_buffer->ch_buf[number_to_move]),
      n_chars, num_to_read );

    current_buffer->n_chars = n_chars;
  }

  if ( n_chars == 0 )
  {
    if ( number_to_move == MORE_ADJ )
    {
      ret_val = EOB_ACT_END_OF_FILE;
      restart();
    }

    else
    {
      ret_val = EOB_ACT_LAST_MATCH;
      current_buffer->buffer_status =
        BUFFER_EOF_PENDING;
    }
  }

  else
    ret_val = EOB_ACT_CONTINUE_SCAN;

  n_chars += number_to_move;
  current_buffer->ch_buf[n_chars] = END_OF_BUFFER_CHAR;
  current_buffer->ch_buf[n_chars + 1] = END_OF_BUFFER_CHAR;

  text = &current_buffer->ch_buf[0];

  return ret_val;
}

int Lexer::get_previous_state()
{
  int current_state;
  CHAR *cp;

  current_state = start;

  for ( cp = text + MORE_ADJ; cp < c_buf_p; ++cp )
  {
    UCHAR c = (*cp ? ec[(int unsigned)(UCHAR)*cp] : 1);
    if ( accept[current_state] )
    {
      last_accepting_state = current_state;
      last_accepting_cpos = cp;
    }
    while ( chk[base[current_state] + c] != current_state )
    {
      current_state = (int) def[current_state];
      if ( current_state >= CONSTANT1 )
        c = meta[(unsigned int) c];
    }
    current_state = nxt[base[current_state] + (unsigned int) c];
  }

  return current_state;
}

int Lexer::try_NUL_trans( int current_state )
{
  int is_jam;
  CHAR *cp = c_buf_p;

  UCHAR c = 1;
  if ( accept[current_state] )
  {
    last_accepting_state = current_state;
    last_accepting_cpos = cp;
  }
  while ( chk[base[current_state] + c] != current_state )
  {
    current_state = (int) def[current_state];
    if ( current_state >= CONSTANT1 )
      c = meta[(unsigned int) c];
  }
  current_state = nxt[base[current_state] + (unsigned int) c];
  is_jam = ( current_state == CONSTANT1 - 1 );

  return is_jam ? 0 : current_state;
}

void Lexer::unput( int c, CHAR *bp )
{
  CHAR *cp = c_buf_p;

  *cp = hold_char;

  if ( cp < current_buffer->ch_buf + 2 )
  {

    size_t number_to_move = n_chars + 2;
    CHAR *dest = &current_buffer->ch_buf[
                current_buffer->buf_size + 2];
    CHAR *source =
        &current_buffer->ch_buf[number_to_move];

    while ( source > current_buffer->ch_buf )
      *--dest = *--source;

    cp += (int) (dest - source);
    bp += (int) (dest - source);
    current_buffer->n_chars =
      n_chars = current_buffer->buf_size;

    if ( cp < current_buffer->ch_buf + 2 )
      fatal_error( "flex internal error: push-back overflow" );
  }

  *--cp = (CHAR) c;

  text = bp;
  hold_char = *cp;
  c_buf_p = cp;
}

void Lexer::restart()
{
  if ( ! current_buffer )
    current_buffer = create_buffer( BUF_SIZE );

  init_buffer( current_buffer );
  load_buffer_state();
}

void Lexer::switch_to_buffer( BufferState * new_buffer )
{
  if ( current_buffer == new_buffer )
    return;

  if ( current_buffer )
  {

    *c_buf_p = hold_char;
    current_buffer->buf_pos = c_buf_p;
    current_buffer->n_chars = n_chars;
  }

  current_buffer = new_buffer;
  load_buffer_state();


  did_buffer_switch_on_eof = 1;
}

void Lexer::load_buffer_state()
{
  n_chars = current_buffer->n_chars;
  text = c_buf_p = current_buffer->buf_pos;
  hold_char = *c_buf_p;
}

Lexer::BufferState *Lexer::create_buffer( int size )
{
  BufferState *b;

  b = (BufferState *) flex_alloc( sizeof( BufferState ) );
  if ( ! b )
    fatal_error( "flex internal error: out of memory" );

  b->buf_size = size;


  b->ch_buf = (CHAR *) flex_alloc( b->buf_size + 2 );
  if ( ! b->ch_buf )
    fatal_error( "flex internal error: out of memory" );

  b->is_our_buffer = 1;

  init_buffer( b );

  return b;
}

void Lexer::delete_buffer( BufferState * b )
{
  if ( ! b )
    return;

  if ( b == current_buffer )
  {
    current_buffer = (BufferState *)0;
  }

  if ( b->is_our_buffer )
  {
    flex_free( (void *) b->ch_buf );
  }

  flex_free( (void *) b );
}

void Lexer::init_buffer( BufferState * b )
{
  flush_buffer( b );

  b->fill_buffer = 1;
  b->is_interactive = 0;
}

void Lexer::flush_buffer( BufferState * b )
{
  if ( ! b )
    return;

  b->n_chars = 0;

  b->ch_buf[0] = END_OF_BUFFER_CHAR;
  b->ch_buf[1] = END_OF_BUFFER_CHAR;

  b->buf_pos = &b->ch_buf[0];

  b->at_bol = 1;
  b->buffer_status = BUFFER_NEW;

  if ( b == current_buffer )
    load_buffer_state();
}

Lexer::BufferState *Lexer::scan_buffer( CHAR *base, size_t size )
{
  BufferState * b;

  if ( size < 2 ||
       base[size-2] != END_OF_BUFFER_CHAR ||
       base[size-1] != END_OF_BUFFER_CHAR )

    return 0;

  b = (BufferState *) flex_alloc( sizeof( BufferState ) );
  if ( ! b )
    fatal_error( "flex internal error: out of memory" );

  b->buf_size = size - 2;
  b->buf_pos = b->ch_buf = base;
  b->is_our_buffer = 0;
  b->n_chars = b->buf_size;
  b->is_interactive = 0;
  b->at_bol = 1;
  b->fill_buffer = 0;
  b->buffer_status = BUFFER_NEW;

  switch_to_buffer( b );

  return b;
}

Lexer::BufferState *Lexer::scan_string( const CHAR *str )
{
  int len;
  for ( len = 0; str[len]; ++len )
    ;

  return scan_bytes( str, len );
}

Lexer::BufferState *Lexer::scan_bytes( const CHAR *bytes, int len )
{
  BufferState * b;
  CHAR *buf;
  size_t n;
  int i;


  n = len + 2;
  buf = (CHAR *) flex_alloc( n );
  if ( ! buf )
    fatal_error( "flex internal error: out of memory" );

  for ( i = 0; i < len; ++i )
    buf[i] = bytes[i];

  buf[len] = buf[len+1] = END_OF_BUFFER_CHAR;

  b = scan_buffer( buf, n );
  if ( ! b )
    fatal_error( "flex internal error: bad buffer" );


  b->is_our_buffer = 1;

  return b;
}

void Lexer::push_state( int new_state )
{
  if ( start_stack_ptr >= start_stack_depth )
  {
    size_t new_size;

    start_stack_depth += START_STACK_INCR;
    new_size = start_stack_depth * sizeof( int );

    if ( ! start_stack )
      start_stack = (int *) flex_alloc( new_size );

    else
      start_stack = (int *) flex_realloc(
                (void *) start_stack, new_size );

    if ( ! start_stack )
      fatal_error(
      "flex internal error: out of memory expanding start-condition stack" );
  }

  start_stack[start_stack_ptr++] = START();

  BEGIN(new_state);
}

void Lexer::pop_state()
{
  if ( --start_stack_ptr < 0 )
    fatal_error( "flex internal error: start-condition stack underflow" );

  BEGIN(start_stack[start_stack_ptr]);
}

int Lexer::top_state()
{
  return start_stack[start_stack_ptr - 1];
}

void Lexer::fatal_error( const CHAR msg[] )
{
  std::cerr << msg << std::endl;
  throw 1;
}

void *Lexer::flex_alloc( size_t size )
{
  return (void *) malloc( size );
}

void *Lexer::flex_realloc( void *ptr, size_t size )
{
  return (void *) realloc( (UCHAR *) ptr, size );
}

void Lexer::flex_free( void *ptr )
{
  free( ptr );
}

int Lexer::wrap()
{
  return 1;
}

} // namespace vrml

#if defined(__sgi) && !defined(__GNUG__)
#pragma set woff 1110
#endif
